/* ---------------------------------------------------------------- *
 * CALCLIB.H -- Encabezado para usar las funciones de CALCLIB       *
 * Pedro Salazar J. - Modificado   12 Feb   1990                002 *
 * Ricardo Ortega O.- Modificado   15 Jul   1991                005 *
 * Wagner V. Lucero N. Modificado  16 Aug   2002                    *
 * ---------------------------------------------------------------- */

#ifndef _C_CALC_H_
#define _C_CALC_H_

typedef short SINT;
typedef char  SSBYTE;
typedef char  STRING;

typedef short CALC_MNUM; /* Define numero de precision multiple  */
#define CALC_MXDIGITS    32  /* Numero total de digitos (valor fijo) */
#define CALC_SGN          0  /* Posicion donde se guarda el signo    */
#define CALC_SGNNEG      -1  /* Para indicar que es numero negativo  */
#define CALC_SGNPOS       0  /* Para indicar que es numero positivo  */
#define CALC_MXELEMD4     ((CALC_MXDIGITS/4) + 1) // Nmero total de elementos enteros
                                                   //agrupados de cuatro = CALC_MXDIGITS/4 +1 por el signo

SINT    calc_set_precision      (SINT, SINT);
SINT    calc_set_decimal_point  (SSBYTE);
int     calc_do    (CALC_MNUM *, SINT, CALC_MNUM *);
int     calc_mul   (CALC_MNUM *, CALC_MNUM *);
int     calc_muli  (int Vi,      CALC_MNUM *Vn);
int     calc_div   (CALC_MNUM *, CALC_MNUM *);
int     calc_add   (CALC_MNUM *, CALC_MNUM *);
int     calc_sub   (CALC_MNUM *, CALC_MNUM *);
void    calc_mtom  (CALC_MNUM *, CALC_MNUM *);
void    calc_com   (CALC_MNUM *);
void    calc_zer   (CALC_MNUM *);
SINT    calc_not_zero     (CALC_MNUM *Vm);
SINT    calc_with_decimals(CALC_MNUM *Vm, int n_dec);
SINT    calc_cmp   (CALC_MNUM *, CALC_MNUM *);
SINT    calc_truncate (CALC_MNUM *Vm, int n_dec);
#define DO_NOT_PAD_ZEROES false
#define PAD_WITH_ZEROES   true
void    calc_redondear     (CALC_MNUM *Vm, short n_dec, int poner_ceros_despues = PAD_WITH_ZEROES);
const STRING * calc_stom   (const STRING *, CALC_MNUM *);
void     calc_mtos   (CALC_MNUM *, STRING *, SINT,SINT, int = 0, int =0);
const STRING * calc_chkstr (const STRING **, SINT *, SINT *, SINT *);

#endif
/* ---------------------------------------------------------------- */
