#ifndef __DAPILOG_H__
#define __DAPILOG_H__

#define DATE_SIZE  8
#define HOUR_SIZE  6

#define MAX_LOG_TYPES  3
#define LOG_PERSISTENT 0
#define LOG_HIGH_PRIO  1
#define LOG_LOW_PRIO   2

void          LOG_Update_Last_Proc_Message    (const char *data_ptr, int was_registered);
int           LOG_Load_Record                 (char *buf, int *len, unsigned int record_number);
void          LOG_Register_Record             (const char *data_ptr);
int           LOG_Is_Processed_Record         (void *header_ptr, char *extra_data);
unsigned long LOG_Get_Last_Processed_Message  (int ds_count, int log_type, char *date, unsigned long *number);
void          LOG_Put_Msg                     (const char     *text, 
                                               const char     *msg_content, 
                                               int             msg_content_len, 
                                               const char     *source_target = NULL,
                                               int             rle_decompressed_msg_len = 0,  // by default compress the incoming message.
                                               char           *extra_data    = NULL);
void          LOG_Put_General_Info            (FILE *log_fp);
void          LOG_Text                        (char *text_format, ...);
int           LOG_Decompress                  (char *log_file_name);
int           LOG_Set_Source_Messages         (char *input_log_filename, char *start_hd, char *end_hd);
int           LOG_DS_Files_Init               (int  ds_count);

#ifdef _ARRM_H_
UNIX_PTR  LOG_Process           (void *ptr);
void      LOG_Init              (char *log_filename, char *dir_name);
void      LOG_Msg_Init          (void);
void      LOG_End               (void);
UNIX_PTR  LOG_Do_Testing        (void *ptr);
#endif

#endif //__DAPILOG_H__
