//////////////////////////////////////////////////////////////////////////////
// dmedefs.h
//
// Definitions for dme application.
//////////////////////////////////////////////////////////////////////////////

#ifndef __DMEDEFS_H__
#define __DMEDEFS_H__

#define DFN_NO_ERROR_FLAG                  ""

#define DFN_FLAG_NORMAL_ORDER              ""
#define DFN_FLAG_REFERENCE_ORDER           "R"
#define DFN_FLAG_REFERENCE_ORDER_CHAR      'R'
#define DFN_FLAG_INDICATIVE_ORDER          "i"
#define DFN_FLAG_INDICATIVE_ORDER_CHAR     'i'
#define DFN_FLAG_DEFERRED_ORDER            "D"
#define DFN_FLAG_DEFERRED_ORDER_CHAR       'D'
#define DFN_FLAG_INDICTFIX_ORDER           "F"
#define DFN_FLAG_INDICTFIX_ORDER_CHAR      'F'

#define INDICATIVE_FIXING_STRING           "IndicativeFixing"

#define DFN_FLAG_DETECTED_NOT_FEASIBLE     "B"
#define DFN_FLAG_TAKED                     "T"
#define DFN_FLAG_ERASED_BY_MINIMUM_AMOUNT  "m"
#define DFN_FLAG_TIMED_EXPIRED             "t"
#define DFN_FLAG_OUT_OF_SPOT_RANGE         "o"
#define DFN_FLAG_ERASED_MULTIPLE_WITHDRAW  "j"
#define DFN_FLAG_WAS_TRADED                "H"
#define DFN_FLAG_EMPTY                     ""
#define DFN_FLAG_ADHERIDA                  "A"

// Flags for field BANDERA_RETIRAR_POSTURA_TRANS_PARCIAL
#define DFN_MINIMUM_AMOUNT_ACTION_NOTHING             0
#define DFN_MINIMUM_AMOUNT_ACTION_EMPTY               ' '
#define DFN_MINIMUM_AMOUNT_ACTION_TOTAL               'T'
#define DFN_MINIMUM_AMOUNT_ACTION_REFERENCE           'R'
#define DFN_MINIMUM_AMOUNT_ACTION_WITHDRAW            'W'
#define DFN_MINIMUM_AMOUNT_ACTION_DEFAULT             DFN_MINIMUM_AMOUNT_ACTION_WITHDRAW

// Flags, clase_mensaje MENSAJE_MODIFICACION (3)
#define DFN_MOK_MODIFICATION_CHAR                     'K'
#define DFN_MOE_MODIFICATION_CHAR                     'E'
#define DFN_MOW_MODIFICATION_CHAR                     'D'
// Voice markets.
#define DFN_VOICE_AMOUNT_MODIFICATION_CHAR            'M'

// Flags, clase_mensaje MENSAJE_RETIRO (3)
#define DFN_MULTIPLE_WITHDRAW                         "Z"
#define DFN_MULTIPLE_WITHDRAW_ERROR_NEW_ORDER         "z"

// Indica que una postura es adherida con pico
#define DFN_ORDER_ADHERIDA_CHAR                       'T'                            
#define DFN_ORDER_ADHERIDA                            "T"                            

// Flags, clase_mensaje MENSAJE_NOT_PROCESSED (33)
#define DFN_NOT_PROCESSED_INSERT                      "E"
#define DFN_NOT_PROCESSED_RE_INSERT                   "I"
#define DFN_NOT_PROCESSED_MODIFY                      "M"
#define DFN_NOT_PROCESSED_DELETE                      "R"
#define DFN_NOT_PROCESSED_MODIFY_CURRENCY             "C"
#define DFN_NOT_PROCESSED_HANDOVER_USER_OFFLINE       "H"
#define DFN_NOT_PROCESSED_REGISTERED_TRANSACTION      "T"
#define DFN_NOT_PROCESSED_FEED_ORDER                  "F"

// Flags, clase_mensaje MENSAJE_TRANSACCION (5)
#define DFN_TRANSACTION_RFQ_FLAG                      "D"

// Flags, clase_mensaje MENSAJE_TRANSACCION (5) Y (29)
#define DFN_TRANSACTION_REGISTERED                    "R"
#define DFN_TRANSACTION_BY_CHAMBER                    "c"
#define DFN_TRANSACTION_REGISTERED_CHAR               'R'
#define DFN_TRANSACTION_BY_CHAMBER_CHAR               'c'
#define DFN_TRANSACTION_CANCEL_CHAR                   'r'


// Flags, clase_mensaje MENSAJE_TRANSACCION (70)
#define DFN_TRANSACTION_NOT_CUPO_OWNER_CHAR                   'P'  //Postulante no tiene cupo
#define DFN_TRANSACTION_NOT_CUPO_CHAMBER_WITH_OWNER_CHAR      'p'  //La camara no tiene cupo con el postulante
#define DFN_TRANSACTION_NOT_CUPO_AGGRESSOR_CHAR               'A'  //Aceptante no tiene cupo
#define DFN_TRANSACTION_NOT_CUPO_CHAMBER_WITH_AGRESSOR_CHAR   'a'  //La camara no tiene cupo con el aceptante
#define DFN_EXPIRED_REQUEST                                   'E'  //Solicitud expirada


// Flags, clase_mensaje MENSAJE_NO_TRANSACCION (6)
#define DFN_NO_TRANSACTION_LOG                        "L"
#define DFN_NO_TRANSACTION_NO_ORDER                   "N"
#define DFN_NO_TRANSACTION_INDICATIVE                 "Z"
#define DFN_NO_TRANSACTION_NOT_TRADEABLE              "r" // reference, deferred, ...
#define DFN_NO_TRANSACTION_CURRENCY                   "c"
#define DFN_NO_TRANSACTION_COMPENSATION               "t"
#define DFN_NO_TRANSACTION_PRICE                      "M"
#define DFN_NO_TRANSACTION_SPOT_PRICE                 "m"
#define DFN_NO_TRANSACTION_MATCHING_FACTOR            "M"
#define DFN_NO_TRANSACTION_AGGRESSOR_TOTAL_AMOUNT     "S"
#define DFN_NO_TRANSACTION_ONWER_TOTAL_AMOUNT         "T"
#define DFN_NO_TRANSACTION_MINIMUM_AMOUNT             "U"
#define DFN_NO_TRANSACTION_AGGRESSOR_NO_NAMEPENDING   "p"
#define DFN_NO_TRANSACTION_OWNER_NO_NAMEPENDING       "q"
#define DFN_NO_TRANSACTION_CREDIT_POLICIES            "x"
#define DFN_NO_TRANSACTION_CREDIT_LIMIT_TOTAL         "X"
#define DFN_NO_TRANSACTION_CREDIT_LIMIT               "Q"
#define DFN_NO_TRANSACTION_OUT_OF_MARKET_HOURS        "O"
#define DFN_NO_TRANSACTION_INCOMPLETE_LINKED_ORDERS   "A"

// Flags, clase mensaje MENSAJE_FOK_FOE_RESPONSE (31)
#define DFN_FOK_NOT_TRADED                            "X"
#define DFN_FOE_NOT_TRADED                            "E"
#define DFN_FOK_FOE_PARTIALLY_TRADED                  "P"

// Flags tradenegotiation.
#define DFN_TRADENEG_CONFIRMATION_CHAR                'C'
#define DFN_TRADENEG_AGREEMENT_CHAR                   'A'
#define DFN_TRADENEG_SUGGESTION_CHAR                  'S'
#define DFN_TRADENEG_PUBLISH_BANK_NAME_CHAR           'P'
#define DFN_TRADENEG_FINISH_CHAR                      'F'
#define DFN_TRADENEG_REJECTION_CHAR                   'f'
#define DFN_TRADENEG_USER_ENTERS_CHAR                 'I'
#define DFN_TRADENEG_USER_QUITS_CHAR                  'O'
#define DFN_TRADENEG_ADVISE_OTHER_BROKERS_SAME_BRANCH 's'
#define DFN_TRADENEG_PUT_RESTRICTION                  'R'

// Flags for tradenegotiation rejections (DFN_TRADENEG_REJECTION_CHAR)
#define DFN_TRADENEG_REJECTION_TRADE_FLAG              "T"
#define DFN_TRADENEG_REJECTION_TRADE_BY_NAME_FLAG      "N"
#define DFN_TRADENEG_REJECTION_WITHOUT_CONFIRM_NAME    "R"

// Flags for BANDERA_ESTANDAR_LIBRE fields.
#define DFN_FLAG_STANDARD_TERM                        "E"
#define DFN_FLAG_FREE_TERM                            "L"

// Flags for REGISTRO_FIJO fields
#define DFN_FLAG_FIXED_RECORD                         "S"
#define DFN_FLAG_NOT_FIXED_RECORD                     "N"
// used for not fixed which must remain as fixed until the end of the day
#define DFN_FLAG_TREAT_AS_FIXED_RECORD                "P"

// Values for concertacion field in voice markets.
#define DFN_VOICE_CONCERTACION_CAMA                    1   // cama
#define DFN_VOICE_CONCERTACION_RONDA                   2   // ronda

// Flags for CMsgAllCrpoliNotification message that is sent from DME to DGI.
#define DFN_ALLCRPOLINOTIFICATION_BEGIN_FLAG           ""
#define DFN_ALLCRPOLINOTIFICATION_END_FLAG             "E"

// Result values for command history message.
#define DFN_COMMANDHISTORY_PROCESSED                   1
#define DFN_COMMANDHISTORY_NOT_PROCESSED               2

// DFN values for G7 RFQ replies.
// Apply to CLASE_MENSAJE field of MSS_TABLA_MONEDA_DIRECTO
#define DFN_RFQ_NOT_ONLINE                  2   //; 2 - Desconectado luego de ingreso
#define DFN_RFQ_INTERRUPTION                3   //; 3 - Interrupcin
#define DFN_RFQ_COUNTERPART_PRICE           4   //; 4 - Ingreso de precio por parte del contestante
#define DFN_RFQ_OWNER_PRICE                 5   //; 5 - Ingreso de precio por parte del convocante
#define DFN_RFQ_TRADE_REQUEST               6   //; 6 - tuyos o mios
#define DFN_RFQ_NO_TRANSACTION              7   //; 7 - No transaccin
#define DFN_RFQ_TRANSACTION                 8   //; 8 - Transaccin
//#define DFN_RFQ_PRICE_CONFIRMATION          9   //; 9 - Confirmacin de ingreso de precio   // NOT USED IN G7 RFQ

#define ETC_RFQ_TRANSACTION                10    // Transaction between ETC Traders

// Values for CLASE_MENSAJE field of indicatives msg (CMsgIndicatives)
#define DFN_INDICATIVES_INSERT                    1
#define DFN_INDICATIVES_MODIFY                    2
#define DFN_INDICATIVES_WITHDRAW                  3
#define DFN_INDICATIVES_PUBLISH                   4

// Values for ACTUALIZACION_AUTOMATICA field of indicatives global table (CGTIndicatives)
#define DFN_INDICATIVES_MANUAL_UPDATE             1
#define DFN_INDICATIVES_AUTOMATIC_UPDATE          2

// Flag values for field RESTRICCION_RETIRODIF in DelDeferred message (Voice Markets).
#define DFN_RETIRODIF_DUE_TO_ERROR                    "E"
#define DFN_RETIRODIF_DUE_TO_FACT_MODIFICATION        "M"

#define DFN_CCYPAIR_NDF_FLAG                          "N"
#define DFN_CCYPAIR_FORWARD_FLAG                      "F"
#define DFN_CCYPAIR_SPOT_FLAG                         "S"

// Values for COLOR_ULTIMA_TRANS field in statistics message.
#define DFN_STATISTICS_COLOR_SOLO_LETRA_AZUL          633

// mximo nmero de caracteres que se leen de una linea de los archivos
#define MAX_OPER_CONF_FILE_LINES         100     // Max lines of Oper file to be saved for logs.
#define MAX_LINECHARS                    10000
#define MAX_AMOUNT_SIZE                  50    
#define COMMENT_CHAR                    ';'
#ifndef DAPI
#define MAX_TABLE_CODES                  32100
#else
#define MAX_TABLE_CODES                  40000
#endif

#define MAX_CODE_LEN                     4 
#define MAX_PID_LEN                      18 
#define MAX_COMMAND_LEN                  50
#define MAX_FILE_NAME                    200
#define BRANCH_CODE_LEN                  8   

#define MAX_USER_NAME_LEN               80
#define MAX_USER_PASS_LEN               80
#define MAX_GTN_FILE_NAME               80
#define MAX_GTN_USER_NAME_LEN           80
#define MAX_GTN_USER_PASS_LEN           80

#define MAX_IP_ADDRESS_TEXT_LEN         20
#define MAX_GTN_SESSIONS_NUMBER         40

#define MAX_NUMBER_OF_MARKETS           100
#define DFN_RFQ_NUM_MARKET                9
#define MAX_MARKET_NUMBER               999

#define INITIAL_MAXIMUM_ARRAYS_SIZE    2000
#define INITIAL_MAXIMUM_RULES            20
#define INITIAL_MAXIMUM_TABLES_LIST       3
#define INITIAL_TABLE_SIZE              500
#ifndef DAPI
#define INITIAL_CONN_MESSAGES_NUMBER    300
#else
#define INITIAL_CONN_MESSAGES_NUMBER    6
#endif
#define INITIAL_LOG_MESSAGES_NUMBER     500
#define INITIAL_TRANS_SIZE              200
#define INITIAL_BRANCHES_BY_INSTIT_SIZE 20

// Messages types.
#define MENSAJE_INGRESO                 1
#define MENSAJE_MODIFICACION            2
#define MENSAJE_RETIRO                  3
#define MENSAJE_ACEPTACION              4
#define MENSAJE_TRANSACCION             5
#define MENSAJE_NO_TRANSACCION          6
#define MENSAJE_REGISTRO_CON_CONFIRMACION            7
#define MENSAJE_ORDEN_C_V_INGRESO       9
#define MENSAJE_ORDEN_C_V_MODIFICACION  10
#define MENSAJE_ORDEN_C_V_RETIRO        11
#define MENSAJE_HANDOVER                16
#define MENSAJE_HANDOVER_UPDATE_FIELD   17
#define MENSAJE_REFERENCE               25
#define MENSAJE_NO_REFERENCE            26
#define MENSAJE_REGISTRO_RESPUESTA      29
#define MENSAJE_FOK_FOE_RESPONSE        31
#define MENSAJE_NOT_PROCESSED           33
#define MENSAJE_ANULACION_TRANSACCION   51
#define MENSAJE_ANULACION_TRANSACCION_2 52
#define MENSAJE_TRANSACCION_NAMEPENDING 65

#define MENSAJE_NO_CONFIRMACION         70
#define MENSAJE_TRANSACCION_CADUCADA    71
#define MENSAJE_FOLIO_RELEASE           99

#define MENSAJE_TERM_LINKED_MODIFICACION    21
#define MENSAJE_TERM_LINKED_RETIRO          22
#define MENSAJE_TERM_LINKED_TRANSACCTION    23

#define MENSAJE_ORDEN_DEP_PLAZO_RETIRO      24

#define MENSAJE_INGRESO_NAME_CHECK          31
#define MENSAJE_RETIRO_NAME_CHECK           32
#define MENSAJE_MODIFICACION_NAME_CHECK     33

#define MENSAJE_INCREMENTO_PRECIO           64

//Definicion de otros mercados
#define MARKET_CO_DOLAR_FORWARD    " 74"
#define MARKET_DOLAR_SWAP          " 77"
#define MARKET_PE_DOLAR_FORWARD    " 59"
#define MARKET_108                 "108"
#define MARKET_DOLAR_SPOT          " 71"
#define MARKET_CORRO_MX            " 89" 
#define MARKET_69_MX               " 69" 
#define MARKET_140_MX              "140" 
#define MARKET_141_MX              "141" 

#ifndef  TRUE
#define  TRUE     true
#define  FALSE    false
#endif


#endif //#ifndef __DMEDEFS_H__

