//////////////////////////////////////////////////////////////////////////////
// global.h
//
// Prototypes of main functions to be used by dme - dgi applications.
//////////////////////////////////////////////////////////////////////////////

#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#ifdef GDIAPP
#include "gdidefs.h"
#endif

#include "dmedefs.h"
#include "flddescr.h"
#include <stdio.h>
#include "arrm.h"

#include <string>
using namespace std;

#ifdef DLOG
namespace _DLOG_ {
#endif


#undef GLOBAL

#ifdef  DME_GLOBAL_HERE
#   define GLOBAL
#   define INIT_B(v)    ={v}
#   define INIT_AN()    ={}
#   define INIT(v)      =(v)
#   define INIT_C(x)    (x)
#   define INIT_CS(x,y) (x,y)
#else
#   define GLOBAL extern
#   define INIT_AN()
#   define INIT_B(v)
#   define INIT(v)
#   define INIT_C(x)    
#   define INIT_CS(x,y) 
#endif

# define PLC_DONT_KNOW          0
# define PLC_NAME_CHECK         1 
# define PLC_NAME_CHECK_TERM    2
# define PLC_PRE_CLEARED        3 
# define PLC_OPT_CUPO           4  
# define PLC_NO_TRANSAR         7


#    define DME_Oper_Conf_File   "oper.conf"
#    define DME_Market_Conf_File "market.conf"

#    define DGI_Oper_Conf_File   DME_Oper_Conf_File
#    define DGI_Market_Conf_File DME_Market_Conf_File

# define DSMD_pid_number      "dsmd.pid"
# define DMDI_pid_number      "dmdi.pid"
# define DMED_pid_number      "dme.pid"
# define DMED_command_file    "dme.command"
# define DMDI_command_file    "dmdi.command"
# define DMED_result_file     "dme.result"
# define DMED_menu_file       "dme.menu"  

# define DGID_pid_number      "dgi.pid"
# define DGID_command_file    "dgi.command"
# define DGID_result_file     "dgi.result"
# define DGID_menu_file       "dgi.menu"  

# define DGDI_pid_number      "gdi.pid"
# define DGDI_command_file    "gdi.command"
# define DGDI_result_file     "gdi.result"
# define DGDI_menu_file       "gdi.menu"  

# define XDFD_pid_number      "xdf.pid"
# define XDFD_command_file    "xdf.command"
# define XDFD_result_file     "xdf.result"
# define XDFD_menu_file       "xdf.menu"  

# define DMDI_pid_number      "dmdi.pid"
# define DMDI_command_file    "dmdi.command"
# define DMDI_result_file     "dmdi.result"
# define DMDI_menu_file       "dmdi.menu"  

# define APPLI_shutdown_file  "normal.shutdown"  

# define D_SIGNAL_ERROR       -1

# define DME_CONF              1
# define DGI_CONF              2

# define CONF_FILE_VERSION    90

# define PING_REQUEST          1
# define SHUTDOWN_REQUEST      2 

#define  OPTION_PROCESSED      1
#define  CLOSE_REQUEST         0

#define  DEFAULT_MAX_FILE_SIZE              2147483647  //2GB

// Posibles opciones para el comportamiento de los cupos
#define NOT_CREDITS_AFFECTED     0    // se asume cupo ilimitado
#define NORMAL_CREDITS_AFFECTED  1    // cupos para paises latinos
#define G7_CREDITS_AFFECTED      2    // cupos para g7

// Values of namecheck flag between two branches.
#define NAMECHECK_NO_RECORD                 0
#define NAMECHECK_TRANSACTION_ANY_TERM      1
#define NAMECHECK_CONDITIONAL_TRANSACTION   2
#define NAMECHECK_NO_AGREEMENT              3

// Flags to define whether a broker or trader respect the amounts in a market.
#define NO_RESPECT_AMOUNTS              0
#define TRADER_RESPECT_AMOUNTS          1
#define BROKER_RESPECT_AMOUNTS          2
#define TRADER_BROKER_RESPECT_AMOUNTS   3

// Values to check the receipients of order messages sent from the DME.
#define NORMAL_RECIPIENTS            1
#define ONLY_POSTULANTE              2
#define ONLY_ACEPTANTE               3
#define DATASERVER                   4
#define ONLY_DATAMANAGERS            5 
// #define TARGETPU_AND_DATAMANAGERS    6 not used
#define ONLY_POSTULANTE_LOW_PRIORITY 7
#define ALL_PARTICIPANTS             8
#define NORMAL_RECIPIENTS_NO_LOG     9

// Time for Bridge pending connections check in seconds.
#define DEFAULT_BRIDGE_CONNECTIONS_CHECKING_TIME    37
// Time for sending bridge udpates to dataserver in seconds.
#define DEFAULT_SEND_BRIDGE_UPDATE_CHECKING_TIME    9

// Mercados para Renta Fija
#define   FIXED_RECT_USE_THIS_DATE       2
#define   FIXED_MARKET_MEXICAN_CORRO     3
#define   FIXED_MARKET_MEXICAN_REPORTO   4


#define MAX_COMMAND_INPUT_LEN                     400

GLOBAL const char *Glb_DS_Id INIT ("D");
GLOBAL const char *Glb_GT_Id INIT ("G");
GLOBAL const char *Glb_BR_Id INIT ("B");
GLOBAL const char *Glb_GDI_Id INIT ("I");

// Indexes for transaction bits.
#define TRANSACTION_NO_PENDIG_TRADE_INDEX               0
#define TRANSACTION_ONE_SIDE_USE_NAMECHECK_INDEX        1
#define TRANSACTION_ONE_SIDE_BANK_PENDING_INDEX         2
#define TRANSACTION_OWNER_MUST_CONFIRM_INDEX            3
#define TRANSACTION_AGGRESSOR_MUST_CONFIRM_INDEX        4
#define TRANSACTION_OWNER_MUST_ENTER_BANK_INDEX         5
#define TRANSACTION_AGGRESSOR_MUST_ENTER_BANK_INDEX     6
#define TRANSACTION_BY_CLS_INDEX                        7
#define TRANSACTION_ORDER_WAS_DRIP_FEED_INDEX           8
#define TRANSACTION_RFQ_BROKER_PRICE_INDEX              9
#define TRANSACTION_ORDER_WAS_AUTOMATCHING              10
#define TRANSACTION_SPOT_IS_NEGOTIABLE                  11
#define TRANSACTION_NOT_BY_CLS_INDEX                    12
#define TRANSACTION_MAX_BIT_INDEX                       13

// Posturas para camas (Concertacion) MX RF
#define PENDING_AGGREMENT                               1

// Max len for arrays with the possible groups ids.
// Enough to cover 9 numbers and 26 uppercase alphabet letters (Total 35).
#define GROUP_ORDERS_IDS_MAX_LEN         35

// Numero maximo de campos que son permitidos para para recibir informacin del bridge
#define BRIDGE_MAX_FIELDS       30
// Longitud maxima para los nombres de los campos y sus respectivos valores.
#define BRIDGE_NAME_MAX_LEN     20

#ifdef __FIELD_H__

#ifdef DME_GLOBAL_HERE
       char                 Glb_group_ids [] = {'Z','Y','X','W','V','U','T','S','R',
                                                'Q','P','O','N','M','L','K','J','I',
                                                'H','G','F','E','D','C','B','A','9',
                                                '8','7','6','5','4','3','2','1'};
       char                 Glb_Restr_Oper[] = {'x','i','d','u','l','x'};
       S_Bits               Glb_Transaction_Bits[]    = {{2,0,0}, //TRANSACTION_NO_PENDIG_TRADE_INDEX          
                                                         {2,0,1}, //TRANSACTION_ONE_SIDE_USE_NAMECHECK_INDEX   
                                                         {2,0,2}, //TRANSACTION_ONE_SIDE_BANK_PENDING_INDEX    
                                                         {1,2,1}, //TRANSACTION_OWNER_MUST_CONFIRM_INDEX       
                                                         {1,3,1}, //TRANSACTION_AGGRESSOR_MUST_CONFIRM_INDEX   
                                                         {1,4,1}, //TRANSACTION_OWNER_MUST_ENTER_BANK_INDEX    
                                                         {1,5,1}, //TRANSACTION_AGGRESSOR_MUST_ENTER_BANK_INDEX
                                                         {1,12,1},//TRANSACTION_BY_CLS_INDEX                
                                                         {1,13,1},//TRANSACTION_ORDER_WAS_DRIP_FEED_INDEX      
                                                         {1,14,1},//TRANSACTION_RFQ_BROKER_PRICE_INDEX
                                                         {1,15,1},//TRANSACTION_ORDER_WAS_AUTOMATCHING      
                                                         {1,19,1},//TRANSACTION_SPOT_IS_NEGOTIABLE
                                                         {1,12,0},//TRANSACTION_NOT_BY_CLS_INDEX                
                                                        };

       S_Bits               Glb_CLS_Bits               =  {1,0,1}; //OWNER_CLS_ORDER_INDEX          
       S_Bits               Glb_FEED_Bits              =  {1,3,1}; //OWNER_FEED_ORDER_INDEX         
       S_Bits               Glb_LEAVE_Bits             =  {1,5,1}; //OWNER_NOT_LEAVE_ORDER_INDEX
       S_Bits               Glb_NPENDING_ToShow_Bits   =  {1,6,1}; //OWNER_NAME_PENDING_TO_SHOW_INDEX
       S_Bits               Glb_NPENDING_To_NOT_Show_Bits = {1,6,0}; //OWNER_NAME_PENDING_TO_NOT_SHOW_INDEX
       S_Bits               Glb_NO_SPLIT_AMOUNT_Bits   =  {1,7,1}; //OWNER_NO_SPLIT_AMOUNT_INDEX

       S_Bits               Glb_Owner2_Split_Amount_Bits                =  {1,0,1}; //OWNER2_SPLIT_AMOUNT_INDEX
       S_Bits               Glb_Owner2_Two_Transactions_Generated_Bits  =  {1,6,1}; //OWNER2_TWO_TRANSACTIONS_GENERATED_INDEX
       S_Bits               Glb_Owner2_No_Show_Name_Bits                =  {1,7,1}; //OWNER2_NO_SHOW_NAME_INDEX
       S_Bits               Glb_Owner2_Show_Name_Bits                   =  {1,7,0}; //OWNER2_SHOW_NAME_INDEX

       // BANDERAS_CONFIGURACION_CONFCUPOS
       S_Bits               Glb_NO_Namepending_Bits    =  {1,0,0}; //CONFCUPOS_NO_NAMEPENDING_INDEX
       S_Bits               Glb_Namepending_Bits       =  {1,0,1}; //CONFCUPOS_NAMEPENDING_INDEX
       S_Bits               Glb_NO_Broker_Admin_Bits   =  {1,1,0}; //CONFCUPOS_NO_BROKER_ADMIN_INDEX
       S_Bits               Glb_Broker_Admin_Bits      =  {1,1,1}; //CONFCUPOS_BROKER_ADMIN_INDEX

#else
extern char                 Glb_group_ids [];
extern char                 Glb_Restr_Oper[];
extern S_Bits               Glb_Transaction_Bits[];
extern S_Bits               Glb_CLS_Bits;                 //OWNER_CLS_ORDER_INDEX          
extern S_Bits               Glb_FEED_Bits;                //OWNER_FEED_ORDER_INDEX         
extern S_Bits               Glb_LEAVE_Bits;               //OWNER_NOT_LEAVE_ORDER_INDEX
extern S_Bits               Glb_NPENDING_ToShow_Bits;     //OWNER_NAME_PENDING_TO_SHOW_INDEX
extern S_Bits               Glb_NPENDING_To_NOT_Show_Bits;//OWNER_NAME_PENDING_TO_NOT_SHOW_INDEX
extern S_Bits               Glb_NO_SPLIT_AMOUNT_Bits;     //OWNER_NO_SPLIT_AMOUNT_INDEX

extern S_Bits               Glb_Owner2_Split_Amount_Bits;               //OWNER2_SPLIT_AMOUNT_INDEX
extern S_Bits               Glb_Owner2_Two_Transactions_Generated_Bits; //OWNER2_TWO_TRANSACTIONS_GENERATED_INDEX
extern S_Bits               Glb_Owner2_No_Show_Name_Bits;               //OWNER2_NO_SHOW_NAME_INDEX
extern S_Bits               Glb_Owner2_Show_Name_Bits;                  //OWNER2_SHOW_NAME_INDEX

// BANDERAS_CONFIGURACION_CONFCUPOS
extern S_Bits               Glb_NO_Namepending_Bits;      //CONFCUPOS_NO_NAMEPENDING_INDEX
extern S_Bits               Glb_Namepending_Bits;         //CONFCUPOS_NAMEPENDING_INDEX
extern S_Bits               Glb_NO_Broker_Admin_Bits;     //CONFCUPOS_NO_BROKER_ADMIN_INDEX
extern S_Bits               Glb_Broker_Admin_Bits;        //CONFCUPOS_BROKER_ADMIN_INDEX


#endif

// Indexes for order bits.
#define OWNER_CLS_ORDER_INDEX                           &Glb_CLS_Bits
#define OWNER_FEED_ORDER_INDEX                          &Glb_FEED_Bits
#define OWNER_NOT_LEAVE_ORDER_INDEX                     &Glb_LEAVE_Bits
#define OWNER_NAME_PENDING_TO_SHOW_INDEX                &Glb_NPENDING_ToShow_Bits
#define OWNER_NAME_PENDING_TO_NOT_SHOW_INDEX            &Glb_NPENDING_To_NOT_Show_Bits
#define OWNER_NO_SPLIT_AMOUNT_INDEX                     &Glb_NO_SPLIT_AMOUNT_Bits

// Indexes for order bits in BANDERAS_POSTURA_2.
#define OWNER2_SPLIT_AMOUNT_INDEX                       &Glb_Owner2_Split_Amount_Bits
#define OWNER2_TWO_TRANSACTIONS_GENERATED_INDEX         &Glb_Owner2_Two_Transactions_Generated_Bits
#define OWNER2_NO_SHOW_NAME_INDEX                       &Glb_Owner2_No_Show_Name_Bits
#define OWNER2_SHOW_NAME_INDEX                          &Glb_Owner2_Show_Name_Bits

// BANDERAS_CONFIGURACION_CONFCUPOS
#define CONFCUPOS_NO_NAMEPENDING_INDEX                  &Glb_NO_Namepending_Bits
#define CONFCUPOS_NAMEPENDING_INDEX                     &Glb_Namepending_Bits
#define CONFCUPOS_NO_BROKER_ADMIN_INDEX                 &Glb_NO_Broker_Admin_Bits
#define CONFCUPOS_BROKER_ADMIN_INDEX                    &Glb_Broker_Admin_Bits

// Indexes for trade order bits. Trade order bits uses the same bits
// that their corresponding order bits.
#define AGGRESSOR_CLS_TRADE_FILTER_INDEX                &Glb_CLS_Bits
#define AGGRESSOR_FEED_ORDER_INDEX                      &Glb_FEED_Bits
#define AGGRESSOR_LEAVE_ORDER_PROCESS_INDEX             &Glb_LEAVE_Bits
#define AGGRESSOR_NAME_PENDING_TO_SHOW_INDEX            &Glb_NPENDING_ToShow_Bits
#define AGGRESSOR_NO_SPLIT_AMOUNT_INDEX                 &Glb_NO_SPLIT_AMOUNT_Bits

#endif // __FIELD_H__

#ifndef DMECON
GLOBAL struct DCON_DESCR    glb_DCon_DESCR;
GLOBAL struct DCON_DESCR    glb_TCon_DESCR;
GLOBAL struct DCON_DESCR    glb_BCon_DESCR; // for bridge connections

// DME has a different connection retry wait time because DS will reject DME connection tries
// until a Datamanager has been connected and published the systema global tables.
// The other applications that uses dcon.cpp module (DGI, dcapi, ...) will continue
// using the original default retry wait time.
#ifdef DMEAPP
GLOBAL unsigned int        Glb_connection_retry_wait     INIT(DME_DEFAULT_CONNECTION_RETRY_WAIT);
#else
GLOBAL unsigned int        Glb_connection_retry_wait     INIT(DEFAULT_CONNECTION_RETRY_WAIT);
#endif
#endif  //DMECON


#define DEST_SIZE 4

#define DME_RANGE_INVALID                                 0
#define DME_RANGE_VALID                                   1

#define APP_RANGE_INVALID                                 0
#define APP_RANGE_VALID                                   1


GLOBAL CABEZA_DFN           glb_cabeza_dfn;
GLOBAL unsigned int        glb_last_message;

GLOBAL int                  G_dm_server_rec_received      INIT(FALSE);
GLOBAL int                  G_persistent_synchronized     INIT(FALSE);
GLOBAL int                  glb_logged                    INIT(0);
GLOBAL int                  glb_valid_range               INIT(DME_RANGE_INVALID);
GLOBAL unsigned int         gbl_code_table_type           [MAX_TABLE_CODES];
#ifdef DAPI
GLOBAL unsigned int         Glb_subscribed_global_table_type [MAX_TABLE_CODES];
//GLOBAL int                  Glb_subscribed_global_count;
//GLOBAL unsigned int         Glb_subscribed_global_codes      [MAX_TABLE_CODES];
GLOBAL unsigned int         Glb_subscribed_code_table_id     [MAX_TABLE_CODES];
#endif
GLOBAL int                  Glb_Market_Num[MAX_MARKET_NUMBER];
GLOBAL int                  glb_markets_selected_by_oper;
GLOBAL const char          *Glb_Offer_Id      INIT ("O");
GLOBAL const char          *Glb_Offer_Id_Bed  INIT ("E");
GLOBAL const char          *Glb_Bid_Id        INIT ("D");
GLOBAL const char          *Glb_Bid_Id_Bed    INIT ("C");
GLOBAL const char          *Glb_Mime          INIT ("M");
GLOBAL const char          *Glb_Other         INIT ("S");
GLOBAL const char          *Glb_Plc_Buy       INIT ("C");
GLOBAL const char          *Glb_Plc_Sell      INIT ("V");
GLOBAL const char          *Glb_Plc_Glbz      INIT ("G");
// estos dos flags son para cupos por PLAZO 
GLOBAL const char          *Glb_Plc_PL_Buy  INIT ("B");
GLOBAL const char          *Glb_Plc_PL_Sell INIT ("S");
GLOBAL const char          *Glb_Plc_PL_Glbz INIT ("g");
// estos dos flags son para cupos por cmara
GLOBAL const char          *Glb_Cam_Buy  INIT ("c");
GLOBAL const char          *Glb_Cam_Sell INIT ("v");

GLOBAL const char          *Glb_Cupos_Dme_Ch_Flag     INIT ("T");
GLOBAL const char          *Glb_Cupos_Dme_Null_Flag   INIT ("A");

#define ASK_CHAR      ((const int)'O')
#define BID_CHAR      ((const int)'D')
#define TOTAL_CHAR    ((const int)'T')
#define YES_CHAR      ((const int)'S')

#define BUY_TRNS      ((const int)'C')
#define SELL_TRNS     ((const int)'V')

#define BUY_PL_TRNS   ((const int)'B')
#define SELL_PL_TRNS  ((const int)'S')

#define BUY_CAMS      ((const int)'c')
#define SELL_CAMS     ((const int)'v')

#define GLBZ_TRNS     ((const int)'G')
#define GLBZ_PL_TRNS  ((const int)'g')

#define DME_MANAGED   ((const int)'M')

#ifdef _C_CALC_H_
GLOBAL CALC_MNUM            Glb_zero          [COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_one      [COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_two      [COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_hundred  [COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_thousand [COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_ten_thousand [COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_millionth[COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_minus_one[COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_min_calc_price[COMMON_CALC_SIZE];
GLOBAL CALC_MNUM            Glb_calc_max_value[COMMON_CALC_SIZE];

#ifdef __MESSAGE_H__
void  COMMON_Get_Transaction_Near_And_Outright_Rate (CMsgOrder *msg_to_send, 
                                                     CALC_MNUM *calc_near_rate,
                                                     CALC_MNUM *calc_outright_rate);
#endif
void  COMMON_Calculate_Rate_With_Precision (CALC_MNUM *market_point_precision, 
                                            CALC_MNUM *market_price_scale,
                                            CALC_MNUM *calc_initial_rate,
                                            CALC_MNUM *calc_points,
                                            CALC_MNUM *calc_result_rate,
                                            int        add_points_to_initial_rate);
void COMMON_Calculate_Ouright_Rate_Metal_Markets (CALC_MNUM  *calc_spot_price,
                                                  CALC_MNUM  *calc_precio,
                                                  int         current_market_num,
                                                  const char *fecha_vencimiento,
                                                  const char *fecha_vencimiento_xdias,
                                                  const char *texto_term,
                                                  CALC_MNUM  *calc_outright_rate_result);
void COMMON_Calculate_Near_Rate_Metal_Markets    (CALC_MNUM  *calc_outright_price,
                                                  CALC_MNUM  *calc_precio,
                                                  int         current_market_num,
                                                  const char *fecha_vencimiento,
                                                  const char *fecha_vencimiento_xdias,
                                                  const char *texto_term,
                                                  CALC_MNUM  *calc_spot_rate_result);
void  COMMON_Get_Rounded_Spot_Price  (int num_market,  CALC_MNUM *calc_spot_price, CALC_MNUM *calc_rounded_spot_price);
void  COMMON_Get_Round_Spot_Price_Length_Decimals(int  num_market,
                                                  int *length,
                                                  int *decimals);

bool  COMMON_Check_Unit_Type                     (int unit_base, 
                                                  std::string market_currency_letter);
int   COMMON_Is_Metal_Market                     (int market_num);

int   COMMON_Get_Mid_Indicative_Price_Tendency   (CALC_MNUM *new_mid_price, 
                                                  CALC_MNUM *cur_mid_price);

#endif  //_C_CALC_H_

#ifdef __MARKET_H__

// Este define tiene como propsito reportar en caso que la variable
// Glb_cur_market est nula y de esta manera se evita posible caidas del dme.
#define GLB_MARKET        (Glb_cur_market?Glb_cur_market:MARKET_Alert_Null_Pointer(__FILE__, __LINE__))

GLOBAL CMarket            * glb_market  [MAX_NUMBER_OF_MARKETS];
GLOBAL CMarket            * Glb_cur_market;
       CMarket            * COMMON_Take_Market(int market_id);
        void              * COMMON_Get_TableList (int tablelist_id, int market_id);
      char                * COMMON_Time_Increase (char *time_ptr, int seconds);
#endif

GLOBAL int                  Glb_range_limit_err_msg       INIT(FALSE);
GLOBAL unsigned int         Glb_range_limit               INIT(1000000);
GLOBAL char                 Glb_Local_Machine[4];
GLOBAL char                 Gbl_Branch_Code[8];
GLOBAL char                 Glb_Branch_4c[4];
GLOBAL char                 Glb_Current_DS[4];
GLOBAL char                 Glb_PU_Code[4];
GLOBAL unsigned int         glb_min_gtable_rec_index      INIT(0);
GLOBAL unsigned int         glb_max_gtable_rec_index      INIT(Glb_range_limit);
GLOBAL unsigned int         Glb_range_environment         INIT(0);
GLOBAL char                 Glb_environment [2];
#ifdef DAPI
GLOBAL unsigned int        glb_min_pu_connected_gtable_rec_index      INIT(0);

GLOBAL int                  Glb_Status_Init_Ask_Log              INIT(0);
GLOBAL int                  Glb_Prev_Date_Log_Req_Successfullty  INIT(0);
GLOBAL char                 Glb_Prev_Date_Log_Req_Copy[10]       INIT_AN();

#endif

GLOBAL bool                 Glb_ds_range_received         INIT(false);
GLOBAL int                  glb_dss_counter;

GLOBAL bool                 Glb_check_trading_by_cupos_change  INIT(false);

#ifdef DAPI
#define MAX_NUM_MARKETS_CODE    30
GLOBAL int                  Glb_Markets_Code [MAX_NUM_MARKETS_CODE];
GLOBAL int                  Glb_Message_Code              INIT(0);
GLOBAL int                  Glb_markets_code_counter      INIT(0);

// Variable que guarda el codigo del esquema definido en el archivo dapi.cfg.
GLOBAL char                 Glb_Esquema_Code[8];
#endif

#define MAX_DS_SERVERS      36
GLOBAL char                 glb_dss[MAX_DS_SERVERS][DEST_SIZE];

#ifdef DME_GLOBAL_HERE
GLOBAL char                 (*glb_ds_dest)[DEST_SIZE] = glb_dss;
#else
extern char                 (*glb_ds_dest)[DEST_SIZE];
#endif

#ifdef DMDIAPP
GLOBAL char                 Glb_Zero_Str[MAX_KEY_LEN] INIT_AN();
#else
GLOBAL const char           Glb_Zero_Str[MAX_KEY_LEN] INIT_AN();
#endif

#define MAX_UNITS_DEF       100
#define MAX_ENV_DEF         30

GLOBAL char                 Glb_One_Str[MAX_KEY_LEN];
GLOBAL char                 Glb_Question_Str[MAX_KEY_LEN];

GLOBAL unsigned int        Glb_max_file_size             INIT(DEFAULT_MAX_FILE_SIZE);
GLOBAL unsigned int        Glb_log_file_size_lower_limit INIT(DEFAULT_MAX_FILE_SIZE-MESSAGE_TRANS_RECORD_SIZE);
GLOBAL unsigned int        glb_num_sent_msgs;
GLOBAL unsigned int        Glb_Binary_Log_Enable         INIT(0); 

GLOBAL std::string          Glb_msg_dest_grps             [MAX_UNITS_DEF];
GLOBAL int                  Glb_num_def_dest_grps         INIT(0);

GLOBAL std::string          Glb_Env_Old_Market_Format     [MAX_UNITS_DEF];
GLOBAL int                  Glb_Env_Old_Market_Format_Num INIT(0);

#ifdef GDIAPP
GLOBAL unsigned int          Glb_Gtn_Recv_Msgs;
GLOBAL unsigned int          Glb_Gtn_Num_Sent_Msgs;
GLOBAL TABLE_MARKET_CONF   * Gbl_Remote_Subscription_Info            [MAX_TABLE_CODES];
GLOBAL int                   Gbl_Int_Remote_Subscription_Available   INIT(0);
#define MAX_NUM_REMOTE_SUBSCRIPTIONS   100
GLOBAL TABLE_MARKET_CONF     Gbl_Int_Remote_Subscription_Info        [MAX_NUM_REMOTE_SUBSCRIPTIONS];
#endif

#define MAX_UNITS_DEF       100
#define BILLIONS_UNIT         1
#define MILLIONS_UNIT         2
#define THOUSAND_UNIT         3

GLOBAL std::string          Glb_amounts_billions_curr[MAX_UNITS_DEF];
GLOBAL unsigned int         Glb_num_def_billions          INIT(0);

GLOBAL std::string          Glb_amounts_millions_curr[MAX_UNITS_DEF];
GLOBAL unsigned int         Glb_num_def_millions          INIT(0);

GLOBAL std::string          Glb_amounts_thousands_curr[MAX_UNITS_DEF];
GLOBAL unsigned int         Glb_num_def_thousands         INIT(0);

#if DGIAPP
GLOBAL unsigned short       Glb_Status_Matrix_Sent        INIT(0);
#endif

#if DGIAPP || GDIAPP

GLOBAL unsigned int        Glb_Gtn_Num_Issueupdate_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Issuebookupd_Orddepth_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Multipacket_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Positive_Order_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Positive_Trade_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Positive_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Negative_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Neworder_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Tradenegotiation_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Orderbookupdate_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Pageupdate_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Default_Customer_Number;
GLOBAL unsigned int        Glb_Gtn_Fixing_Customer_Number;

GLOBAL int                 Gbl_GTN_Columns_Mx_Rf_Dynamic_Pages   INIT(1);

#endif

#ifdef DGIAPP
GLOBAL unsigned int        Glb_Gtn_Recv_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Customernamelist_Update_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Internal_Info_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Tickerupdate_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_Issuelistresponse_Sent_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_RFQ_Static_Data_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_RFQReply_Msgs;
GLOBAL unsigned int        Glb_Gtn_Num_RFQRequest_Msgs;

#else
GLOBAL unsigned int        glb_num_sent_msgs_to_dgi;
GLOBAL unsigned int        glb_num_sent_msgs_to_dmdi;
#endif

GLOBAL unsigned int        glb_num_proc_msgs;
GLOBAL unsigned int        Glb_dgi_num_proc_msgs;
GLOBAL unsigned int        Glb_dmdi_num_proc_msgs;
GLOBAL long                Glb_time_diff;

GLOBAL unsigned int  Glb_Unic_Number;
GLOBAL unsigned int  Glb_Proc_Flag;
GLOBAL unsigned int  Glb_Other_Markets;
GLOBAL unsigned int  Glb_Processed_Mss;
GLOBAL unsigned int  Glb_Table_Mss;
GLOBAL unsigned int  Glb_Not_Applied_Mss;
GLOBAL unsigned int  Glb_Transactions_Count;
GLOBAL unsigned int  Glb_No_Transactions_Count;
GLOBAL unsigned int  Glb_Proposal;
GLOBAL unsigned int  Glb_Del_Proposal;
GLOBAL unsigned int  Glb_Mod_Proposal;
GLOBAL unsigned int  Glb_Trans_Counter;
GLOBAL unsigned int  Glb_Trans_Canceled_Counter;
GLOBAL unsigned int  Glb_Trans_Commited_Counter;
GLOBAL unsigned int  Glb_Inserted_Pending_Orders;
GLOBAL unsigned int  Glb_Deleted_Pending_Orders;
GLOBAL unsigned int  Glb_Inserted_Linked_Trade;
GLOBAL unsigned int  Glb_Deleted_Linked_Trade;
GLOBAL unsigned int  Glb_Tot_Transactioned_Records;
GLOBAL unsigned int  Glb_Tot_Commited_Records;
GLOBAL unsigned int  Glb_Tot_Canceled_Records;
GLOBAL unsigned int  Glb_Tmp_Induced_Trades;
GLOBAL unsigned int  Glb_Tot_Simulated_Trades;
GLOBAL unsigned int  Glb_Tot_Real_Trades;
GLOBAL unsigned int  Glb_Tot_Simulated_Deletes;
GLOBAL unsigned int  Glb_Tot_Induced_Deletes;
GLOBAL unsigned int  Glb_Tot_Denied;
GLOBAL unsigned int  Glb_Syslog_Err;
GLOBAL int            Glb_Max_Arr_Stack_Size;
GLOBAL int            Glb_Sol_Thread_Flags;
GLOBAL int            Glb_Sol_Type_Thread[20];
GLOBAL char           Glb_General_Info[MAX_LINECHARS];
GLOBAL char           Glb_Oper_File_Content [MAX_OPER_CONF_FILE_LINES][MAX_LINECHARS];   // 100 lines of oper conf file.
GLOBAL int            Glb_Oper_File_Lines_Count       INIT(0);
GLOBAL int            Gbl_BackUp_Time_Interval        INIT(0);   
GLOBAL int            G_bridge_counters_update_interval       INIT(DEFAULT_SEND_BRIDGE_UPDATE_CHECKING_TIME);
GLOBAL int            Gbl_Appi_Daemon;
GLOBAL int            Glb_dme_trade_same_branch       INIT(0);
GLOBAL int            Glb_delay_sending_end_trans     INIT(0);

#ifdef DMEAPP

GLOBAL unsigned int  Glb_CRPOLI_Max_Branchnum_Element      INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_Max_Branchnum_ETC_Element  INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_Total                      INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_ETC_Total                  INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_Namecheck                  INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_No_Namecheck               INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_Precleared                 INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_Conditional_Namecheck      INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_Credit_Limit               INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_Unknown                    INIT(0);

GLOBAL unsigned int  Glb_CRPOLI_ETC_Namecheck              INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_ETC_No_Namecheck           INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_ETC_Precleared             INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_ETC_Conditional_Namecheck  INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_ETC_Credit_Limit           INIT(0);
GLOBAL unsigned int  Glb_CRPOLI_ETC_Unknown                INIT(0);

GLOBAL unsigned int  Glb_CUPOS_Next_Day_Spot_Market        INIT(0);
GLOBAL int            Glb_slog_activated                    INIT(0); // deactivated by default

GLOBAL long           Glb_last_trading_time                 INIT(0);
GLOBAL unsigned int   Glb_last_trading_num                  INIT(0);
GLOBAL double         Glb_last_trading_amount               INIT(0.0);
GLOBAL long           Glb_accum_trading_time                INIT(0);
GLOBAL unsigned int   Glb_accum_trading_num                 INIT(0);
GLOBAL double         Glb_accum_trading_amount              INIT(0.0); 
#endif

#ifndef DAPI
//Configuration Module

//DS Connection parameters
GLOBAL char           Gbl_DS_Server_Host     [MAX_IP_ADDRESS_TEXT_LEN];
GLOBAL int            Gbl_DS_Server_Port;

#ifdef GDIAPP
//GDI Connection as a Server Parameters
GLOBAL char           Gbl_GTN_Srv_Binary_Log [MAX_GTN_FILE_NAME];
GLOBAL char           Gbl_GTN_Srv_User_Name  [MAX_GTN_USER_NAME_LEN];
GLOBAL char           Gbl_GTN_Srv_Password   [MAX_GTN_USER_PASS_LEN];
GLOBAL char           Gbl_GTN_Srv_Server_Host[MAX_IP_ADDRESS_TEXT_LEN];
GLOBAL int            Gbl_GTN_Srv_Server_Port;

//GDI Connection as a Server Parameters
GLOBAL char           Gbl_GTN_Clt_User_Name  [MAX_GTN_SESSIONS_NUMBER][MAX_GTN_USER_NAME_LEN];
GLOBAL char           Gbl_GTN_Clt_Password   [MAX_GTN_SESSIONS_NUMBER][MAX_GTN_USER_PASS_LEN];
GLOBAL char           Gbl_GTN_Clt_Server_Host[MAX_GTN_SESSIONS_NUMBER][MAX_IP_ADDRESS_TEXT_LEN];
GLOBAL int            Gbl_GTN_Clt_Server_Port[MAX_GTN_SESSIONS_NUMBER];
GLOBAL int            Gbl_Update_Time        INIT(4);

#endif

GLOBAL int            Glb_Use_CrPoli_Restrictions     INIT(TRUE);
GLOBAL int            Gbl_DGI_Compression_Level_Entered;

GLOBAL char           Gbl_Market_File_Version         [CONF_FILE_VERSION+2];
GLOBAL char           Gbl_GTN_User_Name               [MAX_USER_NAME_LEN];
GLOBAL char           Gbl_GTN_Password                [MAX_USER_PASS_LEN];
GLOBAL char           Gbl_GTN_Server_Host             [MAX_IP_ADDRESS_TEXT_LEN];
GLOBAL int            Gbl_Number_Of_Markets;
GLOBAL int            Gbl_GTN_Sessions_Number         INIT(0);
GLOBAL int            Gbl_GTN_Automatic_Login         INIT(0);
GLOBAL int            Glb_gtn_login_version           INIT(15); // 15 since SDK sep 17. Minfill amount handling.
GLOBAL int            Glb_gtn_login_version_entered   INIT(0);
GLOBAL int            Gbl_GTN_Firm_ID                 INIT(2);
GLOBAL int            Gbl_GTN_Server_Port             INIT(6257);

GLOBAL int            Gbl_GTN_Fixing_State            INIT(6);
GLOBAL int            Gbl_GTN_Fixing_Mode             INIT(2);
GLOBAL int            Glb_GTN_Fixing_Send_OrderQueue_Participant        INIT(0);
GLOBAL int            Glb_GTN_Fixing_Send_TradeQueue_Ori_Posted_Amount  INIT(0);

#endif

#ifdef GDIAPP

#define   GTNINT_CONNECTION                    1
#define   GTNINT_NOT_CONNECTION                2
#define   GTNINT_DISCONNECTION                 3
#define   GTNINT_REQUEST_INSTRUMENT_DEPTH      4
#define   GTNINT_REMOVE_INSTRUMENT_DEPTH       5
#define   GTNINT_PAGEUPDATE_INFO               6
#define   GTNINT_RECEIVED_ISSUEBOOKUPDATE      7
#define   GTNINT_RECEIVED_ISSUEUPDATE          8
#define   GTNINT_INITIALIZE_CONNECTION         9
#define   GTNINT_CLOSE_CONNECTION_REQUEST     10
#define   GTNINT_REMOVE_ISSUE_UPDATE          11
#define   GTNINT_REQUEST_ORDERBOOK_REQUEST    12
#define   GTNINT_RECEIVED_ORDERBOOKUPDATE     13

#define   GDI_INSTRUMENTS_STATE                1 

#endif

#if (DMDIAPP || DMEAPP || DGIAPP || DMECON || GDIAPP)
GLOBAL int            Gbl_GNT_Allowed_Connection INIT(0);
GLOBAL int            Gbl_Local_Machine_Entered;
GLOBAL int            Gbl_User_Entered_Path;
GLOBAL char           Gbl_Application_Path  [MAX_PATH*2];
GLOBAL int            Glb_thread_prio;
GLOBAL unsigned int   Glb_ticks_counter;
GLOBAL char           Gbl_Oper_File_Version [CONF_FILE_VERSION+2];
GLOBAL char           Glb_Initial_Directory [MAX_LINECHARS];
GLOBAL int            Glb_Send_Initial_Wait INIT(30);
GLOBAL int            Glb_Dmdi_Log          INIT(FALSE);
#if USE_LINUX || USE_SOLARIS
GLOBAL int            Glb_Virtual_Machine   INIT(FALSE);
#endif
#endif

#if DMDIAPP
GLOBAL unsigned int  Glb_SPBRIDGE_Proc_Flag;
GLOBAL unsigned int  Glb_RPBRIDGE_Proc_Flag;
#endif

#include "common.h"

#include "dscom.h"

extern CDestinationsList    glb_ds_dest_list;
extern CDestinationsList    glb_ds_dest_list_to_DS;
extern CDestinationsList    glb_ds_dest_list_to_DGI;
extern CDestinationsList    glb_dm_dest_list;
extern CDestinationsList    glb_work_dest_list;
extern CDestinationsList    glb_work_dest_list_to_DS;
extern CDestinationsList    glb_nul_dest_list_to_DS;
extern CDestinationsList    glb_nul_dest_list_to_DGI;
extern CDestinationsList    glb_nul_dest_list_to_DMDI;

void                  COMMON_Process_Login               (void);
void                  COMMON_Process_Datamanagers_List   (void);
void                  COMMON_Send_Login                  (void);
int                   COMMON_Init                        (void);
void                  COMMON_End                         (void);
void                  COMMON_Announce_Termination        (pid_t sender_pid);
void                  COMMON_Set_ShutDown_File           (bool create_sdfile);
int                   COMMON_Get_Market_Charateristics   (int market_id, int market_index);

#ifdef DGIAPP
void                  COMMON_Associate_CcyPair_With_Datatec_Market    (int         market_id, 
                                                                       const char *currency1,
                                                                       const char *currency2);
void                  COMMON_Get_CcyPair_From_Datatec_Market          (int          market_id, 
                                                                       const char **currency1,
                                                                       const char **currency2);
#endif


#ifdef GDIAPP
void                  COMMON_Get_ETC_Page_From_Datatec_Market         (int            market_id, 
                                                                       unsigned int *page_number);
char                 *COMMON_Convert_Get_Cur_Str_Time                 (char *cur_time_str);
#endif


#ifdef DGIAPP

void                  COMMON_Init_CcyPair_With_Datatec_Market_Arrays  (void);

#endif

unsigned int         COMMON_Get_New_Unique_Seed         (void);
unsigned int         COMMON_Get_New_Unique_Scnd_Seed    (void);
int                   COMMON_get_unique_code             (char *unique_code_ptr);
int                   COMMON_get_unique_scnd_code        (char *unique_code_ptr);
void                  COMMON_conv_base36_alfan           (unsigned int key_num, char* unique_code_ptr);
void                  COMMON_Get_Time_Date               (char *timebuf);
void                  COMMON_Get_Current_time            (char *cur_time_str);
void                  COMMON_Get_Current_date            (char *cur_time_str);

unsigned int          COMMON_Get_Remaining_Day_Seconds   (void);
int                   COMMON_Process_User_Command        (char *cur_command, int remote_request, pid_t sender_pid);
int                   COMMON_Daemon_Init_Request         (void);
void                  COMMON_Output_Message              (FILE *file_output, char *buffer, int stored_buffer);
void                  COMMON_Fill_General_Info           (const char *Appi_Version);
#define               ADD_PRINTF                         cur_ptr += sprintf
#define               CHKTWOTABLES                       if (++cnt_lin >= 2) {cur_ptr += sprintf (cur_ptr, "\n"); cnt_lin=0;}

void                  COMMON_Print_Priority_Log          (FILE *file_output = NULL);     
void                  COMMON_print_tables                (FILE *file_output = NULL);
void                  COMMON_print_trans                 (FILE *file_output = NULL);
unsigned int         COMMON_Take_Elapsed_Time           (void);
void                  COMMON_Perform_Bit_Access_Test     (int repetitions, bool test_integrity);
void                  COMMON_Set_Code_Data_Servers_List  (int num_codes, const char *code_data_server);
#ifdef DAPI
int                   COMMON_Set_Code_Markets_List       (char *code_markets);
#endif

#ifdef USE_POSIX_THREADS
void                  COMMON_Block_All_Signals           (void);
void                  COMMON_Alarm_Handler               (void);
#endif

void                  COMMON_Check_Erros_And_Write       (FILE *file_output, char *buffer, char *cur_ptr);
#if USE_LINUX || USE_SOLARIS
void                  COMMON_Control_Command_Received    (int sig, void *);
void                  COMMON_Write_Appi_PID_To_File      (pid_t process_id);
void                  COMMON_Write_Menu_Options          (const char *appi_menu_options, const char *menu_file_name);
pid_t                 COMMON_Get_Proc_Pid                (const char *pid_file_name, int report_error = TRUE);
void                  COMMON_Send_Signal_To_DMSD         (void);
int                   COMMON_Execute_Unix_Command        (char *command);
void                  COMMON_Print_Status_Info_To_File   (int request_type);
void                  COMMON_Process_Signals             (void);
int                   COMMON_Check_Instance              (const char *pid_file_name);
#if USE_SOLARIS
void                  COMMON_Change_Thread_Prio          (void);
#endif
GLOBAL pthread_attr_t Glb_pthread_attr;
#endif

#ifdef DAPI
#define COMMON_USE_DEFAULT_PRIORITY       0
#define COMMON_USE_DEFAULT_LOG_TEXT       (const char *)NULL
#endif

#ifdef __MESSAGE_H__

// Buffer to be used by the current message that is being processed.
#ifndef DAPI
GLOBAL char               Glb_cur_log_buffer            [MESSAGE_TRANS_RECORD_SIZE];
GLOBAL CMessage           Glb_cur_log_message           INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgOrder          Glb_cur_log_order_msg         INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgLogin          Glb_cur_log_login_msg         INIT_C (Glb_cur_log_buffer);
#ifndef DMDIAPP
GLOBAL CMsgTradeNeg       Glb_cur_log_tradeneg_msg      INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgTextTradeNeg   Glb_cur_log_texttradeneg_msg  INIT_C (Glb_cur_log_buffer);
#endif
#ifdef DMEAPP
GLOBAL CMsgFixPrice       G_cur_log_CMsgFixPrice        INIT_C (Glb_cur_log_buffer);
#endif

GLOBAL CGTOrder           Glb_cur_log_gt_order_msg      INIT_C (Glb_cur_log_buffer);

#ifndef DMDIAPP
GLOBAL CMsgPolicyCredit   Glb_cur_log_pol_credit_msg    INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgEqOffLine      Glb_cur_log_eq_offline        INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgOnePlcCredit   Glb_cur_log_oneplccredit_msg  INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgOneCfgCredit   Glb_cur_log_onecfgcredit_msg  INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgCupoG          Glb_cur_log_CMsgCupoG         INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgCupoL          Glb_cur_log_CMsgCupoL         INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgLimInstit      Glb_cur_log_CMsgLimInstit_msg INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgPendCobranzas  Glb_cur_log_CMsgPendCobranzas_msg     
                                                        INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgCreditAdm      Glb_cur_log_creditadm_msg     INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgCommandHistory Glb_cur_log_cmd_history_msg   INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgPInsDme        Glb_cur_log_pinsdme_msg       INIT_C (Glb_cur_log_buffer);
#endif

#ifdef DMEAPP
GLOBAL CMsgCupoXPL        Glb_cur_log_CMsgCuposXPL      INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgIndicatives    Glb_cur_log_CMsgIndicatives   INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgBridge         Glb_log_CMsgBridge            INIT_C (Glb_cur_log_buffer);
#endif

#ifndef DMDIAPP
GLOBAL CMsgNmChkPlz       Glb_cur_log_nmchkplz_msg      INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgRFQRequest     G_cur_log_rfqrequest_msg      INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgOrder          G_cur_log_rfqreply_msg        INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgFactRiesgo     Glb_cur_log_CMsgFactRiesgo    INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgDelDeferred    Glb_cur_log_del_def_msg       INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgVoiceTerm      Glb_cur_log_voiceterm_msg     INIT_C (Glb_cur_log_buffer);
GLOBAL CMsgDMList         Glb_cur_log_dmlist_msg        INIT_C (Glb_cur_log_buffer);
#endif
#endif //#ifndef DAPI

GLOBAL char               Glb_cur_msg_buffer        [MESSAGE_TRANS_RECORD_SIZE];
GLOBAL CMessage           Glb_cur_message           INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTHeader          Glb_cur_gt_header         INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgDMList         Glb_cur_dmlist_msg        INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgDMTList        Glb_cur_dmtlist           INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgTablesReq      Glb_cur_tablesreq_msg     INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgLogin          Glb_cur_login_msg         INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgOrder          Glb_cur_order_msg         INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTBranches        Glb_cur_branches          INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTBranchesRfqs    Glb_cur_branches_rfq      INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTInstit          Glb_cur_instit            INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTUser            Glb_cur_user              INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTOrder           Glb_cur_gt_order_msg      INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTVoiceSummary    Glb_cur_voice_summary     INIT_C (Glb_cur_msg_buffer);
#ifdef DAPI
GLOBAL CMsgChat           Glb_cur_chat_msg          INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgTransComment   Glb_cur_trans_comment_msg INIT_C (Glb_cur_msg_buffer);
#endif

#ifdef GDIAPP
GLOBAL CGTVoiceGroup      Glb_cur_voicegroup        INIT_C ( Glb_cur_msg_buffer);
GLOBAL CGTHistoryFI       Glb_cur_historyco         INIT_C ( Glb_cur_msg_buffer);
GLOBAL CMsgSubcripReq     Glb_cur_subscription      INIT_C ( Glb_cur_msg_buffer);
#endif

#if DGIAPP || DMEAPP
GLOBAL CMsgHandover       Glb_cur_CMsgHandover      INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgHandover       Glb_cur_log_CMsgHandover  INIT_C (Glb_cur_log_buffer);
#endif
#ifdef DAPI
GLOBAL CGTEmisores        Glb_cur_CGTEmisores       INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTComitentes      Glb_cur_CGTComitentes     INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTFiduciarios     Glb_cur_CGTFiduciarios    INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTEmployee        Glb_cur_CGTEmployee       INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTEsquema         Glb_cur_CGTEsquema        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTSubComitente    Glb_cur_CGTSubComitente   INIT_C (Glb_cur_msg_buffer);
#endif

#ifdef DMEAPP
GLOBAL CGTVoiceGroup      Glb_cur_voicegroup        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTInsPerm         Glb_cur_insperm_msg       INIT_C (Glb_cur_msg_buffer);  

GLOBAL CGTHistoryTransDayMem
                          Glb_cur_thistorytransdaymem
                                                    INIT_C (Glb_cur_msg_buffer);  
GLOBAL CMsgEqOffLine      Glb_cur_eq_offline        INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgConfigCredit   Glb_cur_cfg_credit_msg    INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgOneCfgCredit   Glb_cur_onecfgcredit_msg  INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgCupoG          Glb_cur_CMsgCupoG         INIT_C (Glb_cur_msg_buffer);

GLOBAL CMsgCupoL          Glb_cur_CMsgCupoL         INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgCupoXPL        Glb_cur_CMsgCuposXPL      INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgLimInstit      Glb_cur_CMsgLimInstit_msg INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgPendCobranzas  Glb_cur_CMsgPendCobranzas_msg     
                                                    INIT_C (Glb_cur_msg_buffer);

GLOBAL CMsgCreditAdm      Glb_cur_creditadm_msg     INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgFactRiesgo     Glb_cur_CMsgFactRiesgo    INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgNmChkPlz       Glb_cur_nmchkplz_msg      INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgDelDeferred    Glb_cur_del_def_msg       INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgVoiceTerm      Glb_cur_voiceterm_msg     INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgCommandHistory Glb_cur_cmd_history_msg   INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTBridge          Glb_cur_bridge_msg        INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgBridge         Glb_CMsgBridge            INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTIndicatives     Glb_cur_indicatives_msg   INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgIndicatives    Glb_cur_CMsgIndicatives   INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgSpot           Glb_cur_CMsgSpot          INIT_C (Glb_cur_msg_buffer);

GLOBAL CGTConfCupos       G_cur_CGTConfCupos        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTCuposL          G_cur_CGTCuposL           INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTFactRiesgo      G_cur_CGTFactRiesgo       INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTLimInstit       G_cur_CGTLimInstit        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTMarketSpotPrices 
                          G_cur_CGTMarketSpotPrices INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTPendCobranzas   G_cur_CGTPendCobranzas    INIT_C (Glb_cur_msg_buffer);

GLOBAL CGTCuposXPL        G_cur_CGTCuposXPL         INIT_C (Glb_cur_msg_buffer);

GLOBAL CGTCuposXDIA       G_cur_CGTCuposXDIA        INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgFixPrice       G_cur_CMsgFixPrice        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTCompartCupos    G_cur_CGTCompartCupos     INIT_C (Glb_cur_msg_buffer);

#endif

#if DMEAPP || DAPI
GLOBAL CGTConnUser        Glb_cur_connuser          INIT_C (Glb_cur_msg_buffer);
#endif

#if DMEAPP || DMDIAPP
GLOBAL CMsgRBridge      Glb_CMsgRBridge             INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgCmdBridge    Glb_CMsgCmdBridge           INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgCmdBridge    Glb_log_CMsgCmdBridge       INIT_C (Glb_cur_log_buffer);
#endif

#ifdef DMDIAPP
GLOBAL CMsgUserLoginBridge   Glb_CMsgUserLoginBridge    INIT_C (Glb_cur_msg_buffer);
#endif

#ifdef DMEAPP
GLOBAL struct tm        Glb_Last_Daily_Process    INIT_B (0);
GLOBAL struct tm        Glb_Last_Daily_Pr_Conn    INIT_B (0);
GLOBAL int              Glb_Log_Starting_Flag;
#endif

#if (!DAPI && !DMDIAPP)
GLOBAL CGTCurrency      Glb_cur_currency          INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTNamecheck     Glb_cur_namecheck         INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTNmChkPlz      Glb_cur_CGTNmChkPlz       INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTTerm          Glb_cur_term              INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTSummary       Glb_cur_summary           INIT_C (Glb_cur_msg_buffer);
#ifdef GDIAPP
GLOBAL CGTSummaryRF     Glb_cur_summaryrf         INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTSummaryFI     Glb_cur_summaryfi         INIT_C (Glb_cur_msg_buffer);
#endif

GLOBAL CGTStatistics    Glb_cur_statistics        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTSpot          Glb_cur_spot              INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTCashRate      Glb_cur_cashrate          INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTIncrements    Glb_cur_increments        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTOvernight     Glb_cur_overnight         INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTDMEConnected  Glb_cur_dmeconnected      INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTPInsDme       Glb_cur_pinsdme           INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTSuperGroup    Glb_cur_supergroup        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTVoiceTerm     Glb_cur_voice_term        INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgFinalPending Glb_cur_finalpending_msg  INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgTradeNeg     Glb_cur_tradeneg_msg      INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgTextTradeNeg Glb_cur_texttradeneg_msg  INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgPolicyCredit Glb_cur_pol_credit_msg    INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgOnePlcCredit Glb_cur_oneplccredit_msg  INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgETCResponse  Glb_cur_etcresp_msg       INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgAllCrpoliNotification 
                        Glb_cur_allcrpolinotification
                                                  INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgPInsDme      Glb_cur_pinsdme_msg       INIT_C (Glb_cur_msg_buffer);

GLOBAL CGTMarkets       Glb_cur_markets_msg       INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTBranchNum     Glb_cur_branchnum_msg     INIT_C (Glb_cur_msg_buffer);

GLOBAL CGTInstNum       Glb_cur_institnum         INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgOrder        Glb_tmp_order_msg         INIT_C (NOT_USE_TRANSACTION);
GLOBAL CGTCcyPair       G_cur_ccypair             INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTIndicativesMark
                        G_cur_CGTIndicativesMark  INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTConnDmServer  G_cur_conndmserver        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTHoliday       G_cur_holiday             INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTRFQRequest    G_cur_rfqrequest          INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgRFQRequest   G_cur_rfqrequest_msg      INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgRFQUpdate    G_cur_rfqsupdate_msg      INIT_C (Glb_cur_msg_buffer);
GLOBAL CMsgOrder        G_cur_rfqreply_msg        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTCobranzas     G_cur_CGTCobranzas        INIT_C (Glb_cur_msg_buffer);
GLOBAL CGTBuyAverPrice  G_cur_CGTBuyAverPrice     INIT_C (Glb_cur_msg_buffer);
//GLOBAL CGTCConfirmPend  G_cur_CGTCConfirmPend     INIT_C (Glb_cur_msg_buffer);

CGTMarkets *COMMON_Get_Market_Record_From_Spot_Record  (CGTSpot *cur_CGTSpot);
CGTSpot *COMMON_Get_Spot_Record_From_Currencies (const char *currency1, const char *currency2);

int    DME_Main_Process_Order_Insertion (CMsgOrder  *order_msg, 
                                         int         check_etc_response,
                                         int         check_find_and_trade);
void   DME_Send_NO_Transaction_Message  (CMsgOrder *msg_to_send);
void   DME_Send_NO_Processed_Message    (CMsgOrder *msg_to_send, const char *reason);

void   COMMON_Send_AllCrpoliNotification(const char        *flag_ptr, 
                                         int                market_num,
                                         CDestinationsList *msg_dsts);
#ifdef DMEAPP
void   COMMON_Get_Market_Precision_Scale (int          num_market, 
                                          CALC_MNUM   *market_point_precision,
                                          CALC_MNUM   *market_price_scale); 
#endif

#ifdef DMEAPP
void   DME_Execute_Del_Def_Ord          ( CPriceOrderKey  *order_key2_lower, 
                                          CPriceOrderKey  *order_key2_upper,
                                          CMessage        *order_msg);
int    DME_Check_Deferred_Orders        ( CPriceOrderKey  *low_CPriceOrderKey, 
                                          CPriceOrderKey  *upp_CPriceOrderKey,
                                          CGTOrder        *order_msg);
void   DME_Check_Valid_Trading_Rights_Orders (CGTOrder *Cur_CGTOrder);

void   DME_Write_SLog                   ( const char *text_format, ...);

void   COMMON_Send_ETC_Response        (CMessage   *msg_generated, 
                                        int         msg_type, 
                                        const char *response_flag,
                                        int         cur_number_response   = 0,
                                        int         total_number_response = 0);
int    COMMON_Check_Valid_Destinations (CDestinationsList *msg_destinations);
void   COMMON_Print_CRPOLI_Counters    (FILE *file_output = NULL);
void   COMMON_Print_CRPOLI_Check_Records_Created (FILE *file_output = NULL);

void   COMMON_Send_Command_History_Msg (CMessage *source_msg, int processed_result);
#endif

#define COMMON_USE_DEFAULT_DESTINATIONS   (CDestinationsList *)NULL
#define COMMON_USE_DEFAULT_LOG_TEXT       (const char *)NULL
#define COMMON_USE_DEFAULT_PRIORITY       0
#define COMMON_USE_DEFAULT_ETC_USER       (const char *)NULL

#define COMMON_SET_THIS_TIME              0
#define COMMON_DO_NOT_SET_TIME            1

void   COMMON_Put_Message_In_Send_Queue(CMessage *msg_to_send, 
                                        int flag_recipients, 
                                        CDestinationsList *msg_dsts, 
                                        int         msg_priority,
                                        const char *log_msg_text,
#if DMEAPP || GDIAPP
                                        const char *etc_user_code   = COMMON_USE_DEFAULT_ETC_USER,
#else
                                        const char *etc_user_code,  // In DGI, this argument is not optional
#endif
                                        const char *branch_code = (const char *)NULL,
                                        int         set_time = COMMON_SET_THIS_TIME);



int    COMMON_Build_Tradenegotiation_Dest_List(CMsgTradeNeg *msg_tradeneg, char (*dest_arr_ptr)[4], int flag_recipients = 0);
int    COMMON_Build_TextTradenegotiation_Dest_List(CMsgTextTradeNeg *msg_texttradeneg, char (*dest_arr_ptr)[4]);

#endif //  no DAPI

#endif //supergus

#ifdef _ARRM_H_

GLOBAL CMss_Arr Glb_Send_Mss INIT_CS (INITIAL_CONN_MESSAGES_NUMBER,MESSAGE_TRANS_RECORD_SIZE);
GLOBAL CMss_Arr Glb_Recv_Mss INIT_CS (INITIAL_CONN_MESSAGES_NUMBER,MESSAGE_TRANS_RECORD_SIZE);
GLOBAL CMss_Arr Glb_Log_Mss  INIT_CS (INITIAL_CONN_MESSAGES_NUMBER,MESSAGE_TRANS_RECORD_SIZE);
#ifdef DGIAPP
GLOBAL CMss_Arr Glb_TEST_GTN_Recv_Mss INIT_CS (INITIAL_CONN_MESSAGES_NUMBER,MESSAGE_TRANS_RECORD_SIZE);
#endif

#endif

GLOBAL int  glb_ME_test;
GLOBAL char Glb_ME_test_mode_str[128];
GLOBAL int  glb_ME_test_compression;
GLOBAL int  glb_DGI_test;
GLOBAL int  glb_BitAcc_test;

GLOBAL int  glb_SendSubs_test;
GLOBAL int  glb_SendPolicy_test;  

GLOBAL int  glb_cfgcredit_test;

GLOBAL int  glb_cupo_test;

GLOBAL int  glb_use_dlog INIT(0);

// Se guarda la fecha y hora en que arranc el dme y dgi
GLOBAL char  Glb_beggining_time[255];

// Se guarda la fecha y hora en que arranc el dmdi
GLOBAL char  Glb_beggining_time_dmdi[MAX_LINECHARS];

// Se guarda la fecha y hora en que el gtn se conect.
GLOBAL char  Glb_time_conn_disconn_gtn [MAX_LINECHARS];

// PARA DGI

#ifndef DAPI
GLOBAL char *Glb_imm_pfix INIT((char *)"IMM");
#endif

#ifdef __TABLE_H__
GLOBAL CTableList    glb_common_empty_table_list;
#ifdef DMEAPP
GLOBAL CTableList    glb_ctbridge_table_list;
#endif
#endif

#ifdef DGIAPP
#include "dgi/dgi.h"
#elif DMEAPP
#include "tblequiv.h"
#include "dme.h"
#elif GDIAPP
#include "tblequiv.h"
#include "gdi.h"
#endif


#if USE_LINUX || USE_SOLARIS
#define stricmp                     strcasecmp
#define _stricmp                    strcasecmp
#define strnicmp                    strncasecmp
#define _strnicmp                   strncasecmp
#define _mkdir(a)                   mkdir(a, 0755)
#define _S_IFDIR                    S_IFDIR
#define _fullpath(a,b,c)            realpath(b,a)
#define _chdir(a)                   chdir(a)
#endif

// DME values.
#define ME_ALONE_ONE_THREAD    1
#define ME_ALONE_MULTITHREAD   2
#define ME_TO_ME               4
#define ME_TO_DS               8
// DGI values.
#define DGI_CHECK_DMERCV       16   // This value is used also in DME to get connected to DGI.
#define DGI_TO_DME             32
#define DGI_PROCESS_DMERCV     64
#define DGI_GTNSND             128
#define DGI_GTNSND_REAL        256
#define DGI_GTNSND_REAL_RECEIVE             512
#define DGI_GTNSND_REAL_RECEIVE_RESPONSE    1024

// DME combined values.
#define ME_ALONE               (ME_ALONE_ONE_THREAD | ME_ALONE_MULTITHREAD)
#define ME_CONNECTED           (ME_TO_ME | ME_TO_DS)
#define ME_ALONE_MULTITHREAD_TO_DGI             (ME_ALONE_MULTITHREAD | DGI_TO_DME)

// DGI combined values.
#define DGI_ALONE_MULTITHREAD                   ME_ALONE_MULTITHREAD
#define DGI_TO_DME_DMERCV                       (DGI_TO_DME | DGI_CHECK_DMERCV)
#define DGI_TO_DME_DMERCV_PROCESS               (DGI_TO_DME | DGI_CHECK_DMERCV | DGI_PROCESS_DMERCV)
#define DGI_TO_DME_DMERCV_PROCESS_GTNSND        (DGI_TO_DME | DGI_CHECK_DMERCV | DGI_PROCESS_DMERCV | DGI_GTNSND)
#define DGI_TO_DME_DMERCV_GTNSND                (DGI_TO_DME | DGI_CHECK_DMERCV | DGI_GTNSND)
#define DGI_TO_DME_DMERCV_PROCESS_GTNSND_REAL   (DGI_TO_DME | DGI_CHECK_DMERCV | DGI_PROCESS_DMERCV | DGI_GTNSND | DGI_GTNSND_REAL)
#define DGI_TO_DME_DMERCV_PROCESS_GTNSND_REAL_RECEIVE             (DGI_TO_DME | DGI_CHECK_DMERCV | DGI_PROCESS_DMERCV | DGI_GTNSND | DGI_GTNSND_REAL | DGI_GTNSND_REAL_RECEIVE)
#define DGI_TO_DME_DMERCV_PROCESS_GTNSND_REAL_RECEIVE_RESPONSE    (DGI_TO_DME | DGI_CHECK_DMERCV | DGI_PROCESS_DMERCV | DGI_GTNSND | DGI_GTNSND_REAL | DGI_GTNSND_REAL_RECEIVE | DGI_GTNSND_REAL_RECEIVE_RESPONSE)


#define DATE_STR_LEN                8
#define HOUR_STR_LEN                6

#undef GLOBAL
#undef INIT
#undef INIT_C
#undef INIT_CS

#ifdef DLOG
}
using namespace _DLOG_;
#endif



#endif //#ifndef __GLOBAL_H__
