//
// lsock.h : Heading of DAsyncSocket class, this class implements Linux Sockets for DTCP
//


typedef unsigned short     USHORT;
typedef unsigned long      ULONG;

#ifndef WIN32
typedef struct sockaddr    SOCKADDR;
typedef struct sockaddr_in SOCKADDR_IN;

#ifndef  TRUE
#define TRUE          true
#define FALSE         false
#endif


#define SOCKET_ERROR  -1

#define WSAEWOULDBLOCK EAGAIN
#define WSAEINPROGRESS EINPROGRESS

#endif

#ifdef NO_OPENSSL
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/evp.h>
#include <openssl/x509.h>
#include <openssl/x509_vfy.h>
#endif 

#ifdef DLOG
namespace _DLOG_ {
#endif

class DAsyncSocket
{

public:
            DAsyncSocket ();
virtual     ~DAsyncSocket ();

          int  Create          (int tcp_port, int use_ssl);
          int  Listen          (void);

          int  Accept          (DAsyncSocket &new_conn, SOCKADDR *m_saddr, int *sa_len);
virtual  void  OnAccept        ( int nErrorCode );
          int  GetSockName     (SOCKADDR *saddr, int *len);
          int  Connect         (char *servname, int hostport);
virtual  void  OnSend          (int nErrorCode);
virtual  void  OnConnect       (int nErrorCode);
virtual  void  OnClose         (int nErrorCode);
         int   ShutDown        (int nHow);
         int   Close           (void);

         int   Receive         (void *ptr, int maxlen);
         int   Send            (void *info_to_send, int info_len);

         int   get_socketssl    (void);
         int   get_pending      (void);

virtual  void  OnReceive       ( int nErrorCode );
         int   GetLastError    (void);
         void  GetPeerName     (char *rem_ip,  USHORT &rem_port);
         void  GetSockName     (char *this_ip, USHORT &this_port);
         void   Sock_Check      (void);
         SOCKET Get_Sockfd      (void) {return sockfd;}
         int   SetConnSSL      (void);

private:
        int port;
        SOCKET sockfd;
        SOCKET newfd;
        int wstate;
        int accepted;
        #ifdef NO_OPENSSL
        SSL *ssl;
        #endif 
        int socketssl;

        struct sockaddr_in their_addr; /* connector's address information */

        int CouldSend          (void);
        int AnyError           (void);
        int CouldReceive       (void);
        int SockErr            (void);
};

#ifdef DLOG
}
using namespace _DLOG_;
#endif

