// Wsock.h : Encabezado para definir Socket Asincrnico para DF
//

#define LOW_LIMIT_SIZE_USE_COMPRESS     1024
#define HIGH_LIMIT_SIZE_USE_COMPRESS    2048

#ifndef DWSOCK_DEFINED
#define DWSOCK_DEFINED

// 0= default ... se envia solo encryptada
#define SENDPKTENCRYPT     0
// 1= no encryptada
#define SENDPKTNORMAL      1
// 2= comprimida sin importar con que algoritmo dse comprime
#define SENDPKTCOMPRESS    2
// 3 = Comprimida con cualquier algoritmo y encryptada
#define SENDPKTCOMYENCRYPT 3



#define TCP_NO_ERROR                   0
#define TCP_ERROR_MSG_TOO_LONG         1
#define TCP_ERROR_DRIVER_INIT          2
#define TCP_ERROR_BAD_N_CONN           3
#define TCP_ERROR_CANT_TCP_INIT        4
#define TCP_ERROR_CANT_DTCP_INIT       5
#define TCP_ERROR_CANT_OPEN_CONN       6
#define TCP_ERROR_CANT_CONNECT         7
#define TCP_ERROR_NOT_CONNECTION       8
#define TCP_ERROR_NO_READY_FOR_SEND    9
#define TCP_ERROR_CONN_EXIST          10
#define TCP_ERROR_NON_LOCAL_EQUIP     11
#define TCP_ERROR_CANT_CONECT_SAME    12
#define TCP_ERROR_INTERFACE_NUM       13
#define TCP_ERROR_NO_RECVED           14
#define TCP_ERROR_CLOSE_REMOTE        15
#define TCP_ERROR_CLOSE_LOCAL         16
#define TCP_ERROR_EXTRA_TIME          17
#define TCP_ERROR_OUT_EXTRA_TIME      18
#define TCP_ERROR_RECEIVE             19
#define TCP_ERROR_EXTRA_TIME_SEND     30
#define TCP_ERROR_OUT_EXTRA_TIME_SEND 31
#define TCP_ERROR_NO_MEMORY           32
#define TCP_ERROR_CANT_SSL_INIT       33
#define TCP_ERROR_CANT_SSL_CERT       34

/* Tipos de eventos de retorno de tcp */
#define TCP_STATUS_CLOSED_CONNECTION  20
#define TCP_STATUS_OPEN_CONNECTION    21
#define TCP_STATUS_PACKET_RECEIVED    22
#define TCP_STATUS_SEND_ERROR         23
#define TCP_STATUS_EVENT_BRIDGE       24
#define TCP_STATUS_TEST_RECEIVED      25
#define TCP_STATUS_FREE_PACKET_RECEIVED 26
#define TCP_SHUTTING_DOWN             27
#define TCP_CHANGE_REOPEN_LOG_FILE    28  // not used.
#define TCP_TICKING_MESSAGE           29
#define TCP_STATUS_LOG_PACKET         30
#define TCP_CHECK_LOG_AFTER_CONN      31  // not used.
#define TCP_STATUS_LOG_SENT_PACKET    32
#define TCP_FORCE_FILE_FLUSH          33
#define TCP_STATUS_LOG_TEXT           34
// GTN status connections. Used in DGI.
#define TCP_GTN_CONNECTION            35
#define TCP_GTN_DISCONNECTION         36
#define TCP_CLT_GTN_INT_REQ           37  // Client Interface Request
#define TCP_SRV_GTN_INT_REQ           38  // Server Interface Request
#define TCP_GTN_INT_REQ               39  // Common Interface Request

#ifdef DAPI
#define PRIMARY_TABLES_RECEIVED       140  
#endif

/* Test Event for getting initial test time */
#define TEST_INIT                     40  
#define TEST_END_ONE_LOOP       0xFFFF

#define TCP_BAD_DATA_RECEIVED         5000
#define TCP_BAD_CRYPTED_DATA_RECEIVED 5003
#define TCP_SEND_BUFFER_OVERFLOW      5001
#define TCP_BAD_PKT_LEN_RECEIVED      5002
#define TCP_CLOSE_LOG                 5010

#define TIME_SEND_EXPIRED         100  /* Tiempo de expiracion de Timeout de send */
#define TIME_SEND_EXPIRED_WARNING  40  /* Tiempo de expiracion de Timeout de send. Advierte */
#define TIME_CHK_CONNECTION        20  /* Tiempo de expiracion de Timeout de chequeo */
#define TIME_RCV_CONNECTION        60  /* Tiempo en el que se verifica si llego algo */

#define   TCP_MAX_BUF_CMP     5000  /* Maxima longitud de area de compresin */

#define   DTCP_MAX_BUF_LEN   60000  /* Maxima longitud de area para */
#define   TCP_MAX_BUF_LEN    60096  /* recibir mensaje menos de 2048 por */

#define MAX_SEND_INFO            DTCP_MAX_BUF_LEN

#define SEND_NO_ACTIVATED       0  /* conexion lista para enviar un mensaje */
#define READY_FOR_SEND          1  /* conexion lista para enviar un mensaje */
#define NO_READY_FOR_SEND       2  /* Conexion enviando mensaje */

#define CONN_NO_STATE           0  /* Conexion sin estado */
#define CONN_STATE_LISTENNING   1  /* Conexion escuchando */
#define CONN_STATE_OPENNING     2  /* Conexion abriendose */
#define CONN_STATE_OPENED       3  /* Conexion abierta */
#define CONN_STATE_LISTENED     4  /* Conexion abierta */
#define CONN_STATE_CLOSING      5  /* Conexion cerrandose */
#define CONN_STATE_DELETING     6  /* Conexion cerrandose */

#define MARCA_DTCC        "DTCC"
#define MARCA_DTCL        "DTCL"
#define MARCA_DTCR        "DTCR"
#define MARCA_DTPE        "DTPE"
// marca id para paquete comprimido RLE
#define MARCA_DTRC        "DTRC"
// marca id para paquete normal
#define MARCA_DTCP        "DTCP"
// marca id para paquete normal encryptado
#define MARCA_DTCE        "DTCE"
// marca id para paquete que se comprimio pero que su len es mayor al pkt original
#define MARCA_DTNE        "DTNE"
// marca id para paquete comprimido BSD
#define MARCA_DTBC        "DTBC"
// marca id para paquete comprimido BSD encryptado
#define MARCA_DTBE        "DTBE"
// marca id para paquete comprimido rlr encryptado
#define MARCA_DTRE        "DTRE"
// marca id para paquete normal pero que se intento comprimir BSD
#define MARCA_DTNC        "DTNC"
// marca id para paquete de test
#define MARCA_TEST        "TEST"

#define LEN_MARCA_DTCP    4
#define LEN_INIT_MSG      LEN_MARCA_DTCP + sizeof (short int)

#define DEFAULT_MODE_SEND     2 /*Compression by default*/

#include "arch.h"

#ifdef USE_UNIX_TCP
#  include <errno.h>
#  include <sys/types.h>
#  include <sys/socket.h>
#  include <syslog.h>
#  include <strings.h>
#  include <unistd.h>

typedef int SOCKET;
#define INVALID_SOCKET -1

#  ifdef USE_SOLARIS
#    include <sys/filio.h>
#  endif
#  include <sys/ioctl.h>
#  include <arpa/inet.h>
#  define Clean_Error()   errno=0
#  define Get_Error       errno
#  define ZeroMemory      bzero
#  define ioctlsocket     ioctl
#  define closesocket     close
#else
#  include <winsock2.h>
#  define Clean_Error()   WSASetLastError(0)
#  define Get_Error       WSAGetLastError()
#  define inet_aton       inet_addr
   typedef int socklen_t;       
#endif

#include "lsock.h"

#include "arrm.h"

#ifdef DLOG
namespace _DLOG_ {
#endif


class WSocket :public DAsyncSocket
{
public:
    WSocket ();
virtual ~WSocket ();

    bool   am_i            (unsigned int  fhost);
    int    AddRecToSend    (char *rec_data, unsigned short len);
    bool   IsReadyToSend   (unsigned short len);
    void   UpdateTime      (void);
    void   CancelExtraTime (void);
static unsigned int  SetTimeOut     (int extra_seconds);
    void   Control         (unsigned int  this_time);

virtual void  OnConnect       ( int nErrorCode );
virtual int   Connect         ( unsigned int  fh, USHORT nHostPort);
virtual void  OnClose         ( int nErrorCode );
virtual void  OnAccept        ( int nErrorCode );
        int   Listen          (void);
        int   GetState        (void);
short   int   SetExpireTime   (unsigned short time);
int           Init_fhost_myip (void);
unsigned int  Get_fhost     (void) {return fhost;}
unsigned int  Get_My_Ip     (void) {return my_ip;}
    void      DoClose       (int value);
    int       MssPending    (void) {return mss_pend;}
    void      Get_Free_Info (void);
    void      WaitForSend       (long seconds,  long mseconds);
    void      Compression_Test  (char *rec_data, unsigned short len);
    int       AdjustCompress (char *ptr_marca, char *ptr, unsigned short len);

    int         state;             /* Estado de la conexion */
    int         mss_pend;          /* flag tiene mensaje pendiente */
    int         m_compressed;      // use compressed connection
    const char *m_id;
    int         m_id_len;
    CMss_Arr   *m_Recv_Mss;
    CMss_Arr   *m_Send_Mss;
    CMss_Arr   *m_Log_Mss;
    unsigned int  num_msg_out;       /* Mensajes enviados por la conexion */
    unsigned int  num_msg_in;        /* Mensajes recibidos por la conexion */

    unsigned int  num_msg_chk_out;   /* Mensajes enviados de chequeo por la conexion */
    unsigned int  num_msg_chk_in;    /* Mensajes recibidos de chequeo por la conexion */

    unsigned int  num_msg_in_pending; /* Mensajes por recibir pendientes */
    // variable para controlar como se envia la informacion
    // setea modo de envio de mensajes ...  encryptado , normal , comprimido, comprimido-encryptado,
    // tendra efecto solo cuano el puerto no sea ssl. de lo contrario envia comprimido y luego ssl
    unsigned short mode_to_send;


protected:
    SOCKADDR    m_saddr; // informacin de la aceptacin de la conexin
    char        info_to_send [TCP_MAX_BUF_LEN];
    int         info_len;
    char        rem_ip[20];
    char        this_ip[20];
    USHORT      rem_port, this_port;
    int         m_last_error;
    int         rec_counter;

unsigned int    my_ip;
unsigned int    fhost;             /* IP del foreign host */
unsigned int    real_fhost;

    int         open_state;        /* Estado del open */
    int         report_state;      /* Estado del open reportado */
    int         test_state;        /* estado de test */
    int         no_send;           /* TRUE cuando no se pudo enviar este mensaje */
    int         extra_time_send;   /* TRUE cuando da tiempo extra para envio */
    int         extra_time_recv;   /* TRUE cuando da tiempo extra para recibir */
    int         flag_test;         /* TRUE si el mensaje que llega es de TEST */
    int         filler;            /* Relleno */
    int         do_close_last_reason;

    unsigned int   timeout_conn;      /* Para chequear si hay conexion */
    unsigned int   timeout_rcv;       /* Para ver si llego algo */
    unsigned int   timeout_snd;

    short    int   max_ticks_rcv;
    unsigned int   time_prev_rcv;     /* Momento de previa recepcion */

    short    int   max_ticks_send;
    unsigned int   time_prev_send;    /* Momento de previo envio */

    unsigned int   time_send_expired        ;
    unsigned int   time_send_expired_warning;
    unsigned int   time_chk_connection      ;
    unsigned int   time_rcv_connection      ;

    unsigned short noencrypt ;
    unsigned short nocompress ;
    unsigned short set_socket_special_send;

    /* Contadores de mensajes */
    void          *bsd_dbc,            // bsd pointer for compress db
                  *bsd_dbd;            // bsd pointer for decompress db

/*#ifdef DF
    int            no_ME_header;
    int            no_ME_header_msg_len;
#endif*/
    /* Informacion para mensajes de envio y recepcion */
    unsigned short len_to_recv;       /* Longitud del mensaje que esta recibiendo */
    unsigned short len_recved;        /* Longitud recibida de un mensaje */
#pragma pack (8)
    char           buff_recv   [TCP_MAX_BUF_LEN];  /* Buffer para recepcion */
    char           buff_comp   [TCP_MAX_BUF_CMP];  /* Buffer para compress */
    char           buff_dec    [TCP_MAX_BUF_LEN];  /* Buffer para decompress */
    unsigned char* ptr_alg8_buff_decom;            /* Puntero para recepcion alineado a 8*/
    unsigned char* ptr_alg8_buff_com;             /* Puntero para recepcion alineado a 8*/
    unsigned char* ptr_alg8_buff_recv;             /* Puntero para recepcion alineado a 8*/
#pragma pack ()

    void     TakeReceived    (void);
    void     ForceClose      (void);

virtual void OnReceive       ( int nErrorCode );
virtual void OnSend          ( int nErrorCode );

    void   DoCheckRcv          (void);
    void   DoCheckSend         (void);
    void   CancelExtraTimeSend (void);
    void   CancelExtraTimeRecv (void);

};

unsigned short  RLE_init          (unsigned short SourceSize);
unsigned short  RLE_Compression   (unsigned char *Source,unsigned char *Dest, unsigned short SourceSize);
unsigned short  RLE_Decompression (unsigned char *Source,unsigned char *Dest, unsigned short SourceSize);

#ifdef DLOG
}
using namespace _DLOG_;
#endif

#endif
