//////////////////////////////////////////////////////////////////////////////
// flddescr.h
//
// Definitions generated by dictgen.
//////////////////////////////////////////////////////////////////////////////


#ifndef __FLDDESCR_H__
#define __FLDDESCR_H__

#define DATA_INSERT           "I"
#define DATA_DELETE           "B"
#define DATA_UPDATE           "A"
#define DATA_REBUILD          "R"
#define DATA_COPY             "C"
#define DATA_CLOSE            "D"
#define DATA_RANGE            "g"
#define DATA_UPDATE_COPY      "U"
#define DATA_INSCRIPTION      "S"
#define DATA_END_TRANS        "z"

#define DATA_INSERT_CHAR      ((int)'I')
#define DATA_DELETE_CHAR      ((int)'B')
#define DATA_UPDATE_CHAR      ((int)'A')
#define DATA_REBUILD_CHAR     ((int)'R')
#define DATA_COPY_CHAR        ((int)'C')
#define DATA_CLOSE_CHAR       ((int)'D')
#define DATA_RANGE_CHAR       ((int)'g')
#define DATA_UPDATE_COPY_CHAR ((int)'U')
#define DATA_INSCRIPTION_CHAR ((int)'S')
#define DATA_END_TRANS_CHAR   ((int)'z')
#define DATA_UPDATED_SIGNAL   ((int)'t')

// ask to validate the hashing value of the table
#define DATA_HASH_QUERY       ((int)'Q')
// answer telling that the content of the table is correct
#define DATA_HASH_FINISHED    ((int)'Z')
// answer with hashing values of the records
#define DATA_HASH_ANSWER      ((int)'H')
// last answer with hashing values of the records
#define DATA_HASH_LAST_ANSWER ((int)'L')
// ask for the records with these hash values
#define DATA_HASH_ASK         ((int)'N')
// last ask for the records with these hash values
#define DATA_HASH_LAST_ASK    ((int)'P')

// ETC OCO group of orders always use the same group id. A different id
// from any used by Datatec users.
#define ETC_UNIQUE_OCO_GROUP_ID       "G$"

#define DFN_ETC_LOGIN_NAME_LEN        16

#define TRANSACTION_RECORD_SAVE_SIZE  500 // this also used to assure the records buffer
#define MESSAGE_RECORD_SIZE           2800
#define MESSAGE_TRANS_RECORD_SIZE     3300
#define MESSAGE_EXTRA_ALLOCATED_SIZE  100
#define MESSAGE_EXTRA_USED_SIZE        20  // please increase this value as you locate more variables after the dfn message

#define CHECK_NAME_RECORD_SIZE        500
#define CUPOS_RECORD_SIZE             500
// this log header includes the text, hour, etc, etc
#define LOG_HEADER_SIZE               120

#define ORDER_KEY_SIZE                100
#define CHECK_NAME_KEY_SIZE           100
#define CUPOS_KEY_SIZE                100

#define FLD_SHORT                     1
#define FLD_UNSIGNED_SHORT            2
#define FLD_UNSIGNED_INT              3
#define FLD_NUM_ASCII_INT             4
#define FLD_NUM_ASCII_DOUBLE          5
#define FLD_ALPHA                     6
#define FLD_INT                       7
#define FLD_DATE                      8

#define FLD_ALPHA_TYPE_STRING         10 // ensures not composite field, and a null terminates the string
#define _S_                           FLD_ALPHA_TYPE_STRING


#define GENERIC_DESTINATATION_LEN     150

/*--------- Definiciones para tipos de campos ---------*/
/* OJO!! Si se cambia estos numeros, cambiar tambien, por favor el automata */
/* en la definicion del tipo de la variable de retorno */

#define FLD_TYP_INT_BYTE           1   /* Entero con un byte */
#define FLD_TYP_NUM_INT_UNSIGNED   2
#define FLD_TYP_NUM_INT_SIGNED     3
#define FLD_TYP_NUM_LONG_UNSIGNED  4
#define FLD_TYP_NUM_LONG_SIGNED    5
#define FLD_TYP_NUM_REAL           6
#define FLD_TYP_NUM_DOUBLE         7
#define FLD_TYP_NUM_BCD_UNSIGNED   8
#define FLD_TYP_NUM_BCD_SIGNED     9
#define FLD_TYP_NUM               10
#define FLD_TYP_ABT               11
#define FLD_TYP_ANM               12
#define FLD_TYP_FCH               13
#define FLD_TYP_HOR               14
#define FLD_TYP_SCREEN_OBJ        15
#define FLD_TYP_CURSOR            16
#define FLD_KEY_TYPE              17   /* Clave */
#define FLD_REC_TYPE              18   /* Variable, memoria o archivo */
#define FLD_SET_TYPE              19   /* Variable, memoria o archivo */
#define FLD_FIL_TYPE              20   /* Archivo */
#define FLD_GRP_TYPE              21   /* Grupo */
#define MAX_FLD_TYPES             21   /* Tipos de datos */

#define MAX_BRIDGE_COMMAND_LEN    512

#define MAX_KEY_LEN              256

// Currently, two languages are supported.
#define DFN_LANGUAGES_SUPPORT      2
#define DFN_SPANISH                0
#define DFN_ENGLISH                1

// Calclib defines
#define     COMMON_CALC_INT                 16
#define     COMMON_CALC_DEC                 8
#define     COMMON_CALC_SIZE                ((COMMON_CALC_INT + 3)/4 + (COMMON_CALC_DEC + 4)/4+2)
#define     DFN_MAX_NUM_ASCII_DOUBLE_LEN    (COMMON_CALC_INT + COMMON_CALC_DEC + 2)  // sign and decimal point
// Total size in bytes of a CALC_MNUM array that uses the max digits.
#define     CALC_TOTAL_BYTES_MXDIGITS       COMMON_CALC_SIZE*sizeof(CALC_MNUM)
#define     COMMON_CALC_NUM_DIG             ((COMMON_CALC_INT + 3)/4 + (COMMON_CALC_DEC + 4)/4)



#define BCLEN                      8
#define ICLEN                      4
#define DFN_TRADE_AMOUNT_LEN       16
#define DFN_TRADE_AMOUNT_DECIMALS  2
#define DFN_NEAR_AMOUNT_LEN        13
#define DFN_NEAR_AMOUNT_DECIMALS   2
#define DFN_INTEREST_RATE_LEN      10
#define DFN_INTEREST_RATE_DECIMALS 4
#define DFN_TRADE_AMOUNT_INTEGERS  DFN_TRADE_AMOUNT_LEN - DFN_TRADE_AMOUNT_DECIMALS
#define DFN_AMOUNT_LEN             13
#define DFN_AMOUNT_DECIMALS        0
#define DFN_AMOUNT_INTEGERS        DFN_AMOUNT_LEN - DFN_AMOUNT_DECIMALS
#define DFN_DEF_POINTS_LEN         10
#define DFN_DEF_POINTS_DECIMALS    4
#define DFN_PRICE_LEN              19
#define DFN_PRICE_DECIMALS         4
#define DFN_SPOT_PRICE_LEN         14
#define DFN_SPOT_PRICE_DECIMALS    8
#define DFN_USER_CODE_LEN          4
#define DFN_DATASERVER_CODE_LEN    2
#define DFN_ORDER_CODE_LEN         10
#define DFN_MAX_NUM_PENDING_ORDERS 99
#define DFN_C_V_LEN                1
#define DFN_TRADE_CODE_LEN         30
#define DFN_MARKET_LEN             3
#define DFN_NUMERAL_SIZE           2
#define DFN_FECHA_VENCIMIENTO_LEN  8
#define DFN_XDIAS_LEN              2
#define DFN_DIAS_LEN               2
#define DFN_TEXTO_LEN              10
#define DFN_INDICATIVE_KEY_LEN     (DFN_MARKET_LEN + DFN_TEXTO_LEN + DFN_LEVEL_LEN + DFN_FECHA_VENCIMIENTO_LEN + DFN_XDIAS_LEN + DFN_DIAS_LEN) 
#define DFN_LEVEL_LEN              1
#define DFN_USHORT_LEN             2
#define DFN_DATE_LEN               8
#define DFN_HOUR_LEN               6
#define DFN_CURRENCY_LEN           3
#define DFN_FLAG_LEN               1
#define DFN_COUNTRY_CODE_LEN       2
#define DFN_CUSTOMER_NUMBER_LEN    4
#define DFN_TEXT_TERM_LEN          10
#define DFN_SHORT_VAR_LEN          2
#define DFN_ORDER_GROUP_ID_LEN     2
#define DFN_CCYPAIR_LEN            DFN_CURRENCY_LEN*2
#define DFN_CASHRATE_LEN           10
#define DFN_CITYNAME_LEN           20
#define DFN_GROUP_CODE_LEN         8
#define DFN_BRANCH_CODE_LEN        8
#define DFN_INSTIT_CODE_LEN        4
#define DFN_4C_LEN                 4
#define DFN_1C_LEN                 1
#define DFN_2C_LEN                 2
#define DFN_3C_LEN                 3
#define DFN_3C_CURR_LEN            3
#define DFN_CODIGO_ICAP_LEN        11
#define DFN_CODIGO_GUIBOS_LEN      11
#define DFN_CODIGO_GUIBOS_PAIR_LEN  9
#define DFN_ESTADO_BRIDGE_LEN      10
#define DFN_CODIGO_PAIR_LEN        8
#define DFN_SYMBOL_BRIDGE_LEN      30
#define EXTRA_SYMBOL_LEN          (DFN_SYMBOL_BRIDGE_LEN + 20)
#define DFN_PU_CODE_LEN            DFN_4C_LEN
#define DFN_BRANCH_4C_CODE_LEN     DFN_4C_LEN
#define DFN_BRANCH_NAME            50
#define DFN_USER_SHORT_NAME_LEN    10
#define DFN_USER_NAME_LEN          30
#define DFN_NUM_BRANCHES_ARRAY_RFQREQUEST       68
#define DFN_BRANCHES_ARRAY_RFQREQUEST_LEN       (DFN_NUM_BRANCHES_ARRAY_RFQREQUEST*DFN_BRANCH_CODE_LEN)
#define DFN_BRANCHES_4C_ARRAY_RFQREQUEST_LEN    (DFN_NUM_BRANCHES_ARRAY_RFQREQUEST*DFN_BRANCH_4C_CODE_LEN)
#define DFN_POLITICCREDIT_ARRAY_SIZE            1500
#define DFN_POLITICCREDIT_ARRAY_GROUP           3
#define DFN_DOBLECURRENCY_LEN      7
#define DFN_BRIDGE_SEND_RECV_FLAG  1
#define DFN_BRIDGE_BANDERA_TIPO    1
#define DFN_BRIDGE_SEQUENCE_LEN    2
#define DFN_BRIDGE_KEY_LEN         (DFN_MARKET_LEN +DFN_CURRENCY_LEN +DFN_DOBLECURRENCY_LEN +DFN_BRIDGE_SEND_RECV_FLAG +DFN_BRIDGE_BANDERA_TIPO+DFN_BRIDGE_SEQUENCE_LEN)
#define DFN_COUNTERBRIDGE_KEY_LEN  (DFN_MARKET_LEN +DFN_CURRENCY_LEN +DFN_DOBLECURRENCY_LEN +DFN_BRIDGE_BANDERA_TIPO +DFN_1C_LEN +DFN_BRIDGE_SEQUENCE_LEN) 
#define DFN_BRIDGE_SYM_LEN         30
#define DFN_BRIDGE_PROD_LEN        30
#define DFN_BRIDGE_CLAVE_LEN       17
#define DFN_BRIDGE_SYM_KEY_LEN     (DFN_BRIDGE_PROD_LEN + DFN_BRIDGE_SYM_LEN + DFN_BRIDGE_CLAVE_LEN)
#define DFN_PROD_TERM_BRIDGE_KEY_LEN (DFN_BRIDGE_PROD_LEN + DFN_MARKET_LEN + DFN_TEXT_TERM_LEN + DFN_SYMBOL_BRIDGE_LEN)
#define DFN_BANDERA_LEN            1

#define DFN_MAX_ELEMENTS_POLITICCREDIT_ARRAY    ((DFN_POLITICCREDIT_ARRAY_SIZE*8)/DFN_POLITICCREDIT_ARRAY_GROUP)-1  //each byte 8 bits grouped in 3 bytes.

#define DFN_ETC_KEY_LEN            (DFN_MARKET_LEN + DFN_LEVEL_LEN + DFN_DATE_LEN + DFN_XDIAS_LEN + DFN_DIAS_LEN + DFN_TEXTO_LEN) 

#define BRIDGE_STATUS_DISCONNECTED 1
#define BRIDGE_STATUS_TRYING       2
#define BRIDGE_STATUS_CONNECTED    3

#define BR_ORDER_SEND_DATA         'S'
#define BR_ORDER_SEND_CONNECT      'C'
#define BR_ORDER_SEND_DISCONNECT   'F'
#define BR_ORDER_RECV_CONNECT      'R'
#define BR_ORDER_RECV_DISCONNECT   'D'

#define BR_ORDER_SEND_DATA_STR         "S"
#define BR_ORDER_SEND_CONNECT_STR      "C"
#define BR_ORDER_SEND_DISCONNECT_STR   "F"
#define BR_ORDER_RECV_CONNECT_STR      "R"
#define BR_ORDER_RECV_DISCONNECT_STR   "D"

// Mensajes que sirven para evaluar si se realizn las
// acciones de conexin o desconexin.
#define BR_ORDER_SEND_CONNECTED          'C'
#define BR_ORDER_SEND_DISCONNECTED       'U'
#define BR_ORDER_RECV_CONNECTED          'A'
#define BR_ORDER_RECV_DISCONNECTED       'D'

#define BR_ORDER_SEND_CONNECTED_STR      "C"
#define BR_ORDER_SEND_DISCONNECTED_STR   "U"
#define BR_ORDER_RECV_CONNECTED_STR      "A"
#define BR_ORDER_RECV_DISCONNECTED_STR   "D"


#define INDIC_TENDENCIA_IGUAL        1
#define INDIC_TENDENCIA_NO_CAMBIA    2
#define INDIC_TENDENCIA_SUBE         4
#define INDIC_TENDENCIA_BAJA         5
  
// Definitions for spot prices rounding decimals.
#define DFN_THREE_ROUND_SPOT_PRICE_LENGTH       8   // 999.9999
#define DFN_DEFAULT_ROUND_SPOT_PRICE_LENGTH     7   // 99.9999
#define DFN_DEFAULT_ROUND_SPOT_PRICE_DECIMALS   4   // 99.9999
#define DFN_TWO_ROUND_SPOT_PRICE_LENGTH         6   // 999.99
#define DFN_TWO_ROUND_SPOT_PRICE_DECIMALS       2   // 999.99

#define DFN_TWO_ROUND_SPOT_PRICE_DECIMALS_THREE 3   // 99.999

// Defines used by DFN for statistics price tendency.
#define DFN_STATISTICS_SAME_TENDENCY    1
#define DFN_STATISTICS_UP_TENDENCY      4
#define DFN_STATISTICS_DOWN_TENDENCY    5

// Indexes for special institutions. (BANDERA_INSTITUCION_ESPECIAL_INSTITUCION == "S")
// FUNCION_INSTITUCION[]. In DFN, indexes begin in 1.
#define DFN_BVQ_INSTIT_INDEX            3   //; [4]  - Corro BVQ
#define DFN_SEMIBLIND_INSTIT_INDEX      8   //; [9]  - Ver/mostrar codigo en semiciegos

#ifdef DAPI
#define MAX_REFERENCED_FIELDS_IN_A_MESSAGE  1200
#else
#define MAX_REFERENCED_FIELDS_IN_A_MESSAGE   250
#endif

// Total lenght of cities' names in branches global table.
#define DFN_CITIES_NAME_LEN           DFN_CITYNAME_LEN*DFN_LANGUAGES_SUPPORT
// Offset for city name in English (In branches global table)
#define DFN_ENGLISH_CITYNAME_OFFSET   DFN_ENGLISH*DFN_CITYNAME_LEN

// Flag values for array of market operation permissions in user table.
#define DFN_USER_CANNOT_OPERATE       1
#define DFN_USER_CAN_OPERATE          2

#define ETC_CUSTOMER_DATA_LEN        16

#define _CIU_   1
#define _EMI_   2
#define _INS_   3
#define _MER_   4
#define _MON_   5
#define _PAI_   6
#define _PU__   7
#define _SUC_   8
#define _USU_   9
#define _VGR_   10
#define _SGR_   11
#define _INP_   12
#define _CMC_   13
#define _FIC_   14
#define _FIV_   15
#define _EMP_   16
#define _ESQ_   17
#define _CMV_   18
#define _SCM_   19
#define _CMP_   20
#define _CMT_   21
#define _CCP_   22
#define _USM_   23

typedef struct FIELD_EQUIVALENCE
{
    int field_id;
    int field_type;
    int field_reference; // reference to a table, used to access a secondary table
    int field_offset;
    int field_len;
    int field_decimal_len;
    int file_line;
    int end_pos;
    int has_offset;
} FIELD_EQUIVALENCE;

extern FIELD_EQUIVALENCE glb_field_equivalence[];

#pragma pack (1)

typedef struct CABEZA_DFN
{
//datos_para_dataserver alfanumerico 33 COMPUESTO POR
    // codigo_primaryuser                                  alfanumerico 4
    //; El codigo del primaryusers remitente
    char codigo_primaryuser[4];

    // bandera_mensaje_persistente       alfanumerico 1
    // ; S - indica que el mensaje es persistente
    char bandera_mensaje_persistente;
    // no_guardar_log_destinatarios             alfanumerico 1
    // ; S - Indica al DS que no debe grabar este mensaje en el log de los destinatarios
    char no_guardar_log_destinatarios;
    //guardar_log_remitente           alfanumerico 1
    //; S - Los mensajes enviados por el PU son guardados en el DS,
    //;     para que el PU pueda pedir los mensajes que l mismo envi.
    char guardar_log_remitente;
    //marca_procesado                 alfanumerico 1
    //; S - Indica que el PU que deba recibir este mensaje ya lo haba recibido
    //;     antes y ya lo haban procesado
    //; X - indica al DS que este mensaje podr ser marcado por los que reciban.
    char marca_procesado;
    //codigo_dataserver                   alfanumerico 2
    //; El cdigo del dataserver de donde viene el mensaje
    char codigo_dataserver[2];
    //numero_remitente                    entero sin signo
    //; El numero secuencial de este mensaje en la serie de mensajes enviados por
    //; este remitente a DATASERVERS
    unsigned int numero_remitente;
    //numero_dataserver                   entero sin signo
    //; El numero secuencial de este mensaje en la serie de mensajes enviados por
    //; DATASERVERS al destinatario
    unsigned int numero_dataserver;
    //log                                 alfabetico 1
    //; S - Es un mensaje que estaba grabado en un log
    char log;
    //usuario                             alfanumerico 4
    //; El codigo del usuario remitente
    char usuario[4];
    //hora                                hora 6
    //; La hora en que se envio este mensaje  hhmmss
    char hora[6];
    //fecha_alfanumerica alfanumerico 8 COMPUESTO POR
        //fecha                           fecha 8
        //; La fecha en que se envio este mensaje
    char fecha[8];
    //FIN
    int  milisegundo;
    char bandera_destinatarios[1];
    char bandera_tipo_horas[1];
    char hora_local_remitente[6];
    char relleno_1_cabeza[2];
//FIN

//;-------------------------------
//; Datos no usados por dataserver
//;-------------------------------
//datos_remitente alfanumerico 24 COMPUESTO POR
    //sucursal alfanumerico 8 COMPUESTO POR
    char sucursal[8];
        //codigo_institucion                              alfanumerico 4
        //ciudad                                          alfanumerico 3
        //agencia                                         alfanumerico 1
    //FIN
    //bandera_institucion_especial_remitente              alfabetico 1
    //; S - Esta institucin tiene un trabajo especial en el sistema
    char bandera_institucion_especial_remitente;
    //funcion_remitente                                   alfanumerico 1 [15]
    //; Una S en la posicin de acuerdo a la funcin e ndice
    //; [1]  - DataManager
    //; [2]  - BVGManager - Director de rueda de la BVG
    //; [3]  - DecevaleManager
    //; [4]  - DataStats
    //; [5]  - Pregoneros e intercambio con la BVG
    //; [6]  - Equipo en la rueda
    //; [7]  - Negociar sin cupos
    //; [8]  - Administrar cuentas
    //; [9]  - Ver/mostrar codigo en semiciegos
    //; [10] - Monusuarios inputer de Bolsa Mexicana de Valores
    //; [11] - Equipos en Decevale
    //; [12] - Institucin OTR para registros de transacciones
    char funcion_institucion_remitente[15];
    int  diezmilesima_local_remitente;
    //relleno_2_cabeza                alfanumerico 5
    char relleno_2_cabeza [1];
//FIN
}CABEZA_DFN;

#pragma pack ()

#define MSG_TYPE_GLOBALTABLE        1
#define MSG_TYPE_GLOBALTABLE_MSG    2
#define MSG_TYPE_MSG                3

#define MSS_ORDEN                   111     //; usuario      usuario
#define MSS_TRANS_MONEDA            112     //; from datamanager to conlombian feed dapi
#define MSS_ORDEN_3                 119     //; Same as MSS_ORDEN, used in some markets.
#define MSS_ORDEN_2                 121     //; Same as MSS_ORDEN, used in some markets.
#define MSS_LOG_ORDER_TABLE         114     //; Same as MSS_ORDEN, used for order table log.
#define MSS_FINALPENDING            116     //; PU           dme
#define MSS_GUIBOS                  133     //; DAPI   <-->   datamanager
#define MSS_GUIBOSWH                134     //; DAPI   <-->   datamanager
#define MSS_TABLA_GLOBAL            888     //; usuario      usuario
#define MSS_INGRESO_EQUIPO          201     //; primaryusers  datamanager
#define MSS_PEDIDO_LOG              203     //; primaryusers  dataserver
#define MSS_INICIO_LOG              204     //; dataserver    primaryusers
#define MSS_FIN_LOG                 205     //; dataserver    primaryusers
#define MSS_PEDIR_TABLAS            213     //; primaryusers  dataserver
#define MSS_FIN_PEDIR_TABLAS        214     //; primaryusers  dataserver
#define MSS_PEDIDO_SIGUIENTE_LOG    252     //; primaryusers  dataserver
#define MSS_LISTA_DATAMANAGERS      865     //; primaryusers  datamanager
#define MSS_END_TRANSACTION         879     //; mensaje de fin de transaccion
#define MSS_NAMECHECK                65     //; namecheck     datamanager
#define MSS_FACTRIESGO              151     //; primaryusers  primaryusers
#define MSG_NMCHKPLZ                152     //; namecheck ciertos plazos  datamanager
#define MSS_TRADENEGOTIATION        108     //MSS_ACUERDO_TRANSACCION
#define MSS_TEXTTRADENEGOTIATION    109     //MSS_TEXTO_TRANSACCION
#define MSS_TIME_CHECK              869     //; primary-users dataserver
#define MSS_ONECFGCREDIT            144     //; mensaje configuracion credito      PU  --> DME
#define MSS_ONEPLCCREDIT            145     //; mensaje politica credito           PU  --> DME
#define MSS_CUPOG                   146     //; mensaje cupo                       PU  --> DME
#define MSS_CREDITADM               167     //; mensaje configuracion name pending PU  --> DME
#define MSS_CONFIGCREDIT            148     //; mensaje configuracion credito      DME --> PU
#define MSS_POLITICCREDIT           149     //; mensaje politica credito           DME --> PU
#define MSS_RETIROEQUIPO            202     //  mensaje retiro equipo
#define MSS_DELDEFERRED             136
#define MSS_VOICETERM               262
#define MSS_PRCMNT_TRANS_HOY         87     //; mensaje con info de transaccion para hoy, dia, mes  
#define MSS_PRCMNT_HORA_HOY         176     //; mensaje de historia moneda
#define MSS_RFQSTATUS_UPDATE        308     //; mensaje para actualizar la matrix de RFQ

#ifdef DAPI
#define MSS_PRCMNT_TRANS_RENTA_FIJA 132     //; mensaje de mantenimiento transacciones de papeles
#define MSS_ORDEN_RFQ               113     //; mensaje igual que el MSS_ORDEN, used in RFQ's market
#define MSS_CHAT                    575     //; mensaje que el DASLINK utiliza para pasar los mensajes del CHAT a los PUs DAPI configurados para recibir esta informacin. 
#endif
#define MSS_PAY_INSTRUCTION         153     //; mensaje de instruccion de pago
#define MSS_COMMANDHISTORY          159     //; mensaje de instruccion de pago
#define MSS_ICAP                    256     //; PrimaryUser(User) DataStats
#define MSS_RONDA                   227     //; mensaje de convocatoria de ronda (RFQ request)
#define MSS_TABLA_MONEDA_DIRECTO    113     //; mensaje para contraofertas de ronda (RFQ replies)
#define MSS_SPOT                    226     //; message for spot manual configuration
// Messages between DME and DGI with Datatec format for ETC requirements.
#define MSS_ETCRESPONSE             996     //; mensaje de respuesta positiva/negativa a mensajes ETC
#define MSS_PINSDME                 994     //; mensaje entre DGI y DME para suscribir a una sucursal ETC.
#define MSS_ALLCRPOLINOTIFICATION   993     //; mensaje entre DME y DGI para indicar que politicas de credito se envian.
// Messages for bridge management from DM -> DME
#define MSS_BRIDGE                  225     //  mensaje configuracin del bridge
// Messages between DME and DMDI with Datatec format for BRIDGE feed
#define MSS_RBRIDGE                 995     //  mensaje retiro equipo
#define MSS_CMDBRIDGE               992     //  mensaje comando-respuesta dme dmdi
#define MSS_HANDOVER                103     // mensaje para hacer handover entre transacciones.

#define MSS_PRCMNT_HORA_PLAZO_HOY  177      // mensaje mejores oferta-demanda
#define MSS_PRCMNT_HORA_AM_PM_HOY  300      // mensaje precios am-pm
#define MSS_AVGPURCHASEPRICE       291      // mensaje precios promedio de compra 

#define MSS_CUPOL                                 50     // mensaje cupo                       
#define MSS_CUPOXPL                               54     // mensaje cupo por plazo                       
#define MSS_LIMITE_INSTITUCION                   150     // primaryusers  primaryusers
#define MSS_PENDIENTE_COBRANZA                   126     // primaryuser   datamanager 
#define MSS_PENDING_CONFIRMATION                 996
#define LOGIN_AUTHORITY_MACHINE       1
#define LOGIN_DAPI_MACHINE            4
#define LOGIN_DS_MACHINE              5

#define MSS_FIXPRICE                306     // mensaje para posturas fix price.

#define MSS_VERSION_CONTROL         253     // mensaje para control de versiones
#define MSS_COMENTARIO_TRANSACCION  104     // mensaje para modfiicacin de comentario en trasacciones

#ifdef DMDIAPP
#define MSS_USERLOGINBRIDGE          34     // mensaje de ingreso de usuario para el dmdi.
#endif


//////////////////////////////////////////////////////////////////////////////
// MESSAGE STRUCTURE TO BE SUPPORTED
// <num_message>[<gtable_header><gtable_fields> | <dfn_cabeza_header><after_cabeza_fields>[<gtable_fields>]]
//////////////////////////////////////////////////////////////////////////////

#define MSG_NUMBER_FIELD_SIZE                   3
                                                
#define GTABLE_HEADER_SIZE                      19
#define GTABLE_MSG_HEADER_SIZE                  (MSG_NUMBER_FIELD_SIZE + GTABLE_HEADER_SIZE)
#define GTABLE_MESSAGE_SIZE                     (MESSAGE_RECORD_SIZE + GTABLE_HEADER_SIZE)
#define CABEZA_HEADER_SIZE                      80
#define ORDER_AFTER_CABEZA_SIZE                 4
#define TABLESREQ_AFTER_CABEZA_SIZE             95
#define LOGIN_AFTER_CABEZA_SIZE                 435
#define PED_LOG_AFTER_CABEZA_SIZE               900
#define LOG_BEGIN_AFTER_CABEZA_SIZE             9
#define LOG_END_AFTER_CABEZA_SIZE               40
#define TABLE_REQ_AFTER_CABEZA_SIZE             35
#define DMLIST_AFTER_CABEZA_SIZE                42
#define ENDTRANS_AFTER_CABEZA_SIZE              40
#define GTABLE_NAMECHECK_SIZE                   535
#define DMTLIST_AFTER_GTABLE_SIZE               64
#define GTABLE_NMCHKPLZ_SIZE                    61
#define GTABLE_FACTRISKPLZTERM_SIZE             61
#define GTABLE_ORDER_SIZE                       1194
#define ORDER_AFTER_GTABLE_SIZE                 223
#define FINALPENDING_AFTER_CABEZA_SIZE          2221
#define VOICETERM_AFTER_GTABLE_SIZE             97
#define FACTRIESGO_AFTER_CABEZA_SIZE            2
#define TABLE_SUBSCRIPTION_SIZE                 124
#define GTABLE_TERM_SIZE                        57
#define GTABLE_SUMMARY_SIZE                     1030
#define GTABLE_STATISTICS_SIZE                  189
#define GTABLE_BRANCHES_SIZE                    312
#define GTABLE_BRANCHESRFQS_SIZE                 35
#define GTABLE_INSTIT_SIZE                      108
#define GTABLE_SPOT_SIZE                        110
#define GTABLE_USER_SIZE                        699
#define GTABLE_CASHRATE_SIZE                    97
#define GTABLE_INCREMENTS_SIZE                  63
#define GTABLE_CURRENCY_SIZE                    146
#define GTABLE_CUPOS_SIZE                       117
#define GTABLE_INSTNUM_SIZE                     6
#define GTABLE_BRANCHNUM_SIZE                   10
#define GTABLE_PINSDME_SIZE                     15
#define PINSDME_AFTER_CABEZA_SIZE               1
#define GTABLE_CREDITADM_SIZE                   26
#define GTABLE_SUPERGROUP_SIZE                  277
#define GTABLE_OVERNIGHT_SIZE                   103
#define GTABLE_DMECONNECTED_SIZE                8
#define GTABLE_MARKETS_SIZE                     1018
#define GTABLE_MARKETS_SIZE_OLD                 581
#define VOICETERM_AFTER_CABEZA_SIZE             1
#define GTABLE_VOICETERM_SIZE                   526
#define GTABLE_VOICESUMMARY_SIZE                693
#define GTABLE_VOICEGROUP_SIZE                  303
#define GTABLE_FIXEDINCOMEMARKETS_SIZE          284
#define GTABLE_HISTORYTRANSDAYTERM_SIZE         368
#define GTABLE_HISTORYTRANSDAYMEM_SIZE          189
#define GTABLE_RATES_SIZE                       107
#define GTABLE_PU_SIZE                          33
#define GTABLE_INDICATIVES_SIZE                 110

#define RFQ_STATUS_UPDATE_SIZE                  1543

#define GTABLE_CUPOSXPL_SIZE                    128
#define CUPO_AFTER_RANGO_PLAZO_SIZE              10
#define CUPO_AFTER_INSTITUCION_OTRA_SIZE         15
#define GTABLE_CUPOSXDIA_SIZE                   390

#define GTABLE_CUPOSL_SIZE                      118
#define GTABLE_COBRANZAS_SIZE                   30
#define GTABLE_PENDCOBRANZAS_SIZE               374
#define GTABLE_FACTRIESGO_SIZE                  82
#define GTABLE_COMPARTCUPOS_SIZE                64
#define GTABLE_CONFCUPOS_SIZE                   35
#define GTABLE_LIMINSTIT_SIZE                   46
#define GTABLE_BUYAVERPRICE_SIZE                29
#define GTABLE_MARKETSPOTPRICES_SIZE            84
#define GTABLE_COUNTERBRIDGE_SIZE               22
#define GTABLE_MSG_ORDER_SIZE                   (GTABLE_ORDER_SIZE + ORDER_AFTER_GTABLE_SIZE) // global table data + additional msg data.
#define MSG_ORDER_SIZE                          (CABEZA_HEADER_SIZE + ORDER_AFTER_CABEZA_SIZE + GTABLE_MSG_ORDER_SIZE)  // complete order msg data
#define GTABLE_ONLY_CONFIRMPEND_SIZE            7
#define GTABLE_CONFIRMPEND_RELLENO_SIZE         50
#define GTABLE_CONFIRMPEND_SIZE                 (GTABLE_ONLY_CONFIRMPEND_SIZE + GTABLE_CONFIRMPEND_RELLENO_SIZE + GTABLE_MSG_ORDER_SIZE)
#define GTABLE_SUMMARYRF_SIZE                    615
#define GTABLE_SUMMARYFI_SIZE                   240
#define GTABLE_HISTORYIC_SIZE                   292

#ifdef DAPI
#define GTABLE_EMISORES_SIZE                    92
#define GTABLE_COMITENTES_SIZE                  163
#define GTABLE_FIDUCIARIOS_SIZE                 87 
#define GTABLE_EMPLOYEE_SIZE                    142
#define GTABLE_ESQUEMA_SIZE                     96
#define GTABLE_SUBCOMITENTE_SIZE                63
#endif

#define CUPO_AFTER_GTABLE_SIZE                  49
#define NAMECHECK_AFTER_CABEZA_SIZE             1
#define NMCHKPLZ_AFTER_CABEZA_SIZE              1
#define TRADENEG_AFTER_CABEZA_SIZE              367
#define TEXTTRADENEG_AFTER_CABEZA_SIZE          112
#define GUIBOS_AFTER_CABEZA_SIZE               1532 
#define GUIBOSWH_AFTER_CABEZA_SIZE              551
#define TIME_CHECK_AFTER_CABEZA_SIZE             56
#define ONECFGCREDIT_AFTER_CABEZA_SIZE           39
#define PLCCREDIT_AFTER_CABEZA_SIZE              51
#define CUPO_AFTER_CABEZA_SIZE                    2
#define CONFIGCREDIT_AFTER_CABEZA_SIZE         1028
#define RETIROEQUIPO_AFTER_CABEZA_SIZE           16
#define POLITICCREDIT_AFTER_CABEZA_SIZE        1533
#define CREDITADM_AFTER_CABEZA_SIZE               1
#define DELDEFERRED_AFTER_CABEZA_SIZE           183
#define TRANSMON_AFTER_ADDITDATA_SIZE           784
#define HTRAMHOY_AFTER_CABEZA_SIZE              919 
#define HISTMHOY_AFTER_CABEZA_SIZE              324 
#define MNTTRANSRENTAFIJA_AFTER_CABEZA_SIZE     226
#define CITY_AFTER_CABEZA_SIZE                  135
#define COUNTRY_AFTER_CABEZA_SIZE               253
#define MONEY_AFTER_CABEZA_SIZE                 146
#define INSPERM_AFTER_CABEZA_SIZE               276 
#define PAYINSTRUCTION_AFTER_CABEZA_SIZE         36
#define COMMANDHISTORY_AFTER_CABEZA_SIZE        110
#define BRIDGE_AFTER_CABEZA_SIZE                180
#define INDICATIVES_AFTER_CABEZA_SIZE             2
#define RBRIDGE_AFTER_CABEZA_SIZE              1244
#define DATOS_BRIDGE_AFTER_CABEZA_SIZE          468
#define CMDBRIDGE_AFTER_CABEZA_SIZE             674
#define FIXPRICE_AFTER_CABEZA_SIZE              205 
#define GTABLE_CCYPAIR_SIZE                      54
#define GTABLE_INDICATIVESMARK_SIZE              12
#define GTABLE_CONNDMSERVER_SIZE                 30
#define GTABLE_HOLIDAY_SIZE                      70
#define RFQREQUEST_AFTER_CABEZA_SIZE              1
#define GTABLE_RFQREQUEST_SIZE                  (677 + DFN_BRANCHES_ARRAY_RFQREQUEST_LEN + DFN_BRANCHES_4C_ARRAY_RFQREQUEST_LEN) //= 1493
#define CONFIG_PRECIO_SPOT_AFTER_CABEZA_SIZE     46
#define HANDOVER_AFTER_CABEZA_SIZE              400  
#define HANDOVER_EXTRA_SIZE                      23
#define GTABLE_GENDATA_SIZE                     117
#define PRCHOURTERM_AFTER_CABEZA_SIZE             2
#define PRCHOURTERM_SIZE                        492 
#define PRCHOURAMPM_AFTER_CABEZA_SIZE           353
#define AVGPURCHASEPRICE_AFTER_CABEZA_SIZE       50
#define CHAT_AFTER_CABEZA_SIZE                 3740   
#ifdef DMDIAPP
#define USERLOGINBRIDGE_AFTER_CABEZA_SIZE        73
#endif

// Messages between DME and DGI with Datatec format for ETC requirements.
#define ETC_RESPONSE_MSG_SIZE            203
#define ALLCRPOLINOTIFICATION_MSG_SIZE   32
#define GTABLE_CONNUSER_SIZE             158

#define MSG_VRSCTRL_SIZE                 111 
#define MSG_TRANSCOMMENT_SIZE            179

void FIELD_Check_Consistency (void);

enum
{
CMESSAGE_TYPE,
CGTHEADER_TYPE,
CMSGORDER_TYPE,
CGTORDER_TYPE,
CMSGLOGIN_TYPE,
CMSGLOGREQ_TYPE,
CMSGLOGBEGIN_TYPE,
CMSGLOGEND_TYPE,
CMSGNEXTLOGREQ_TYPE,
CGUIBOSMSG_TYPE,
CGUIBOSWHMSG_TYPE,
CMSGDMLIST_TYPE,
CMSGLOGTRANSACTION_TYPE,
CMSGDMTLIST_TYPE,
CMSGTABLESREQ_TYPE,
CMSGETCRESPONSE_TYPE,
CMSGCOMMANDHISTORY_TYPE,
CMSGALLCRPOLINOTIFICATION_TYPE,
CMSGFINALPENDING_TYPE,
CMSGTRADENEG_TYPE,
CMSGTEXTTRADENEG_TYPE,
CGTTERM_TYPE,
CMSGVOICETERM_TYPE,
CGTSUMMARY_TYPE,
CGTSTATISTICS_TYPE,
CGTBRANCHES_TYPE,
CGTBRANCHESRFQS_TYPE,
CGTSPOT_TYPE,
CGTUSER_TYPE,
CGTCASHRATE_TYPE,
CGTINCREMENTS_TYPE,
CGTCURRENCY_TYPE,
CGTOVERNIGHT_TYPE,
CGTDMECONNECTED_TYPE,
CGTSUPERGROUP_TYPE,
CGTVOICETERM_TYPE,
CGTVOICESUMMARY_TYPE,
CGTVOICEGROUP_TYPE,
CMSGNAMECHECK_TYPE,
CGTNAMECHECK_TYPE,
CMSGNMCHKPLZ_TYPE,
CGTNMCHKPLZ_TYPE,
CGTINSTNUM_TYPE,
CGTBRANCHNUM_TYPE,
CGTPINSDME_TYPE,
CMSGPINSDME_TYPE,
CMSGCREDITADM_TYPE,
CGTCREDITADM_TYPE,
CMSGCUPOG_TYPE,
CMSGCUPOL_TYPE,
CMSGCUPOXPL_TYPE,
CMSGFACTRIESGO_TYPE,
CMSGLIMINSTIT_TYPE,
CMSGPENDCOBRANZAS_TYPE,
CGTCUPOSG_TYPE,
CGTCUPOSL_TYPE,
CGTCOBRANZAS_TYPE,
CGTPENDCOBRANZAS_TYPE, 
CGTFACTRIESGO_TYPE,
CGTCOMPARTCUPOS_TYPE,
CGTCONFCUPOS_TYPE,
CGTBUYAVERPRICE_TYPE,
CGTMARKETSPOTPRICES_TYPE,
CGTCONFIRMPEND_TYPE,
CGTPU_TYPE,
CMSGONECFGCREDIT_TYPE,
CMSGCONFIGCREDIT_TYPE,
CCONFIGCREDIT_TYPE,
CMSGONEPLCCREDIT_TYPE,
CMSGPOLICYCREDIT_TYPE,
CPOLICYCREDIT_TYPE,
CMSGEQOFFLINE_TYPE,
CMSGDELDEFERRED_TYPE,
CGTINSTIT_TYPE,
CMSTRANSMON_TYPE,
CGTMARKET_TYPE,
CGTMARKET_OLD_TYPE,
CMSHTRAMHOY_TYPE,
CMSHISTMHOY_TYPE,
CGTCITY_TYPE,
CGTCOUNTRY_TYPE,
CGTMONEY_TYPE,
CGTINSPERM_TYPE,
CMSGPAYINST_TYPE,
CGTFIXEDINCOMEMARKETS_TYPE,
CGTHISTORYTRANSDAYTERM_TYPE,
CGTRATES_TYPE,
CGTBRIDGE_TYPE,
CGTCOUNTERBRIDGE_TYPE,
CGTINDICATIVES_TYPE,
CMSGINDICATIVES_TYPE,
CGTBRIDGEDATA_TYPE,
CMSGRBRIDGE_TYPE,
CMSGCMDBRIDGE_TYPE,
CMSGBRIDGE_TYPE,
CGTCCYPAIR_TYPE,
CGTINDICATIVESMARK_TYPE,
CGTCONNDMSERVER_TYPE,
CGTHOLIDAY_TYPE,
CGTRFQREQUEST_TYPE,
CMSGRFQREQUEST_TYPE,
CMSGSPOT_TYPE,
#ifdef DAPI
CGTEMISORES_TYPE,
CGTCOMITENTES_TYPE,
CGTFIDUCIARIOS_TYPE,
CMSPRCHOURTERM_TYPE,
CMSPRCMNTAMPMHOUR_TYPE,
CMSPRMNTTRANSRENTAFIJA_TYPE,
#endif
CGTHISTORYTRANSDAYMEM_TYPE,
CMSGHANDOVER_TYPE,
CGTSUMMARYRF_TYPE,
CGTSUMMARYFI_TYPE,
CGTSUMMARYCO_TYPE,
CGTHISTORYFI_TYPE,
CGTGENDATA_TYPE,
CGTCUPOSXPL_TYPE,
CGTCUPOSXDIA_TYPE,
CMSGFIXPRICE_TYPE,
CGTFACTRISKPLZTERM_TYPE,
CMSGFACTRISKPLZTERM_TYPE,
CMSVRSCTRL_TYPE,
CMSGRFQUPDATE_TYPE,
#ifdef DAPI
CGTEMPLOYEE_TYPE,
CMSAVGPURCHASEPRICE_TYPE,
CGTESQUEMA_TYPE,
#endif
CMSGSUBSCRIPTION_TYPE,
#ifdef DMDIAPP
CMSGUSERLOGINBRIDGE_TYPE,
#endif
#ifdef DAPI
CGTSUBCOMITENTE_TYPE,
CMSGCHAT_TYPE,
CMSGTRANSCOMMENTL_TYPE,
CGTCONNUSER_TYPE,
#endif
MAX_MESSAGES_TYPES
};

enum {
MSG_NUMBER_FIELD,
// Global table header
I_OP,
DATA_CODE,
REC_NUM,
FLAGS,
REC_IDX,
ENV_CRC32,
CRC32,
ENVIRONMENT,
DATA_INFO,


// Field to be used to backup the original unique code of the tables that are passed to DAPI
CODIGO_UNICO_REGISTRO,

// DFN header. Included on all normal messages, but not included in
// global table messages.
CABEZA,

DATOS_PARA_DATASERVER,
CODIGO_PRIMARYUSER,
BANDERA_MENSAJE_PERSISTENTE,
NO_GUARDAR_LOG_DESTINATARIOS,
GUARDAR_LOG_REMITENTE,
MARCA_PROCESADO,
CODIGO_DATASERVER,
NUMERO_REMITENTE,
NUMERO_DATASERVER,
LOG,
USUARIO,
HORA,
FECHA_ALFANUMERICA,
FECHA,
MILISEGUNDO,
BANDERA_DESTINATARIOS,
BANDERA_TIPO_HORAS,
HORA_LOCAL_REMITENTE,
RELLENO_1_CABEZA,
DATOS_REMITENTE,
SUCURSAL,
CODIGO_INSTITUCION,
CIUDAD,
AGENCIA,
BANDERA_INSTITUCION_ESPECIAL_REMITENTE,
FUNCION_INSTITUCION_REMITENTE,
DIEZMILESIMA_LOCAL_REMITENTE,
RELLENO_2_CABEZA,
DATOS,

// ORDER global table message fields that come after cabeza header.
CLASE_MENSAJE,
BANDERA,
BANDERA_PRIORIDAD,

// TABLESREQ message fields that come after cabeza header.
RELLENO_TABLESREQ,

// TABLE ENVIRONMENT SUBSCRIPTION
TABLE_SUBSCRIPTION,                               
TABLE_SUBSCRIPTION_SUBS_CHAR,                     
TABLE_SUBSCRIPTION_SERVER_TYPE,
TABLE_SUBSCRIPTION_SERVER_DETAIL,                 
TABLE_SUBSCRIPTION_SOURCE_PU,                     
TABLE_SUBSCRIPTION_KEY_NAME_CRC32,                
TABLE_SUBSCRIPTION_KEY_CODE,                      
TABLE_SUBSCRIPTION_KEY_LEN,  
TABLE_SUBSCRIPTION_DATA_INFO,

// LOGIN message fields that come after cabeza header.
EQUIPO_USUARIO,
BANDERA_LOGIN,
NOMBRE_USUARIO,
BANDERA_FORMA_INGRESO,
DIRECCION_IP_EQUIPO,
DIRECCION_IP_EQUIPO_1,
BANDERA_APLICACION_PERMITIDA,
CODIGO_USUARIO_LOGIN,
CAMBIAR_CLAVE,
BANDERA_USUARIO,
TIEMPO_EXPIRACION_CONEXION,
TEXTO_CLAVE_SUCURSAL,
VERSION,
CLAVE_USUARIO_16,
CLAVE_USUARIO_16_A,
FECHA_CONEXION_ANTERIOR,
HORA_CONEXION_ANTERIOR,
GRUPO_MERCADOS,
BANDERA_TIPO_PRIMARYUSER,
BANDERA_NO_VALIDAR_CLAVE_SUCURSAL,
BANDERA_NO_ENVIAR_LOG,
BANDERA_NO_ENCRIPTAR,
BANDERA_NO_EMPAQUETAR,
CODIGO_SUCURSAL_INGRESADA,
CODIGO_INSTITUCION_SUCURSAL_INGRESADA,
CODIGO_CIUDAD_SUCURSAL_INGRESADA,
CODIGO_AGENCIA_SUCURSAL_INGRESADA,
SISTEMA_DE_FECHAS,
NOMBRE_VERSION_SIGUIENTE,
FECHA_ACTUALIZACION,
CODIGO_SUCURSAL_INGRESADA_4C,
BANDERA_ADMINISTRADOR_ME,
BANDERA_MOTOR_CALCE,
BANDERA_FORMATO_CLAVE_USUARIO,
CLAVE_TEMPORAL_LOGIN,
PAIS_INSTITUCION,
INSTITUCION_4C,
INSTITUCION_3C,
CLASE_INSTITUCION_LOGIN,
BANDERA_ADMINISTRADOR_DM,
BANDERA_USUARIO_OBSERVADOR,
BANDERA_VIA_DPROXY,
CODIGO_DPROXY,
CODIGO_AMBIENTE,
FECHA_ULTIMO_MENSAJE_RECIBIDO_DESDE_PU,
ULTIMO_MENSAJE_RECIBIDO_DESDE_PU,
BANDERA_ASIGNAR_RANGO,
NUMERO_CODIGOS_TABLAS_GLOBALES,
FECHA_HOY_MENOS_1,
FECHA_HOY_MENOS_2,
DIRECCION_IP_ASIGNADA_POR_DS,
RANGO_INFERIOR_ASIGNADO_POR_DS,
RANGO_SUPERIOR_ASIGNADO_POR_DS,
HORA_ULTIMO_INGRESO,
NUMERO_INGRESOS,
EQUIPO_USUARIO_NUEVO,
DIRECCION_IP_EQUIPO_DP,
DIRECCION_IP_REAL_PU,
DIRECCION_IP_REAL_PU_EXITOSA,
DIRECCION_IP_REAL_PU_FALLIDA,
FECHA_CONEXION_ANTERIOR_FALLIDA,
HORA_CONEXION_ANTERIOR_FALLIDA,
NUMERO_CLAVES_INCORRECTAS,
DIRECCION_MAC,
BANDERA_LOG,
SUB_VERSION,
BANDERA_CHEQUEAR_NEXT_RESTART,
DIRECCION_IP_REAL_PU_EN_DS,
FOLDER_BAJAR_SUBIR,
FUNCION_INTERCAMBIO_BV,
RELLENO_INGRESO_EQUIPO,
AMBIENTE_EJECUCION_LOCAL,
LETRAS_ID_PUS,
TRABAJA_COMO,
IP_EQUIPO_DS,
DS_VERSION_ASK_BY_IDX,
RELLENO_INGRESO_EQUIPO_DS,

// INSTITUTIONS
DATOS_INSTITUCION_INSTITUCION,
    CODIGO_UNICO_INSTITUCION,
      PAIS_DATAMANAGER_INSTITUCION,
      SECUENCIAL_INSTITUCION,
    BANDERA_TRANSNACIONAL_INSTITUCION,
    CODIGO_PAIS_INSTITUCION,
    CODIGO_3C_INSTITUCION,
    CODIGO_4C_INSTITUCION,
    NOMBRE_CORTO_INSTITUCION,
    NOMBRE_INSTITUCION,
    CLASE_INSTITUCION,
    TIPO_ENTIDAD_INSTITUCION,
    BANDERA_INSTITUCION_ESPECIAL_INSTITUCION,
    FUNCION_INSTITUCION,
    ACTIVO_INSTITUCION,
    BANDERA_MODIFICAR_CUPOS_INSTITUCION,
    MATRIZ_INSTITUCION,
    CODIGO_BIC,                                 
    TIPO_SUPER_FINANCIERA,                      
    CODIGO_SUPER_FINANCIERA,                    
    EXTERNO_SISTEMA,
    RELLENO_INSTITUCION,
NUMERO_INSTITUCION_INSTITUCION,

#if DAPI || DMEAPP
//INSTRUCCIONES PERMANENTES
DATOS_INSTRUCCION_PERMANENTE,                     
                                                 
    CODIGO_IP,                                    
    USUARIO_IP,                                   
    SECUENCIA_IP,                                 
    TIPO_IP,                                      
    SUCURSAL_IP,                                  
    CODIGO_INSTITUCION_IP,                        
    CIUDAD_3C_IP,                                 
    AGENCIA_IP,                                   
    CUENTA_IP,                                    
    CIUDAD_IP,                                    
    BANCO_IP,                                     
    DIRECCION_SWIFT,                              
    FED_ABA,                                      
    CHIPS_ID,                                     
    TEXTO_IP,                                     
    COLOR_IP,                                     
    MONEDA_IP,                                    
    BANDERA_DEFAULT,                              
    FORMA_PAGO,                                   
    ACTIVA_IP,                                    
    RELLENO_IP,                                   
    SUCURSAL_4C_INSPERM,
#endif

#if DAPI || DGIAPP

// DFN header. Included on all normal messages, but not included in
// global table messages.
SCND_CABEZA,

SCND_DATOS_PARA_DATASERVER,
SCND_CODIGO_PRIMARYUSER,
SCND_BANDERA_MENSAJE_PERSISTENTE,
SCND_NO_GUARDAR_LOG_DESTINATARIOS,
SCND_GUARDAR_LOG_REMITENTE,
SCND_MARCA_PROCESADO,
SCND_CODIGO_DATASERVER,
SCND_NUMERO_REMITENTE,
SCND_NUMERO_DATASERVER,
SCND_LOG,
SCND_USUARIO,
SCND_HORA,
SCND_FECHA_ALFANUMERICA,
SCND_FECHA,
SCND_MILISEGUNDO,          
SCND_BANDERA_DESTINATARIOS,
SCND_BANDERA_TIPO_HORAS,   
SCND_HORA_LOCAL_REMITENTE, 
SCND_RELLENO_1_CABEZA,
SCND_DATOS_REMITENTE,
SCND_SUCURSAL,
SCND_CODIGO_INSTITUCION,
SCND_CIUDAD,
SCND_AGENCIA,
SCND_BANDERA_INSTITUCION_ESPECIAL_REMITENTE,
SCND_FUNCION_INSTITUCION_REMITENTE,
SCND_DIEZMILESIMA_LOCAL_REMITENTE,
SCND_RELLENO_2_CABEZA,
SCND_DATOS,
#endif

#ifdef DAPI
// LOG REQUIREMENT
PED_LOG_CLASE_LOG,
PED_LOG_CODIGO_DATASERVER,
PED_LOG_FECHA_ULTIMO_MENSAJE,
PED_LOG_HORA_ULTIMO_MENSAJE,
PED_LOG_ULTIMO_MENSAJE_DATASERVER,
PED_LOG_ULTIMO_MENSAJE_PU,
PED_LOG_RESTO_ULTIMO_MENSAJE,

// LOG BEGIN
INI_LOG_NUMERO_RECIENTE_LOG,
INI_LOG_ULTIMO_MENSAJE_RECIBIDO,
INI_LOG_BANDERA,

// LOG END
FIN_LOG_MONITORES_CONECTADOS,

// PED_TABS
PED_TABS_RELLENO_1,

// GUIBOS
G_RELLENO_MENSAJE,
G_FLAG_SIDE_CHANGED,
G_BANDERA,
G_DATOS_GUIBOS,
G_INSTRUMENT,
G_CURRENCY_PAIR,
G_DEAL_TYPE_SELLER_BANK,
G_DEAL_TYPE_BUYER_BANK,
G_DEAL_TIME,
G_DEAL_DATE,
G_TRADE_IDENTIFICATION,
G_INSTANCE_TRADE,
G_POINTS,
G_CURRENCY_CODE_DEALT,
G_VALUE_DATE_NEAR,
G_AMOUNT_NEAR,
G_CURRENCY_CODE_NONDEALT,
G_RATE,
G_VALUE_DATE_FAR,
G_AMOUNT_FAR,
G_BUYER_BANK,
G_SELLER_BANK,
G_BUYER_DEALER,
G_SELLER_DEALER,
G_CODE_BUYER_VIA,
G_CODE_SELLER_VIA,
G_BROKER_BUYER,
G_BROKER_SELLER,
G_DATE_REGISTER,
G_TIME_REGISTER,
G_CANCELED_AMEND,
G_BUYER_SIDE_NET_BROKERAGE,
G_SELLER_SIDE_NET_BROKERAGE,
G_TEXT_TERM,
G_MAR_DATE,
G_FLAG_SELLER_AGGRESOR,
G_FLAG_BUYER_AGGRESOR,
G_CLS_TRADE,
G_NEW_STP_MESSAGE_BUYER,
G_NEW_STP_MESSAGE_SELLER,
G_FLAG_SPREAD,
G_FILLER,
G_REAL_BROKER_BUYER_CENTER,
G_REAL_BROKER_SELLER_CENTER,
G_STP_BUYER,
G_STP_SELLER,
G_KEY_USED_DATATEC,
G_PART_1,
G_PART_2,
G_PART_3,
G_PART_4,
G_BUYER_PUBLISHED_FIELD,
G_SELLER_PUBLISHED_FIELD,
G_BUYER_SIDE_DRN,
G_SELLER_SIDE_DRN,
G_BUYER_SIDE_VERSION,
G_SELLER_SIDE_VERSION,
G_BUYER_SIDE_HOUR_ENTERED,
G_BUYER_SIDE_DATE_ENTERED,
G_SELLER_SIDE_HOUR_ENTERED,
G_SELLER_SIDE_DATE_ENTERED,
G_BUYER_SIDE_STATUS_ERROR,
G_SELLER_SIDE_STATUS_ERROR,
G_BUY_STP_STATUS,
G_SELL_STP_STATUS,
G_MARKETID,   
G_DESK_BUYER,
G_RELLENO_A,
G_DESK_SELLER,
G_RELLENO_B,
G_CLEARING_FIRM,
G_UNIQUE_SWAP_IDENTIFIER,
G_USI_PREFIX,
G_USI_VALUE,
G_SOURCE_ID,
G_TRADE_UNIQUE_ID,
G_EXTERNAL_STRATEGY_ID,
G_TRADE_IDENTIFICATION_COPY,
G_UNIQUE_PRODUCT_ID,
G_LEGAL_ENTITY_IDENTIFIER,
G_ORDERID_BUYER,
G_ORDERID_SELLER,
G_SUBMITTINGBROKER_BUYER,
G_SUBMITTINGBROKER_SELLER,
G_ISBLOCKTRADE,
G_RFQ_FLAG,
G_CCP,
G_FCM_BUYER,
G_FCM_SELLER,
G_FCM_ACCOUNT_BUYER,
G_FCM_ACCOUNT_SELLER,
G_SEFABLE,
G_PRIOR_USI,
G_SUBMMITTER_TYPE_BUYER,
G_SUBMMITTER_TYPE_SELLER,
G_IB_FIRM_ID_SELLER,
G_IB_FIRM_ID_BUYER,
G_IB_GROUP_ID_BUYER,
G_IB_GROUP_ID_SELLER,
G_IB_BROKER_ACCOUNT_BUYER,
G_IB_BROKER_ACCOUNT_SELLER,
G_SEF_BROKER_ACCOUNT_BUYER,
G_SEF_BROKER_ACCOUNT_SELLER,
G_FLAG_FIXING,
G_SEF_PROOFED_FLAG,
G_PIECE_ID_1,
G_PIECE_ID_2,
G_BANDERA_ENVIAR_A_CO_BUYER,
G_BANDERA_ENVIAR_A_CO_SELLER,
G_SHORTDATE_FLAG,
G_CREDIT_TOKEN_BUYER,
G_CREDIT_TOKEN_SELLER,
G_RELLENO,

// GUIBOSWH
GW_RELLENO_MENSAJE,
GW_BANDERA,
GW_DATOS_GUIBOS,
GW_TRADE_ID,
GW_OPERATION_TYPE_FLAG,
GW_TRADE_VERSION_NUMBER,
GW_RECORD_TIME_STAMP,
GW_INSTRUMENT,
GW_TRADE_TIME,
GW_TRADE_DATE,
GW_TRADE_TYPE,
GW_G_T,
GW_CURRENCY,
GW_AMOUNT,
GW_PRICE,
GW_TRADE_START_DATE,
GW_TRADE_END_DATE,
GW_STRUCTURE,
GW_TRADE_TERM,
GW_DELIVERY_POINT,
GW_TERMS,
GW_BUYER_CUSTOMER,
GW_BUYER_VIA,
GW_BUYER_BROKER,
GW_BUYER_TRADER,
GW_BUYER_DEAL_TYPE,
GW_BUYER_NET_BRO,
GW_SELLER_CUSTOMER,
GW_SELLER_VIA,
GW_SELLER_BROKER,
GW_SELLER_TRADER,
GW_SELLER_DEAL_TYPE,
GW_SELLER_NET_BRO,
GW_KEY_USED_DATATEC,
GW_PART_1,
GW_PART_2,
GW_PART_3,
GW_PART_4,
GW_PUBLISHED_FIELD,
GW_GUIBOS_DRN,
GW_GUIBOS_VERSION,
GW_GUIBOS_PROCESSED_TIME_STAMP,
GW_GUIBOS_PROCESSED_HOUR,
GW_GUIBOS_PROCESSED_DATE,
GW_GUIBOS_STATUS_ERROR,

// Primaryusers global table
DATOS_PU,

CODIGO_PU,
PAIS_DATAMANAGER_PU,
SECUENCIAL_PU,
CODIGO_SUCURSAL_PU,
CODIGO_UNICO_INSTITUCION_PU,
CODIGO_CIUDAD_3C_PU,
CODIGO_AGENCIA_PU,
SUCURSAL_4C_PU,
TIEMPO_DESCONEXION_PU,
ACTIVO_PU,
TIEMPO_DESCONEXION_USUARIOS_PU,
ESPEJO_PU,
RELLENO_PU,
DATOS_ADICIONALES_PU,
NUMERO_PRIMARYUSER_PU,

// Msg HTRAMHOY
BANDERA_CLASE_MENSAJE,
DATOS_HOY,
  FECHA_HORA_HISTORIA_HOY,
  FECHA_HISTORIA_HOY,
  ANO_HOY,
  MES_HOY,
  DIA_HOY,
  HORA_HISTORIA_HOY,
  MERCADO_HOY,
  PRECIO_HOY,
  MONTO_HOY,
  CODIGO_POSTURA_HOY,
  USUARIO_POSTURA_HOY,
  MCOD_POSTURA_HOY,
  CODIGO_POSTURA_1_HOY,
  USUARIO_POSTURA_1_HOY,
  MCOD_POSTURA_1_HOY,
  BANDERA_REGISTRADA_HOY,
  XDIAS_HOY,
  DIAS_HOY,
  DIAS_2_HOY,
  TEXTO_TERM_HOY ,
  O_D_HOY,
  ORIGEN_MERCADO_SPREAD_HOY,
  SUB_MERCADO_HOY,
  DIAS_AUX_HOY,
  BANCO_4C_COMPRADOR_HOY,
  USUARIO_CLIENTE_COMPRADOR_HOY ,
  BANCO_4C_VENDEDOR_HOY,
  USUARIO_CLIENTE_VENDEDOR_HOY  ,
  MONEDA_HOY,
  HORA_REGISTRO_HOY,
  TEXTO_TERM_AUX_HOY,
  BANDERA_AUX_HOY,
  PRECIO_OUTRIGHT_HOY,
  MONTO_MONEDA_CONTRAPARTE_HOY,
  PRECIO_SPOT_HOY,
  BANDERA_FISICO_COMPENSACION_HOY,
  BANDERA_ORIGEN_HOY,
  CODIGO_BROKER_HOME_HOY,
  BANDERA_BROKER_POSTURA_HOY,
  BANDERA_BROKER_POSTURA_1_HOY,
  BANDERA_OPERACION_HOY,
  HORA_FIN_TRANSACCION_HOY,
  HORA_ANULACION_HOY,
  BANDERA_ESTANDAR_LIBRE_HOY,
  TICKS_OPERACION_HOY,
  INTERMEDIARIO_EN_CODIGO_POSTURA_HOY,
  INTERMEDIARIO_EN_CODIGO_POSTURA_1_HOY,
  NEMOTECNICO_HOY,
  PUNTOS_SPREAD_HOY,
  PICTURE_PRECIO_STD_HOY,
  ESCALA_PRECIO_STD_HOY,
  BANDERAS_STD_HOY,
  MARCA_PRECIO_HOY,
  MONTO_SPREAD_HOY,
  BANDERAS_STD_1_HOY,
  MONTO_CAMBIADO_HOY,
  CODIGO_GRUPO_TRANSACCIONES_HOY,
  CODIGO_SUB_GRUPO_TRANSACCIONES_HOY,
  TEXTO_ORIGEN_HOY,
  RELLENO_P_HOY,
DATOS_DIA,
  FECHA_HISTORIA_DIA,
  ANO_DIA,
  MES_DIA,
  DIA_DIA,
  MERCADO_DIA,
DATOS_PRECIO_MONTO_DIA_DIA,
  PRECIO_APERTURA_DIA,
  PRECIO_CIERRE_DIA,
  PRECIO_PROMEDIO_DIA,
  PRECIO_MINIMO_DIA,
  PRECIO_MAXIMO_DIA,
  PRECIO_PROMEDIO_CALCULOS_DIA,
  MONTO_TOTAL_DIA,
  MONTO_MINIMO_DIA,
  MONTO_MAXIMO_DIA,
  MONTO_PROMEDIO_DIA,
  NUMERO_TRANSACCIONES_DIA,
  MONTO_ULTIMO_DIA,
  MONTO_ULTIMO_SPD_DIA,
  XDIAS_DIA,
  DIAS_DIA,
  TEXTO_TERM_DIA,
  TEXTO_TERM_A_DIA,
  TEXTO_TERM_B_DIA,
  TEXTO_TERM_C_DIA,
  HORA_ULTIMA_TRANSACCION_DIA,
  HORA_PRIMERA_TRANSACCION_DIA,
  CONSOLIDADO_DIA,
  COLOR_ULTIMA_TRANS_DIA,
  TENDENCIA_ULTIMA_TRANSACCION_DIA, 
  TENDENCIA_DIA  ,
  SUB_MERCADO_DIA,
  DIAS_AUX_DIA,
  BANDERA_ESTANDAR_LIBRE_DIA, 
  BANDERA_SOLO_REGISTRADA_DIA, 
  BANDERA_AFECTAR_PRECIO_DIA, 
  ORIGEN_MERCADO_SPREAD_DIA, 
  TASA_PLAZO_SPD_1_DIA,
  TASA_PLAZO_SPD_2_DIA,
  TASA_PLAZO_SPD_3_DIA,
  TEXTO_TERM_1_DIA,
  MONTO_T_FIX_DIA,
    TEXTO_TERM_2_DIA,
    TEXTO_TERM_3_DIA,
  PRECIO_TRANSACCIONES_FIX_DIA,
  PRECIO_FIX_DIA,
  BANDERA_ULTIMO_HECHO_DIA,
  PRECIO_X_MONTO_TOTAL_DIA,
  PRECIO_X_MONTO_T_FIX_DIA,
  SUB_TIPO_MERCADO_DIA,
  RELLENO_D_P_M_D_DIA, 
DATOS_MES,     
  ANO_MES,
  MES_MES,
  MERCADO_MES,
  PRECIO_APERTURA_MES,
  PRECIO_CIERRE_MES,
  PRECIO_PROMEDIO_MES,
  PRECIO_MINIMO_MES,
  PRECIO_MAXIMO_MES,
  PRECIO_PROMEDIO_CALCULOS_MES,
  PRECIO_X_MONTO_TOTAL_MES,
  MONTO_TOTAL_MES,
  MONTO_MINIMO_MES,
  MONTO_MAXIMO_MES,
  MONTO_PROMEDIO_MES,
  NUMERO_TRANSACCIONES_MES,
  XDIAS_MES,
  DIAS_MES,
  TEXTO_TERM_MES ,
  CONSOLIDADO_MES,
  SUB_MERCADO_MES,
  DIAS_AUX_MES,
  BANDERA_ESTANDAR_LIBRE_MES,
  BANDERA_AFECTAR_PRECIO_MES,
  RELLENO_MES,
  ESCALA_PRECIO_HOY,

// HISTMHOY
BANDERA_CLASE_MENSAJE_HISTMHOY,
DATOS_HISTORIA_MONEDA_HORA,    
   FECHA_HISTORIA_HISTMHOY,    
   ANO_HISTMHOY,
   MES_HISTMHOY,
   DIA_HISTMHOY,
   HORA_HISTORIA_HISTMHOY,     
   MERCADO_HISTMHOY,           
   O_D_HISTMHOY,               
   PRECIO_HISTMHOY,            
   MONTO_HISTMHOY,     
   SECUENCIAL_HISTMHOY,
   RELLENO_HISTMHOY,     
DATOS_H_DIA_HISTMHOY, 
   FECHA_HISTORIA_H_DIA_HISTMHOY,
   ANO_H_DIA_HISTMHOY,               
   MES_H_DIA_HISTMHOY,               
   DIA_H_DIA_HISTMHOY,               
   MERCADO_H_DIA_HISTMHOY,
   PRECIO_DEMANDA_ALTA_H_DIA_HISTMHOY,
   PRECIO_DEMANDA_BAJA_H_DIA_HISTMHOY,    
   PRECIO_OFERTA_ALTA_H_DIA_HISTMHOY,     
   PRECIO_OFERTA_BAJA_H_DIA_HISTMHOY,     
   PRECIO_DEMANDA_PROMEDIO_H_DIA_HISTMHOY,
   PRECIO_OFERTA_PROMEDIO_H_DIA_HISTMHOY,
   REGISTROS_DEMANDA_H_DIA_HISTMHOY,   
   REGISTROS_OFERTA_H_DIA_HISTMHOY,    
   SUMA_PRECIOS_DEMANDA_H_DIA_HISTMHOY,
   SUMA_PRECIOS_OFERTA_H_DIA_HISTMHOY,
   RELLENO_H_DIA_HISTMHOY,    
DATOS_H_MES_HISTMHOY,                     
   ANO_H_MES_HISTMHOY,                    
   MES_H_MES_HISTMHOY,                    
   MERCADO_H_MES_HISTMHOY,                
   PRECIO_DEMANDA_ALTA_H_MES_HISTMHOY,    
   PRECIO_DEMANDA_BAJA_H_MES_HISTMHOY,    
   PRECIO_OFERTA_ALTA_H_MES_HISTMHOY,     
   PRECIO_OFERTA_BAJA_H_MES_HISTMHOY,     
   PRECIO_DEMANDA_PROMEDIO_H_MES_HISTMHOY,
   PRECIO_OFERTA_PROMEDIO_H_MES_HISTMHOY, 
   REGISTROS_DEMANDA_H_MES_HISTMHOY,      
   REGISTROS_OFERTA_H_MES_HISTMHOY,       
   SUMA_PRECIOS_DEMANDA_H_MES_HISTMHOY,   
   SUMA_PRECIOS_OFERTA_H_MES_HISTMHOY,    
   RELLENO_H_MES_HISTMHOY,                

// PrcMntHourTerm                                                              
BANDERA_CLASE_MENSAJE_PRCHOURTERM                ,
BANDERA_ARCHIVO_PRCHOURTERM                      ,
DATOS_PRCHOURTERM                                ,
  DATOS_HISTORIA_MONEDA_HORA_PLAZO_PRCHOURTERM   ,
    FECHA_HISTORIA_PRCHOURTERM                   ,
      ANO_PRCHOURTERM                            ,
      MES_PRCHOURTERM                            ,
      DIA_PRCHOURTERM                            ,
    HORA_HISTORIA_PRCHOURTERM                    ,
    MERCADO_PRCHOURTERM                          ,
    NIVEL_PRCHOURTERM                            ,
    XDIAS_PRCHOURTERM                            ,
    DIAS_PRCHOURTERM                             ,
    FECHA_VENCIMIENTO_PRCHOURTERM                ,
    O_D_PRCHOURTERM                              ,
    PRECIO_PRCHOURTERM                           ,
    MONTO_PRCHOURTERM                            ,
    TEXTO_TERM_PRCHOURTERM                       ,
    BANDERA_ESTANDAR_LIBRE_PRCHOURTERM           ,
    PRECIO_MEDIO_PRCHOURTERM                     ,
    TICKS_OPERACION_PRCHOURTERM                  ,
    RELLENO_PRCHOURTERM                          ,
  DATOS_H_DIA_PRCHOURTERM                        ,
    FECHA_HISTORIA_H_DIA_PRCHOURTERM             ,
      ANO_H_DIA_PRCHOURTERM                      ,
      MES_H_DIA_PRCHOURTERM                      ,
      DIA_H_DIA_PRCHOURTERM                      ,
    MERCADO_H_DIA_PRCHOURTERM                    ,
    PRECIO_DEMANDA_ALTA_H_DIA_PRCHOURTERM        ,
    PRECIO_DEMANDA_BAJA_H_DIA_PRCHOURTERM        ,
    PRECIO_OFERTA_ALTA_H_DIA_PRCHOURTERM         ,
    PRECIO_OFERTA_BAJA_H_DIA_PRCHOURTERM         ,
    PRECIO_DEMANDA_CIERRE_H_DIA_PRCHOURTERM      ,
    PRECIO_OFERTA_CIERRE_H_DIA_PRCHOURTERM       ,
    PRECIO_DEMANDA_APERTURA_H_DIA_PRCHOURTERM    ,
    PRECIO_OFERTA_APERTURA_H_DIA_PRCHOURTERM     ,
    PRECIO_MEDIO_ALTA_H_DIA_PRCHOURTERM          ,
    PRECIO_MEDIO_BAJA_H_DIA_PRCHOURTERM          ,
    PRECIO_MEDIO_CIERRE_H_DIA_PRCHOURTERM        ,
    PRECIO_MEDIO_APERTURA_H_DIA_PRCHOURTERM      ,
    XDIAS_H_DIA_PRCHOURTERM                      ,
    DIAS_H_DIA_PRCHOURTERM                       ,
    TEXTO_TERM_H_DIA_PRCHOURTERM                 ,
    SUB_MERCADO_H_DIA_PRCHOURTERM                ,
    DIAS_AUX_H_DIA_PRCHOURTERM                   ,
    BANDERA_ESTANDAR_LIBRE_H_DIA_PRCHOURTERM     ,
    CONSOLIDADO_H_DIA_PRCHOURTERM                ,
    NIVEL_H_DIA_PRCHOURTERM                      ,
    RELLENO_H_DIA_PRCHOURTERM                    ,
  DATOS_H_MES_PRCHOURTERM                        ,
    ANO_H_MES_PRCHOURTERM                        ,
    MES_H_MES_PRCHOURTERM                        ,
    MERCADO_H_MES_PRCHOURTERM                    ,
    PRECIO_DEMANDA_ALTA_H_MES_PRCHOURTERM        ,
    PRECIO_DEMANDA_BAJA_H_MES_PRCHOURTERM        ,
    PRECIO_OFERTA_ALTA_H_MES_PRCHOURTERM         ,
    PRECIO_OFERTA_BAJA_H_MES_PRCHOURTERM         ,
    PRECIO_DEMANDA_CIERRE_H_MES_PRCHOURTERM      ,
    PRECIO_OFERTA_CIERRE_H_MES_PRCHOURTERM       ,
    PRECIO_DEMANDA_APERTURA_H_MES_PRCHOURTERM    ,
    PRECIO_OFERTA_APERTURA_H_MES_PRCHOURTERM     ,
    PRECIO_MEDIO_ALTA_H_MES_PRCHOURTERM          ,
    PRECIO_MEDIO_BAJA_H_MES_PRCHOURTERM          ,
    PRECIO_MEDIO_CIERRE_H_MES_PRCHOURTERM        ,
    PRECIO_MEDIO_APERTURA_H_MES_PRCHOURTERM      ,
    XDIAS_H_MES_PRCHOURTERM                      ,
    DIAS_H_MES_PRCHOURTERM                       ,
    TEXTO_TERM_H_MES_PRCHOURTERM                 ,
    SUB_MERCADO_H_MES_PRCHOURTERM                ,
    DIAS_AUX_H_MES_PRCHOURTERM                   ,
    BANDERA_ESTANDAR_LIBRE_H_MES_PRCHOURTERM     ,
    CONSOLIDADO_H_MES_PRCHOURTERM                ,
    NIVEL_H_MES_PRCHOURTERM                      ,
    FECHA_CIERRE_MES_H_MES_PRCHOURTERM           ,
    FECHA_CIERRE_MES_1_H_MES_PRCHOURTERM         ,
    RELLENO_H_MES_PRCHOURTERM                    ,
    ESCALA_PRECIO_PRCHOURTERM                    , 

// PrcMntHourAmPm                                                              
BANDERA_PRCHOURAMPM                              ,
DATOS_PRCHOURAMPM                                ,
  FECHA_HISTORIA_PRCHOURAMPM                     ,
    ANO_PRCHOURAMPM                              ,
    MES_PRCHOURAMPM                              ,
    DIA_PRCHOURAMPM                              ,
  MERCADO_PRCHOURAMPM                            ,
  DATOS_PRECIO_MONTO_DIA_PRCHOURAMPM             ,
    PRECIO_APERTURA_PRCHOURAMPM                  ,
    PRECIO_CIERRE_PRCHOURAMPM                    ,
    PRECIO_PROMEDIO_PRCHOURAMPM                  ,
    PRECIO_MINIMO_PRCHOURAMPM                    ,
    PRECIO_MAXIMO_PRCHOURAMPM                    ,
    PRECIO_PROMEDIO_CALCULADOS_PRCHOURAMPM       ,
    MONTO_TOTAL_PRCHOURAMPM                      ,
    MONTO_MINIMO_PRCHOURAMPM                     ,
    MONTO_MAXIMO_PRCHOURAMPM                     ,
    MONTO_PROMEDIO_PRCHOURAMPM                   ,
    NUMERO_TRANSACCIONES_PRCHOURAMPM             ,
    MONTO_ULTIMO_PRCHOURAMPM                     ,
      MONTO_ULTIMO_SPD_PRCHOURAMPM               , 
    XDIAS_PRCHOURAMPM                            ,
    DIAS_PRCHOURAMPM                             ,
    TEXTO_TERM_PRCHOURAMPM                       ,
      TEXTO_TERM_A_PRCHOURAMPM                   ,
      TEXTO_TERM_B_PRCHOURAMPM                   ,
      TEXTO_TERM_C_PRCHOURAMPM                   ,
    HORA_ULTIMA_TRANSACCION_PRCHOURAMPM          ,
    HORA_PRIMERA_TRANSACCION_PRCHOURAMPM         ,
    CONSOLIDADO_PRCHOURAMPM                      ,
    COLOR_ULTIMA_TRANS_PRCHOURAMPM               ,
    TENDENCIA_ULTIMA_TRANSACCION_PRCHOURAMPM     ,
      TENDENCIA_PRCHOURAMPM                      ,
    SUB_MERCADO_PRCHOURAMPM                      ,
    DIAS_AUX_PRCHOURAMPM                         ,
    BANDERA_ESTANDAR_LIBRE_PRCHOURAMPM           ,
    BANDERA_SOLO_REGISTRADA_PRCHOURAMPM          , 
    BANDERA_AFECTAR_PRECIO_PRCHOURAMPM           ,
    ORIGEN_MERCADO_SPREAD_PRCHOURAMPM            ,
    TASA_PLAZO_SPD_1_PRCHOURAMPM                 ,
    TASA_PLAZO_SPD_2_PRCHOURAMPM                 ,
    TASA_PLAZO_SPD_3_PRCHOURAMPM                 ,
    TEXTO_TERM_1_PRCHOURAMPM                     ,
    TEXTO_TERM_2_PRCHOURAMPM                     ,
    TEXTO_TERM_3_PRCHOURAMPM                     ,
    PRECIO_TRANSACCIONES_FIX_PRCHOURAMPM         ,
    PRECIO_FIX_PRCHOURAMPM                       ,
    BANDERA_ULTIMO_HECHO_PRCHOURAMPM             ,
    PRECIO_X_MONTO_TOTAL_PRCHOURAMPM             ,
    RELLENO_D_P_M_D_PRCHOURAMPM                  ,
  TIPO_RESPALDO_PRCHOURAMPM                      ,
  BANDERA_FIJO_PRCHOURAMPM                       ,
  RELLENO_1_PRCHOURAMPM                          ,
  ESCALA_PRECIO_PRCHOURAMPM                      , 

// Precios Promedio de Compra (Average Purchase Price)
BANDERA_APP                                      ,
DATOS_APP                                        ,
  CODIGO_APP                                     ,
    CODIGO_INSTITUCION_SUCURSAL_APP              ,
    CIUDAD_3C_SUCURSAL_APP                       ,
    AGENCIA_SUCURSAL_APP                         ,
  MERCADO_APP                                    ,
  PRECIO_PROMEDIO_COMPRA_APP                     ,
  FECHA_HISTORIA_ALFANUMERICA_APP                ,
    FECHA_REGISTRO_APP                           ,
  RELLENO_APP                                    ,

//INSTRUCCION PAGO
DATOS_INSTRUCCION_PAGO,                

   CODIGO_TRANSACCION_IP,
   MERCADO_IP,
   HORA_IP,
   CODIGO_POSTURA_IP,
   CODIGO_POSTURA_1_IP,
   DATOS_CAMBIADOS,
   CODIGO_IP_PAY,

// MNTTRANSRENTAFIJA
DATOS_MNTTRANSRENTAFIJA,
CLASE_MENSAJE_MNTTRANSRENTAFIJA,
O_D_MNTTRANSRENTAFIJA,
FECHA_ORIGINAL_MNTTRANSRENTAFIJA,
HORA_ORIGINAL_MNTTRANSRENTAFIJA,
MERCADO_MNTTRANSRENTAFIJA,
CODIGO_POSTURA_MNTTRANSRENTAFIJA,
  USUARIO_POSTURA_MNTTRANSRENTAFIJA,
  MCOD_POSTURA_MNTTRANSRENTAFIJA,
CODIGO_POSTURA_1_MNTTRANSRENTAFIJA,
  USUARIO_POSTURA_1_MNTTRANSRENTAFIJA,
  MCOD_POSTURA_1_MNTTRANSRENTAFIJA,
MONEDA_MNTTRANSRENTAFIJA,
DIAS_MNTTRANSRENTAFIJA,

BANDERA_CAMBIO_DE_COMPRADOR_MNTTRANSRENTAFIJA,
CODIGO_USUARIO_COMPRADOR_MNTTRANSRENTAFIJA,
CODIGO_BV_USUARIO_COMPRADOR_MNTTRANSRENTAFIJA,
CODIGO_PRIMARYUSER_COMPRADOR_MNTTRANSRENTAFIJA,
DATOS_SUCURSAL_COMPRADOR_MNTTRANSRENTAFIJA,
    CODIGO_SUCURSAL_COMPRADOR_MNTTRANSRENTAFIJA,
    SUCURSAL_4C_COMPRADOR_MNTTRANSRENTAFIJA,
    CIUDAD_COMPRADOR_MNTTRANSRENTAFIJA,
CODIGO_BV_SUCURSAL_COMPRADOR_MNTTRANSRENTAFIJA,
BANDERA_CAMBIO_DE_VENDEDOR_MNTTRANSRENTAFIJA,
CODIGO_USUARIO_VENDEDOR_MNTTRANSRENTAFIJA,
CODIGO_BV_USUARIO_VENDEDOR_MNTTRANSRENTAFIJA,
CODIGO_PRIMARYUSER_VENDEDOR_MNTTRANSRENTAFIJA,
DATOS_SUCURSAL_VENDEDOR_MNTTRANSRENTAFIJA,
    CODIGO_SUCURSAL_VENDEDOR_MNTTRANSRENTAFIJA,
    SUCURSAL_4C_VENDEDOR_MNTTRANSRENTAFIJA,
    CIUDAD_VENDEDOR_MNTTRANSRENTAFIJA,
CODIGO_BV_SUCURSAL_VENDEDOR_MNTTRANSRENTAFIJA,
CODIGO_USUARIO_INTERMEDIARIO_MNTTRANSRENTAFIJA,
CODIGO_BV_USUARIO_INTERMEDIARIO_MNTTRANSRENTAFIJA,
CODIGO_PRIMARYUSER_INTERMEDIARIO_MNTTRANSRENTAFIJA,
DATOS_SUCURSAL_INTERMEDIARIO_MNTTRANSRENTAFIJA,
    CODIGO_SUCURSAL_INTERMEDIARIO_MNTTRANSRENTAFIJA,
    SUCURSAL_4C_INTERMEDIARIO_MNTTRANSRENTAFIJA,
    CIUDAD_INTERMEDIARIO_MNTTRANSRENTAFIJA,
CODIGO_BV_SUCURSAL_INTERMEDIARIO_MNTTRANSRENTAFIJA,
CODIGO_USUARIO_SIF_ATT_COMPRADOR_MNTTRANSRENTAFIJA,
CODIGO_USUARIO_SIF_ATT_VENDEDOR_MNTTRANSRENTAFIJA,
BANDERA_NUEVO_PRECIO_MNTTRANSRENTAFIJA,
BANDERA_NUEVO_MONTO_MNTTRANSRENTAFIJA,
PRECIO_MNTTRANSRENTAFIJA,
MONTO_MNTTRANSRENTAFIJA,
BANDERA_PRIORIDAD_MNTTRANSRENTAFIJA,

DATOS_ADICIONALES_MNTTRANSRENTAFIJA,
BANDERA_VIA_INTERMEDIARIO_MNTTRANSRENTAFIJA,
MCOD_TRANSACCION_MNTTRANSRENTAFIJA,
MCOD_NUEVA_MNTTRANSRENTAFIJA,
PRECIO_1_MNTTRANSRENTAFIJA,
CODIGO_PRIMARYUSER_POSTURA_MNTTRANSRENTAFIJA,
CODIGO_PRIMARYUSER_POSTURA_1_MNTTRANSRENTAFIJA,
BANDERA_TRANSACCION_PENDIENTE_MNTTRANSRENTAFIJA,
C_V_MNTTRANSRENTAFIJA,
MCOD_NUEVA_1_MNTTRANSRENTAFIJA,

#endif

#if (DAPI ||DMEAPP || DGIAPP || GDIAPP)
// Msg RETIRO EQUIPO
CODIGO_EQUIPO_RETIRO,
BANDERA_EQUIPO_RETIRO,
NOMBRE_USUARIO_RETIRO,
BANDERA_USUARIO_RETIRO,
#endif

#if DAPI || DGIAPP
// TRANS_MONEDA
DATOS_TMONEDA,
  DATOS_SUCURSAL_NUESTRA_TMONEDA,
      CODIGO_SUCURSAL_NUESTRA_TMONEDA,
      CODIGO_INSTITUCION_NUESTRA_TMONEDA,
          CIUDAD_3C_NUESTRA_TMONEDA,
          AGENCIA_NUESTRA_TMONEDA,
      SUCURSAL_4C_NUESTRA_TMONEDA,
      CIUDAD_NUESTRA_TMONEDA,
  USUARIO_NUESTRO_TMONEDA,
  DATOS_SUCURSAL_VENDEDOR_TMONEDA,
    CODIGO_SUCURSAL_VENDEDOR_TMONEDA,
      CODIGO_INSTITUCION_VENDEDOR_TMONEDA,
      CIUDAD_3C_VENDEDOR_TMONEDA,
      AGENCIA_VENDEDOR_TMONEDA,
    SUCURSAL_4C_VENDEDOR_TMONEDA,
    CIUDAD_VENDEDOR_TMONEDA,
  USUARIO_VENDEDOR_TMONEDA,
  DATOS_SUCURSAL_COMPRADOR_TMONEDA,
    CODIGO_SUCURSAL_COMPRADOR_TMONEDA,
      CODIGO_INSTITUCION_COMPRADOR_TMONEDA,
      CIUDAD_3C_COMPRADOR_TMONEDA,
      AGENCIA_COMPRADOR_TMONEDA,
    SUCURSAL_4C_COMPRADOR_TMONEDA,
    CIUDAD_COMPRADOR_TMONEDA,
  USUARIO_COMPRADOR_TMONEDA,
  DATOS_SUCURSAL_CLIENTE_VENDEDOR_TMONEDA,
    CODIGO_SUCURSAL_CLIENTE_VENDEDOR_TMONEDA,
      CODIGO_INSTITUCION_CLIENTE_VENDEDOR_TMONEDA,
      CIUDAD_3C_CLIENTE_VENDEDOR_TMONEDA,
      AGENCIA_CLIENTE_VENDEDOR_TMONEDA,
    SUCURSAL_4C_CLIENTE_VENDEDOR_TMONEDA,
    CIUDAD_CLIENTE_VENDEDOR_TMONEDA,
  USUARIO_CLIENTE_VENDEDOR_TMONEDA,
  DATOS_SUCURSAL_CLIENTE_COMPRADOR_TMONEDA,
   CODIGO_SUCURSAL_CLIENTE_COMPRADOR_TMONEDA,
    CODIGO_INSTITUCION_CLIENTE_COMPRADOR_TMONEDA,
    CIUDAD_3C_CLIENTE_COMPRADOR_TMONEDA,
    AGENCIA_CLIENTE_COMPRADOR_TMONEDA,
   SUCURSAL_4C_CLIENTE_COMPRADOR_TMONEDA,
   CIUDAD_CLIENTE_COMPRADOR_TMONEDA,
  USUARIO_CLIENTE_COMPRADOR_TMONEDA,
  BANDERA_COMPLETADA_TMONEDA,
  BANDERA_PIDE_ANULACION_TMONEDA,
  MERCADO_MASTER_TMONEDA,
  FACTOR_CONVERSION_TMONEDA,
  C_V_TMONEDA,
  COMISION_VENDEDOR_TMONEDA,
  COMISION_COMPRADOR_TMONEDA,
  FORMA_DE_PAGO_TMONEDA,
  MONEDA_CONTRAPARTE_TMONEDA,
  NUMERAL_CAMBIARIO_VENDEDOR_TMONEDA,
  NUMERAL_CAMBIARIO_COMPRADOR_TMONEDA,
    STP_BUYER_TMONEDA,
    STP_SELLER_TMONEDA,
    RELLENO_N_TMONEDA,
  FORMA_PAGO_VENDEDOR_TMONEDA,
  FORMA_PAGO_COMPRADOR_TMONEDA,
  BANDERA_DATOS_COMPLETADOS_TMONEDA,
  COMENTARIO_TMONEDA,
  COLOR_LETRAS_TRANSACCION_TMONEDA,
  LUZ_CONTRAPARTE_TMONEDA,
  BANDERAS_USUARIOS_TMONEDA,
  USUARIO_OTRO_TMONEDA,
  USUARIO_CLIENTE_OTRO_TMONEDA,
  NUMERO_FINAL_TMONEDA,
  DATOS_SUCURSAL_OTRA_TMONEDA,
    CODIGO_SUCURSAL_OTRA_TMONEDA,
      CODIGO_INSTITUCION_OTRA_TMONEDA,
      CIUDAD_3C_OTRA_TMONEDA,
      AGENCIA_OTRA_TMONEDA,
    SUCURSAL_4C_OTRA_TMONEDA,
    CIUDAD_OTRA_TMONEDA,
  DATOS_SUCURSAL_CLIENTE_OTRA_TMONEDA,
    CODIGO_SUCURSAL_CLIENTE_OTRA_TMONEDA,
      CODIGO_INSTITUCION_CLIENTE_OTRA_TMONEDA,
      CIUDAD_3C_CLIENTE_OTRA_TMONEDA,
      AGENCIA_CLIENTE_OTRA_TMONEDA,
    SUCURSAL_4C_CLIENTE_OTRA_TMONEDA,
    CIUDAD_CLIENTE_OTRA_TMONEDA,
  NUMERO_SUCURSAL_COMPRADOR_TMONEDA,
  NUMERO_USUARIO_COMPRADOR_TMONEDA,
  NUMERO_SUCURSAL_VENDEDOR_TMONEDA,
  NUMERO_USUARIO_VENDEDOR_TMONEDA,
  BANDERA_COMPLETADA_COMPRADOR_TMONEDA,
  BANDERA_COMPLETADA_VENDEDOR_TMONEDA,
  BACKOFFICE_TMONEDA,
  BANDERA_SOLICITANTE_TMONEDA,
  BANDERA_TRANSMISION_COMITENTES_TMONEDA,
  BANDERA_REGISTRADOR_TMONEDA,
  ESTADO_GUIBOS_TMONEDA,
  BANDERA_ESTADO_TMONEDA,
  BANDERA_TRANSACCION_PENDIENTE_TMONEDA,
  COLOR_TRANSACCION_TMONEDA,
  BANDERA_USUARIO_NUESTRO_TMONEDA,
  DATOS_SUCURSAL_CLIENTE_NUESTRA_TMONEDA,
    CODIGO_SUCURSAL_CLIENTE_NUESTRA_TMONEDA,
      CODIGO_INSTITUCION_CLIENTE_NUESTRA_TMONEDA,
      CIUDAD_3C_CLIENTE_NUESTRA_TMONEDA,
      AGENCIA_CLIENTE_NUESTRA_TMONEDA,
    SUCURSAL_4C_CLIENTE_NUESTRA_TMONEDA,
    CIUDAD_CLIENTE_NUESTRA_TMONEDA,
  USUARIO_CLIENTE_NUESTRO_TMONEDA,
INSTRUMENTO_TMONEDA,
TIPO_IDENTIFICACION_COMPRADOR_TMONEDA,
IDENTIFICACION_COMPRADOR_TMONEDA,
BANDERA_TIPO_ENTIDAD_COMPRADOR_TMONEDA,
CONSECUTIVO_COMPRADOR_TMONEDA,
TIPO_IDENTIFICACION_VENDEDOR_TMONEDA,
IDENTIFICACION_VENDEDOR_TMONEDA,
BANDERA_TIPO_ENTIDAD_VENDEDOR_TMONEDA,
CONSECUTIVO_VENDEDOR_TMONEDA,
PUNTOS_NEGOCIADOS_TMONEDA,
NOMBRE_TASA_REFERENCIAL_TMONEDA,
DESCRIPCION_OPCION_TMONEDA,
PRIMA_TMONEDA,
CONDICION_EJERCICIO_TMONEDA,
TASA_INTERES_EN_PESOS_TMONEDA,
TASA_INTERES_EN_USD_TMONEDA,
TIPO_OPERACION_VENDEDOR_TMONEDA,
TIPO_OPERACION_COMPRADOR_TMONEDA,
MONTO_COMISION_VENDEDOR_TMONEDA,
MONTO_COMISION_COMPRADOR_TMONEDA,
BANDERA_ESPECIAL_FIDUCIARIO_COMPRADOR_TMONEDA,
CODIGO_ESPECIAL_FIDUCIARIO_COMPRADOR_TMONEDA,
BANDERA_ESPECIAL_FIDUCIARIO_VENDEDOR_TMONEDA,
CODIGO_ESPECIAL_FIDUCIARIO_VENDEDOR_TMONEDA,
RELLENO_U_TMONEDA,  
BANDERA_REGISTRO_TMONEDA,
BANDERA_TIPO_TMONEDA,
CODIGO_INSTITUCION_1_TMONEDA,
BANDERA_CAMBIO_COMPRADOR_TMONEDA,
CODIGO_BANCO_COMPRADOR_ANTERIOR_TMONEDA,
BANDERA_CAMBIO_VENDEDOR_TMONEDA,         
CODIGO_BANCO_VENDEDOR_ANTERIOR_TMONEDA,
BANDERA_CONFIRMACION_TMONEDA,  
#endif

#ifdef DAPI
// CITIES
DATOS_CITY,

  CODIGO_3C_CITY,
  LETRA_CIUDAD_CITY,
  RELLENO_A_CITY,
  NOMBRE_CITY,
  NOMBRE_CITY_1,
  NOMBRE_CITY_2,
  NOMBRE_CITY_3,
  NOMBRE_CITY_4,
  NOMBRE_CITY_5,
  NOMBRE_CITY_6,
  CODIGO_GUIBOS_CITY,
  RELLENO_CITY,

// COUNTRIES
DATOS_COUNTRY,

  CODIGO_COUNTRY,
  RELLENO_A_COUNTRY,
  NOMBRE_CORTO_COUNTRY,
  NOMBRE_CORTO_1_COUNTRY,
  NOMBRE_CORTO_2_COUNTRY,
  NOMBRE_CORTO_3_COUNTRY,
  NOMBRE_CORTO_4_COUNTRY,
  NOMBRE_CORTO_5_COUNTRY,
  NOMBRE_CORTO_6_COUNTRY,
  NOMBRE_COUNTRY,
  NOMBRE_1_COUNTRY,
  NOMBRE_2_COUNTRY,
  NOMBRE_3_COUNTRY,
  NOMBRE_4_COUNTRY,
  NOMBRE_5_COUNTRY,
  NOMBRE_6_COUNTRY,
  RELLENO_COUNTRY,

//MONEYS
DATOS_MONEY,

  CODIGO_MONEY,
  MONEDA_MONEY,
  RELLENO_A_MONEY,
  NOMBRE_MONEY,
  NOMBRE_1_MONEY,
  NOMBRE_2_MONEY,
  NOMBRE_3_MONEY,
  NOMBRE_4_MONEY,
  NOMBRE_5_MONEY,
  NOMBRE_6_MONEY,
  ULTIMO_PRECIO_MONEY,
  PICTURE_PRECIO_MONEY,

// message version control
DATOS_VRSCTRL                                    ,
                                                  
   CODIGO_PRIMARYUSER_CONTROL_VRSCTRL            ,
     PAIS_DATAMANAGER_CONTROL_VRSCTRL            ,
     SECUENCIAL_CONTROL_VRSCTRL                  ,
   SUCURSAL_REMITENTE_VRSCTRL                    ,
     CODIGO_UNICO_INSTITUCION_VRSCTRL            ,
     CODIGO_CIUDAD_3C_VRSCTRL                    ,
     CODIGO_AGENCIA_VRSCTRL                      ,
   SUCURSAL_4C_VRSCTRL                           ,
   BANDERA_INGRESO_SUCURSAL_VRSCTRL              ,
   CLASE_MENSAJE_VRSCTRL                         ,
   VERSION_OBJETOS_VRSCTRL                       ,
   FECHA_WDF_VRSCTRL                             ,
   HORA_WDF_VRSCTRL                              ,
   NUMERO_ARCHIVOS_DATOS_INMEDIATOS_VRSCTRL      ,
   NUMERO_ARCHIVOS_OBJETOS_INMEDIATOS_VRSCTRL    ,
   NOMBRE_VERSION_ACTUAL_VRSCTRL                 ,
   ESTADO_VERSION_ACTUAL_VRSCTRL                 ,
   BANDERA_TIPO_ACTUALIZACION_VRSCTRL            ,
   NOMBRE_VERSION_SIGUIENTE_VRSCTRL              ,
   ESTADO_VERSION_SIGUIENTE_VRSCTRL              ,
   TIPO_ACTUALIZACION_VRSCTRL                    ,
   FECHA_ACTUALIZACION_VRSCTRL                   ,
   VERSION_SISTEMA_VRSCTRL                       ,
   CODIGO_USUARIO_VRSCTRL                        ,
   NOMBRE_USUARIO_VRSCTRL                        ,
   PRIMARYUSER_DPROXY_VRSCTRL                    ,
   BANDERA_DM_CLIENT_VRSCTRL                     ,
   BITMAP_MARCADO_VRSCTRL                        ,
   RELLENO_VRSCTRL                               ,

   // Mensaje para modificacin de comentario en trasacciones
   DATOS_TRANSCOMMENT                                ,
   CLASE_TITULO_TRANSCOMMENT                         ,
   CODIGO_TITULO_TRANSCOMMENT                        ,
   MERCADO_TRANSCOMMENT                              ,
   HORA_TRANSACCION_TRANSCOMMENT                     ,
   CODIGO_TRANSCOMMENT                               ,
   CODIGO_POSTURA_TRANSCOMMENT                       ,
   USUARIO_POSTURA_COMENTARIO_TRANSCOMMENT           , 
   MCOD_POSTURA_COMENTARIO_TRANSCOMMENT              , 
   CODIGO_POSTURA_1_TRANSCOMMENT                     ,
   USUARIO_POSTURA_1_COMENTARIO_TRANSCOMMENT         , 
   MCOD_POSTURA_1_COMENTARIO_TRANSCOMMENT            , 
   C_V_TRANSCOMMENT                                  ,
   DIAS_TRANSCOMMENT                                 ,
   RENTABILIDAD_TRANSCOMMENT                         ,
   PRECIO_TRANSCOMMENT                               ,
   VALOR_TRANSCOMMENT                                ,
   VENCIMIENTO_TRANSCOMMENT                          ,
   BANDERA_TRANSCOMMENT                              ,
   COMENTARIO_TRANSCOMMENT                           ,
   FECHA_TRANSACCION_TRANSCOMMENT                    ,
   PRIMARYUSER_TRANSACCION_TRANSCOMMENT              ,
   MCOD_TRANSACCION_TRANSCOMMENT                     ,
   BANDERA_PUBLICAR_COMENTARIO_TRANSCOMMENT          ,
   CODIGO_INSTITUCION_POSTURA_TRANSCOMMENT           ,
   CODIGO_INSTITUCION_POSTURA_1_TRANSCOMMENT         ,
   CODIGO_BANCO_POSTURA_TRANSCOMMENT                 ,
   CODIGO_BANCO_POSTURA_1_TRANSCOMMENT               ,
   CODIGO_EXTERNO_TRANSCOMMENT                       ,
   SUB_MERCADO_TRANSCOMMENT                          ,
   BANDERA_BROKER_POSTURA_TRANSCOMMENT               ,
   BANDERA_BROKER_POSTURA_1_TRANSCOMMENT             ,
   BANDERAS_TRANSACCION_TRANSCOMMENT                 ,
   RELLENO_TRANSCOMMENT                              ,
#endif

#if DAPI || GDIAPP || DMEAPP
// CGTVoiceGroup (Groups of voice terms)
DATOS_VOICEGROUP                             ,

CODIGO_VOICEGROUP                            ,
PAIS_DATAMANAGER_VOICEGROUP                  ,
SECUENCIAL_VOICEGROUP                        ,
CODIGO_SUPER_GRUPO_VOICEGROUP                ,
NOMBRE_VOICEGROUP                            ,
NOMBRE_1_VOICEGROUP                          ,
NOMBRE_2_VOICEGROUP                          ,
NOMBRE_3_VOICEGROUP                          ,
NOMBRE_4_VOICEGROUP                          ,
NOMBRE_5_VOICEGROUP                          ,
NOMBRE_6_VOICEGROUP                          ,
COLOR_FONDO_FRANJA_VOICEGROUP                ,
COLOR_LETRA_FRANJA_VOICEGROUP                ,
NUMERO_GRUPO_VOICEGROUP                      ,
FACTOR_DE_CALCE_VOICEGROUP                   ,
CODIGO_ALTERNO_VOICEGROUP                    ,
ORDEN_POSTURAS_VOICEGROUP                    ,
CLASE_FUTURO_VOICEGROUP                      ,
CODIGO_MERCADO_RF_VOICEGROUP                 , 
MONTOS_MAXIMOS_MINIMOS_VOICEGROUP            ,
MONTO_MAXIMO_MISMO_DIA_VOICEGROUP            ,
MONTO_MAXIMO_PLAZO_VOICEGROUP                ,
MONTO_MINIMO_MISMO_DIA_VOICEGROUP            ,
MONTO_MINIMO_PLAZO_VOICEGROUP                , 
BANDERA_MONTOS_MINIMOS_VOICEGROUP            ,
TIEMPO_RESTABLECER_CIERRES_VOICEGROUP        ,
PICTURE_PRECIO_VOICEGROUP                    ,
PICTURE_MONTOS_VOICEGROUP                    ,
NO_USA_CUPOS_VOICEGROUP                      ,
RELLENO_VOICEGROUP                           ,
#endif

#ifdef DAPI
// CGTFixedIncomeMarkets (Markets of Fixed Income)
DATOS_FIXEDINCOMEMARKETS                      ,
                                                  
CODIGO_FIXEDINCOMEMARKETS                     ,
PAIS_DATAMANAGER_FIXEDINCOMEMARKETS           ,
SECUENCIAL_FIXEDINCOMEMARKETS                 ,
NOMBRE_FIXEDINCOMEMARKETS                     ,
NOMBRE_1_FIXEDINCOMEMARKETS                   ,
NOMBRE_2_FIXEDINCOMEMARKETS                   ,
NOMBRE_3_FIXEDINCOMEMARKETS                   ,
NOMBRE_4_FIXEDINCOMEMARKETS                   ,
NOMBRE_5_FIXEDINCOMEMARKETS                   ,
NOMBRE_6_FIXEDINCOMEMARKETS                   ,
RELLENO_FIXEDINCOMEMARKETS                    ,

// CGTHistoryTransDayTerm (HistoryTransaction Day Termi)
DATOS_HISTORYTRANSDAYTERM                        ,

FECHA_HISTORIA_HISTORYTRANSDAYTERM               ,
ANO_HISTORYTRANSDAYTERM                          ,
MES_HISTORYTRANSDAYTERM                          ,
DIA_HISTORYTRANSDAYTERM                          ,
MERCADO_HISTORYTRANSDAYTERM                      ,
DATOS_PRECIO_MONTO_RF_69_DIA_HISTORYTRANSDAYTERM ,
PRECIO_APERTURA_HISTORYTRANSDAYTERM              ,
PRECIO_CIERRE_HISTORYTRANSDAYTERM                ,
PRECIO_PROMEDIO_HISTORYTRANSDAYTERM              ,
PRECIO_MINIMO_HISTORYTRANSDAYTERM                , 
PRECIO_MAXIMO_HISTORYTRANSDAYTERM                ,
PRECIO_PROMEDIO_CALCULOS_HISTORYTRANSDAYTERM     ,
PRECIO_POR_MONTO_TOTAL_HISTORYTRANSDAYTERM       ,
MONTO_TOTAL_HISTORYTRANSDAYTERM                  ,
MONTO_MINIMO_HISTORYTRANSDAYTERM                 ,
MONTO_MAXIMO_HISTORYTRANSDAYTERM                 ,
MONTO_PROMEDIO_HISTORYTRANSDAYTERM               ,
NUMERO_TRANSACCIONES_HISTORYTRANSDAYTERM         ,
MONTO_ULTIMO_HISTORYTRANSDAYTERM                 ,
CODIGO_GRUPO_HISTORYTRANSDAYTERM                 ,
REFERENCIA_TITULO_HISTORYTRANSDAYTERM            ,
TEXTO_TERM_HISTORYTRANSDAYTERM                   ,
MONEDA_HISTORYTRANSDAYTERM                       ,
CONCERTACION_HISTORYTRANSDAYTERM                 ,
XDIAS_HISTORYTRANSDAYTERM                        ,
DIAS_HISTORYTRANSDAYTERM                         ,
FECHA_VALOR_HISTORYTRANSDAYTERM                  ,
HORA_ULTIMA_TRANSACCION_HISTORYTRANSDAYTERM      ,
HORA_PRIMERA_TRANSACCION_HISTORYTRANSDAYTERM     ,
CONSOLIDADO_HISTORYTRANSDAYTERM                  ,
COLOR_ULTIMA_TRANS_PRECIO_HISTORYTRANSDAYTERM    ,
COLOR_ULTIMA_TRANS_MONTO_HISTORYTRANSDAYTERM     ,
TENDENCIA_DEMANDA_HISTORYTRANSDAYTERM            ,
TIPO_OPERACION_HISTORYTRANSDAYTERM               ,
CAMA_DE_MONTO_HISTORYTRANSDAYTERM                ,
LINEA_PICO_HISTORYTRANSDAYTERM                   ,
PENDIENTE_HISTORYTRANSDAYTERM                    ,
HORA_PARA_TITILAR_HISTORYTRANSDAYTERM            ,
ORDEN_OPERACION_HISTORYTRANSDAYTERM              ,
BANDERA_MODIFICACION_HISTORYTRANSDAYTERM         ,
CODIGO_UNICO_REGISTRO_RESUMENES_HISTORYTRANSDAYTERM,

PRECIO_ULTIMO_HECHO_HISTORYTRANSDAYTERM          ,
BANDERA_ELIMINACION_HISTORYTRANSDAYTERM          ,
ESCALA_PRECIO_HISTORYTRANSDAYTERM                ,
RELLENO_HISTORYTRANSDAYTERM                      ,
CODIGO_EMISION_HISTORYTRANSDAYTERM               ,

// CGTRates (rates)
DATOS_RATES                 ,
                                                 
CODIGO_RATES                ,
BANDERA_RATES               ,
DIAS_TIIE_RATES             ,
RELLENO_1_RATES             ,
VALOR_1_RATES               ,
VALOR_2_RATES               ,
VALOR_3_RATES               , 
ETIQUETA_SUB_RATES          ,
HORA_RATES                  ,
HORA_U_H_RATES              ,
FECHA_REGISTRO_RATES        ,
RELLENO_RATES               ,

#endif

#ifdef DMEAPP
// TIME - CHECK
TC_PU_DESTINO,
TC_HORA,
TC_PU_ORIGEN,
TC_CONTADOR,
TC_TIEMPOS,
#endif

// CMsgEndTransaction, Message after a transaction to be sent to Dapi PU's.
MERCADO_LOGTRANSACTION    ,
O_D_LOGTRANSACTION        ,
MONTO_TOTAL_LOGTRANSACTION,
PRECIO_LOGTRANSACTION     ,
CODIGO_UNICO_REGISTRO_RESUMENES_LOGTRANSACTION,

// DMLIST message fields that come after cabeza header.
NUMERO_DATAMANAGERS,
CODIGO_PU_DATAMANAGER,

// DMTLIST
DMT_TIPO_SERVIDOR,
DMT_NUMERO,
DMT_CODIGO_EQUIPOS,

// ORDER global table fields.
DATOS_GLOBALES,

DATOS_POSTULANTE,
CODIGO_PRIMARYUSER_POSTURA,
CODIGO_PRIMARYUSERS_POSTULANTE,
CODIGO_POSTURA,
USUARIO_POSTURA,
MCOD_POSTURA,
SUCURSAL_POSTULANTE,
CODIGO_SUCURSAL_POSTURA,
CODIGO_INSTITUCION_POSTURA,
CIUDAD_3C_POSTURA,
AGENCIA_POSTURA,
SUCURSAL_4C_POSTURA,
CIUDAD_POSTURA,
BANCO_POSTULANTE,
CODIGO_BANCO_POSTURA,
CODIGO_INSTITUCION_BANCO_POSTURA,
CIUDAD_3C_BANCO_POSTURA,
AGENCIA_BANCO_POSTURA,
SUCURSAL_4C_BANCO_POSTURA,
CIUDAD_BANCO_POSTURA,
USUARIO_BANCO,
BANDERA_CLIENTE_ETC_POSTURA,
BANDERA_SECTOR_FINANCIERO,
BANDERA_BROKER_POSTURA,
NOMBRE_CORTO_USUARIO_ETC,
NUMERO_SUCURSAL_POSTURA,
NUMERO_USUARIO_POSTURA,

BANDERA_COTIZACION_POSTURA,
BANDERA_TRANSACCION_VIGILADA,
BANDERA_VERSION_POSTULANTE,
BANDERA_PERMISO_ANULACION,
BANDERA_POSTURA_SPREAD,
BANDERA_ULTIMO_HECHO,
SISTEMA_ORIGEN,
DATOS_POSTURA,
DATOS_GENERALES_POSTURA,
MERCADO,
SUB_MERCADO,
O_D,
BANDERA_VIA_PROCESAMIENTO,
HORA_OPERACION,
HORA_OPERACION_POSTULANTE,
TICKS_OPERACION,
HORA_PARA_TITILAR,
FECHA_POSTURA,
FECHA_RONDA,
HORA_POSTURA,
TOTAL_POSTURA,
FECHA_VALOR,
FECHA_ENTREGA,
DIAS,
XDIAS,
FECHA_VENCIMIENTO_XDIAS,
NIVEL,
TEXTO_TERM_EXTENDIDO,
TEXTO_TERM,
BANDERA_FISICO_COMPENSACION,
BANDERA_ESTANDAR_LIBRE,
IDENTIFICADOR_BONO,
IDENTIFICADOR_GRUPO_POSTURAS,
IDENTIFICADOR_GRUPO_POSTURAS_A,
IDENTIFICADOR_GRUPO_POSTURAS_B,
BANDERA_RETIRAR_POSTURA_TRANS_PARCIAL,
PRECIO,
PRECIO_C,
PRECIO_TRANSADO,
POINTS_FORWARD,
NUMERO,
NUMERO_MINIMO,
NUMERO_TRANSADO,
NUMERO_TOTAL,
FRACCION_BASICA,
BANDERA_MINIMO,
BANDERA_FORMA_ADJUDICACION,
GRUPO_TITULO_CODIGO_ALTERNO,
BANDERA_OPERACION_AUTOMATICA,
BANDERA_AJUSTE_PRECIO,
BANDERA_INGRESADA_CON_CALCULOS,
BANDERA_TIPO_POSTURA,
BANDERA_RONDA,
OVERRIDE_INDICATIVE,
BANDERA_POSTURA_PENDIENTE,
BANDERA_OPCIONALIDAD,
BANDERA_ENLAZADA_POR_MONTO,
BANDERA_EFECTIVO_CHEQUE,
BANDERA_CLASE_POSTURA,
BANDERA_SUB_CLASE_POSTURA,
DATOS_PLAZO_ENLACE,
IDENTIFICADOR_PLAZO_ENLACE,
DIAS_ENLACE,
XDIAS_ENLACE,
DATOS_ENLACE_TIPO_RF_MX,
NIVEL_ENLACE,
FECHA_VENCIMIENTO_ENLACE,
TEXTO_TERM_ENLACE,
FECHA_ENLACE,
CURRENCY_PAIR,
RELLENO_FECHA_ENLACE,
RELLENO_TEXTO_TERM,
SUB_MERCADO_ENLACE,

CODIGO_GRUPO_ENLACE,
NOMBRE_TITULO_ENLACE,
FECHA_VALOR_ENLACE,
TIPO_OPERACION_ENLACE,

O_D_ENLACE,
DESCRIPCION_OPCION_PARTE_1,
BANDERA_POSTURA_CON_EXPIRACION,
HORA_EXPIRACION_POSTURA,
HORA_OPERACION_CONTESTANTE,
BANDERA_ENLACE_A_PRECIO_SPOT,
PRECIO_SPOT_MINIMO,
PRECIO_A,
PRECIO_SPOT_MAXIMO,
PRECIO_B,
CODIGO_ORDEN_ENLACE,
USUARIO_ORDEN_ENLACE,
MCOD_ORDEN_ENLACE,
CODIGO_ISIN_1,
SUCURSAL_INTERMEDIARIA_POSTULANTE,
CODIGO_SUCURSAL_INTERMEDIARIA_POSTURA,
CODIGO_INSTITUCION_INTERMEDIARIA_POSTURA,
CIUDAD_3C_INTERMEDIARIA_POSTURA,
AGENCIA_INTERMEDIARIA_POSTURA,
SUCURSAL_4C_INTERMEDIARIA_POSTURA,
CIUDAD_INTERMEDIARIA_POSTURA,
BANDERA_VIA_INTERMEDIARIO_POSTURA,
BANDERA_ENLACE_OTRO_MERCADO,
CODIGO_CATEGORIA,
BANDERAS_POSTURA,
TICKS_PRECIO_SPOT_MINIMO,
SEGUNDOS_PARA_INTERRUMPIR,
TICKS_PRECIO_SPOT_MAXIMO,
TIEMPO_VALIDEZ,
ACTUALIZAR_HORA_OPERACION,
BANDERAS_POSTURA_2,
BANDERAS_POSTURA_3,
NOMBRE_TASA,
BANDERA_POSTURA_ESPECIFICA,
CODIGO_POSTURA_ORIGINAL,
USUARIO_POSTURA_ORIGINAL,
MCOD_POSTURA_ORIGINAL,
CODIGO_REGISTRO_2,
BANDERA_CORRETAJE,
COMISION_POSTURA,
BANDERA_COMISION,
CLORDID_ACEPTACION,
ENTIDAD_PUBLICA_POSTULANTE,
CODIGO_ENTIDAD_PUBLICA,
ENTIDAD_PUBLICA_3C,
USUARIO_EQUIPO,
OPCION,
REGION,
BANDERA_PREFERENCIA,
FECHA_OPCION,
CRUZADA,
ENTIDAD_PUBLICA_AVISO,
CODIGO_ENTIDAD_PUBLICA_AVISO,
ENTIDAD_PUBLICA_3C_AVISO,
BANDERA_POSTURA_CON_EXPIRACION_1,
DATOS_MERCADOS_PAPELES,
DATOS_EMISION,
CODIGO_EMISION,
CODIGO_TITULO,
DELIM_CODIGO_TITULO,
EMISOR,
CODIGO_PAIS,
CODIGO_EMISOR,
IDENTIFICADOR_DE_MERCADO,
CODIGO_REGISTRO_1,
CODIGO_REGISTRO_1_PARTE_1,
REFERENCIA,
NUMERO_EMISION,
NUMERO_TRAMO,
NUMERO_COLOCACION,
CODIGO_TABLA_DESARROLLO,
CODIGO_BACK_OFFICE,
TIPO_IDENTIFICACION_CONTRAPARTE,
IDENTIFICACION_CONTRAPARTE,
BANDERA_TIPO_ENTIDAD_CONTRAPARTE,
BANDERA_ENVIAR_A_CO,
ETC_LOGIN_NAME,

RELLENO_ETC_LOGIN_NAME,
DETALLES,
BANDERA_VENCIMIENTO,
BANDERA_INTERESES,
TIPO_PAPEL,
DATOS_OPCIONALES_TITULO,
MONEDA,
MONEDA_1C,
FCM_BUYER,
VALOR_NOMINAL,
ETC_LOGIN_NAME_1,
FCM_SELLER,
LOTE_MAXIMO,
CALIFICACION_1,  
PREMIO_DESCUENTO,
BASE_DIAS_NUMERADOR,    
BASE_DIAS_DENOMINADOR,  
PERIODO_CAPITAL,        
PERIODO_INTERES,       
BANDERA_PERIODO_INTERES,
BANDERA_PERIODO_CAPITAL,
BANDERA_DESMATERIALIZADAS,
TIPO_INTERES,
ORDERID_BUYER,
TASA_INTERES,
BANDERA_TIPO_TASA,
DATOS_REAJUSTE_TASA,
NEMOTECNICO_RFQ,                     
ORDERID_SELLER,                      
CODIGO_TASA_REFERENCIAL_EXTENDIDO,   
TASA_REFERENCIAL,                    
CODIGO_FORMULA,                      
BANDERA_PUNTOS_PORCENTAJE,           
BANDERA_TASAS,                       
PUNTOS_EN_FORMULA,                   
PORCENTAJE_EN_FORMULA,               
BANDERA_TASA_REFERENCIAL_INICIAL,    
BANDERA_TASA_REFERENCIAL_FINAL,      
DIAS_MESES_TASA_REFERENCIAL_INICIAL, 
DIAS_MESES_TASA_REFERENCIAL_FINAL,   
FORMULA_REAJUSTE,
COMENTARIO_1,
TASA_RANGO_1,          
TASA_RANGO_2,          
TASA_RANGO_3,          
TASA_RANGO_4,          
MCOD_POSTURA_SPREAD_1, 
MCOD_POSTURA_SPREAD_2, 
RELLENO_COMENTARIO_1,  

COMENTARIO_2,
BANDERA_REAJUSTE,
BANDERA_PONDERADO,
CCP,
PERIODO_REAJUSTE,
BANDERA_PERIODO_REAJUSTE,
BANDERA_REAJUSTE_PERIODICO,
REFERENCIA_TITULO,
MCOD_TRANSACCION_2,
RELLENO_REFENCIA_TITULO,
CODIGO_ISIN,
SERIE_1,
FECHA_EMISION,
FECHA_VENCIMIENTO,
FV_ANIO_MES,
FV_ANIO,
FV_MES,
FV_DIA,
IB_FIRM_ID_BUYER,
PLAZO_TOTAL,
DIAS_2,
PLAZO_TOTAL1,
NOMBRE_TASA_INTERES_MONEDA_1,
BANDERA_PERIODICO,
DIAS_REAJUSTABILIDAD,
FCM_ACCOUNT_BUYER,
SALDO_AMORTIZAR,
INICIO_CUPON_VIGENTE_INT,
VENCIMIENTO_CUPON_VIGENTE_INT,
INICIO_CUPON_VIGENTE_CAP,
VENCIMIENTO_CUPON_VIGENTE_CAP,
SUCURSAL_REAL_BANCO_POSTURA,
INSTITUCION_REAL_BANCO_POSTURA,
RELLENO_SUC_REAL_BANCO_POSTURA,
UNIQUE_SWAP_IDENTIFIER,
INTERES_1,
INTERES_2,
FECHA_REAJUSTE,
INICIO_REAJUSTE_VIGENTE,
SUCURSAL_REAL_BANCO_POSTURA_1,
INSTITUCION_REAL_BANCO_POSTURA_1,
IB_BROKER_ACCOUNT_BUYER,
RELLENO_SUC_REAL_BANCO_POSTURA_1,
IB_BROKER_ACCOUNT_SELLER,
VENCIMIENTO_REAJUSTE_VIGENTE,
USUARIO_REAL_BANCO_POSTURA,
IB_GROUP_ID_BUYER,
USUARIO_REAL_BANCO_POSTURA_1,
IB_GROUP_ID_SELLER,
FCM_ACCOUNT_SELLER,
NUMERO_TITULOS,
NEMOTECNICO,
MONTO_EMITIDO,
CUPONES_SOBREPUESTOS,
CODIGO_REGISTRO_3,
SERIE,
CODIGO_GRUPO,
RESTRICCION,
CONCERTACION,
ERROR_SERIE,
RESTRICCION_PARA_ORDENAMIENTO,
BANDERA_RESTABLECER_HECHOS,
CLASE,
CODIGO_SUPER_GRUPO,
SECURED,
LISTED,
BANDERA_JUMBO,
TEXTO_ORIGEN_ADD,
LINEA,
LIQUIDACION,
TIPO_OPERACION,
CAMA_DE_MONTO,
SUBMITTINGBROKER_SELLER,
LINEA_PICO,
PERIODOS_TOTALES_GRACIA_CAPITAL,
ORDEN_OPERACION,
TOTAL_RFQ,
CODIGO_AMBIENTE_EMISION,

DESCRIPCION_OPCION_PARTE_3,
SUBTIPO_PAPEL,
BANDERA_INDICE_INGRESADO,
BANDERA_PROVISIONAL,
BANDERA_EMISION,
BANDERA_MECANISMO,
CLASE_PAPEL,
VENCIMIENTO_REAL,
DIAS_REAL,
PLAZO_TOTAL_REAL,
CUPON,
CARTA_COMPROMISO,
RENDIMIENTO,
RENDIMIENTO_C,
RENTABILIDAD,
RENTABILIDAD_C,
VALOR_A_NEGOCIAR_COMPLETO,
TERM,
PRECIO_DEMANDA_CONTESTANTE,
PRECIO_DEMANDA_CONTESTANTE_C,
PRECIO_DEMANDA_CONTESTANTE_1,
BANDERA_COMITENTE_PROPIO,
ID_COMITENTE_PROPIO,
PRECIO_DEMANDA_CONTESTANTE_2,
TIPO_ENTIDAD_COMITENTE_PROPIO,
TIPO_ID_COMITENTE_PROPIO,
DESCUENTO,
DIAS_TRANSCURRIDOS,
DIAS_RESTA,
DIAS_ULTIMO_PERIODO,
INTERESES_DEVENGADOS,
VALOR_A_NEGOCIAR,
MONTO_EN_DOLARES,
UNIQUE_PRODUCT_ID,
VALOR_EFECTIVO,
CODIGO_UNICO_OTRO_SISTEMA,
VALOR_TOTAL,
VALOR_MINIMO_SUBASTA,
PRECIO_SPOT_MEDIO,
CODIGO_EXTERNO,
DECRETO,
CLORDID_POSTURA,
FIX_MESSAGEID,
CADENA_DIAS_CUPON_ACTUAL,
DIAS_CUPON_SEGUN_BASE,
NUMERO_LINEA,
DIAS_REAL_CUPON,
NUMERO_VENTANA,
OMITIR_CIERRE_PI,
BANDERA_TIPO_DIAS_CIERRE_PI,
DATOS_MERCADOS_ACCIONES,
ACCION,
MONEDA_PRECIO_SPOT,
BANDERA_SUSPENSION,
BANDERA_POSTURA_MERCADO,
ESCALA_PRECIO,
PICTURE_PRECIO,
PICTURE_PRECIO_FINAL,
DIVISOR_PRECIO,
BANDERA_DERECHOS,
BANDERA_POSTURAS_EN_COMBINADA,
BANDERA_PASS_EN_CONTESTANTE,
PICTURE_MONTOS,
CODIGO_CATALOGO,
OTRA_MONEDA,
HORA_EXPIRACION_POSTURA_1,
NOMBRE_TITULO,
DATOS_TASAS_ADICIONALES,
TASA_DOLARES,
SUBMITTINGBROKER_BUYER,
TASA_MONEDA_LOCAL,
TASA_LIBOR,
TASA_SPREAD,
DETALLE_BILLETES,
BILLETES_1_DOLAR,
DIAS_CIERRE_PI,
BILLETES_5_DOLARES,
DIAS_CIERRE_DE_PLAZO,
CUENTA_CRCC_COMPRADOR,
BILLETES_10_DOLARES,
BILLETES_20_DOLARES,
BILLETES_50_DOLARES,
CUENTA_CRCC_VENDEDOR,
BILLETES_100_DOLARES,
BILLETES_2_DOLARES,
BANDERA_ESTADO_BILLETES,
BANDERA_SERIES_BILLETES,
BANDERA_ENTREGA_BILLETES,
DATOS_RUEDA,
NUMERO_RUEDA,
NUMERO_PAGINA,
CODIGO_INSTIT_DIRECTOR_RUEDA,
HORA_CIERRE_SUBASTA,
BANDERA_FORMA_RUEDA,
BANDERA_TASA,
BANDERA_ADJUDICACION,
BANDERA_CUANTA_TRANSFERENCIA,
BANDERA_CONFIRMADO_DIRECTOR,
BANDERA_RETIRO_CUSTODIA,
ORIGEN_ULTIMA_OPERACION,
ORIGEN_POSTURA,
PRECIO_2,
PORCENTAJE_CERRADAS,
BANDERA_PLAZO,
IP_ACREDITAR_COMPRADOR_MONEDA_1,
CALIFICACION,
IP_DEBITAR_COMPRADOR_MONEDA_2,
INSTITUCION_CALIFICADORA_RIESGO,
RELLENO_IP_DEBITAR,
NUMERO_RONDA,
MERCADO_REAL_RONDA,
DATOS_ASIGNACION,
NOMBRE_TASA_INTERES_MONEDA_2,
RENDIMIENTO_ASIGNADO,
PRECIO_OFERTA_POSTULANTE,
PRECIO_OFERTA_POSTULANTE_C,
PRECIO_OFERTA_POSTULANTE_1,
PRECIO_OFERTA_POSTULANTE_2,
PRECIO_OFERTA_POSTULANTE_2_A,
NUMERO_PEDIDO,
NUMERO_ASIGNADO,
PRECIO_ASIGNADO,
PRECIO_ASIGNADO_C,
PRECIO_DEMANDA_POSTULANTE,
PRECIO_DEMANDA_POSTULANTE_C,
PRECIO_DEMANDA_POSTULANTE_1,
BANDERA_COMITENTE_CONTRAPARTE,
TIPO_ID_COMITENTE_CONTRAPARTE,
ID_COMITENTE_CONTRAPARTE,
PRECIO_DEMANDA_POSTULANTE_2,
TIPO_ENTIDAD_COMITENTE_CONTRAPARTE,
PRECIO_DEMANDA_POSTULANTE_2_R,
VALOR_ACTUAL_DIVIDIDO_PARA_10,
MONTO_EFECTIVO_ASIGNADO,
PRECIO_OFERTA_CONTESTANTE,
PRECIO_OFERTA_CONTESTANTE_C,
PRECIO_OFERTA_CONTESTANTE_1,
PRECIO_OFERTA_CONTESTANTE_2,
PRECIO_OFERTA_CONTESTANTE_2_A,
PRECIO_OFERTA_CONTESTANTE_3_A,
BANDERA_O_D_ASIGNACION,
CODIGO_POSTURA_ACEPTACION,
NUMERO_LIQUIDACION,
HORA_EXPIRACION,
BANDERA_REVISAR_CALCE,
FECHA_CALIFICACION_RIESGO,
IP_DEBITAR_VENDEDOR_MONEDA_1,
IP_ACREDITAR_VENDEDOR_MONEDA_2,

//Dataserver Code to be included in Order Global Table
CODIGO_DATASERVER_ORDEN,
BANDERA_DIFERIDO,
// Special field for ETC customer supplied data. It comes after the record data and it is saved only
// the dgi app.
#ifndef GDIAPP
ETC_CUSTOMER_DATA,
#endif
// Order message data that comes after the order global table data.
DATOS_ADICIONALES_TRANSACCION,
PRECIO_SPOT,
PRECIO_FINAL,
IVA,
TML,
SEF_BROKER_ACCOUNT_BUYER,
SEF_BROKER_ACCOUNT_SELLER,
FIXINGFLAG,
PUNTOS_FW,
MARCA_PRECIO,
BANDERA_TRANSACCION_PARA_POSTULANTES,
MCOD_TRANSACCION,
CONTADOR,
BANDERAS_TRANSACCION,
#ifdef DAPI
BANDERAS_TRANSACCION2,
#endif
ADD_INTEREST,
BANDERA_FORMA_PAGO,
DATOS_ACEPTACION,
CODIGO_POSTURA_1,
USUARIO_POSTURA_1,
USUARIO_POSTURA_CONTESTANTE,
MCOD_POSTURA_1,
MCOD_POSTURA_CONTESTANTE,
SUCURSAL_ACEPTANTE,
SUCURSAL_CONTESTANTE,
CODIGO_SUCURSAL_POSTURA_1,
CODIGO_SUCURSAL_POSTURA_CONTESTANTE,
CODIGO_INSTITUCION_POSTURA_1,
CODIGO_INSTITUCION_POSTURA_CONTESTANTE,
CIUDAD_3C_POSTURA_1,
CIUDAD_3C_POSTURA_CONTESTANTE,
AGENCIA_POSTURA_1,
AGENCIA_POSTURA_CONTESTANTE,
SUCURSAL_4C_POSTURA_1,
SUCURSAL_4C_CONTESTANTE,
CIUDAD_POSTURA_1,
CIUDAD_CONTESTANTE,
BANCO_ACEPTANTE,
CODIGO_BANCO_POSTURA_1,
CODIGO_INSTITUCION_BANCO_POSTURA_1,
CIUDAD_3C_BANCO_POSTURA_1,
AGENCIA_BANCO_POSTURA_1,
SUCURSAL_4C_BANCO_POSTURA_1,
CIUDAD_BANCO_POSTURA_1,
USUARIO_BANCO_1,
BANDERA_CLIENTE_ETC_POSTURA_1,
BANDERA_SECTOR_FINANCIERO_1,
TOTAL_POSTURA_1,
BANDERA_ACEPTACION,
HORA_ACEPTACION,
CODIGO_COMITENTE_RFQ,
SUCURSAL_INTERMEDIARIA,
CODIGO_SUCURSAL_INTERMEDIARIA,
CODIGO_INSTITUCION_INTERMEDIARIA,
CIUDAD_3C_INTERMEDIARIA,
AGENCIA_INTERMEDIARIA,
SUCURSAL_4C_INTERMEDIARIA,
CIUDAD_INTERMEDIARIA,
USUARIO_SUCURSAL_INTERMEDIARIO,
USUARIO_EMPLEADO,
CODIGO_COMITENTE_RFQ_1,
SUCURSAL_INTERMEDIARIA_1,
CODIGO_SUCURSAL_INTERMEDIARIA_1,
CODIGO_INSTITUCION_INTERMEDIARIA_1,
CIUDAD_3C_INTERMEDIARIA_1,
AGENCIA_INTERMEDIARIA_1,
SUCURSAL_4C_INTERMEDIARIA_1,
CIUDAD_INTERMEDIARIA_1,
USUARIO_SUCURSAL_INTERMEDIARIO_1,
USUARIO_EMPLEADO_1,
BANDERA_BROKERAGE_COMPRADOR,
BANDERA_BROKERAGE_VENDEDOR,
BANDERA_VIA_INTERMEDIARIO_COMPRADOR,
BANDERA_VIA_INTERMEDIARIO_VENDEDOR,
CODIGO_PRIMARYUSER_POSTURA_1,
CODIGO_PRIMARYUSER_CONTESTANTE,
BANDERA_REGISTRA_CON_OTR,
BANDERA_ON_OFF_SCREEN,
BANDERA_CAMBIAN_CAMPOS_ADICIONALES,
BANDERA_ACEPTACION_PENDIENTE,
BANDERA_PROCEDENCIA,
BANDERA_VERSION_ACEPTANTE,
BANDERA_MODIFICADOR_PRIORIDAD,
COMISION_POSTURA_1,
SPREAD_TASA,
SUBMMITTER_TYPE_BUYER,
SUBMMITTER_TYPE_SELLER,
IB_FIRM_ID_SELLER,
RELLENO_SPREAD_TASA,
BANDERA_COMISION_1,
MCOD_TRANSACCION_1,
BANDERA_COTIZACION_POSTURA_1,
ENTIDAD_PUBLICA_ACEPTANTE,
CODIGO_ENTIDAD_PUBLICA_1,
NUMERO_SUCURSAL_POSTURA_1,
NUMERO_USUARIO_POSTURA_1,
ENTIDAD_PUBLICA_3C_1,
TEXTO_ORIGEN,
TICKS_ACEPTACION,
IDENTIFICADOR_LINK,
IDENTIFICADOR_LINK_A,
IDENTIFICADOR_LINK_B,
BANDERA_BROKER_POSTURA_1,
BANDERA_PRECIO_ACEPTADO,
BANDERAS_POSTURA_1,
REASONCODE,
BANDERA_AFECTA_UH,
BANDERA_TITILAR_UH,
TIPO_TRANSACCION,
DATOS_ANULACION_MODIFICACION,
USUARIO_SOLICITANTE,
HORA_ORIGINAL,
BANDERA_RETIRO_PARA_MODIFICAR,
BANDERA_HORA_ORIGINAL,
BANCO_DE_TRABAJO_C_V,
BANDERA_RESPALDO,
CODIGO_PRIMARYUSER_ORIGINAL,
FECHA_ORIGINAL,
BANDERA_O_D_ORIGINAL,
BANDERA_AGRESOR,

// FINALPENDING message fields that come after cabeza header.
BANDERA_TIPO_PROCESAMIENTO,
CODIGO_POSTURA_MIA,
    USUARIO_POSTURA_MIA,
    HORA_POSTURA_MIA,
NUMERO_POSTURAS_ACEPTADAS,
CODIGOS_OTRAS_POSTURAS,
                                                  
MERCADO_PENDING,
NUMERO_POSTURAS_MIAS,
CODIGOS_POSTURAS_ACEPTADAS,
                             
SECUENCIAL_POSTURAS_ACEPTADAS,
                                                  
RELLENO_2,

#ifdef DAPI
// Emisores global table
DATOS_EMISOR                                     ,
                                                  
  DATOS_CODIGO_EMISOR                            ,
    CODIGO_PAIS_EMISOR                           ,
    CODIGO_EMISOR_EMISOR                         ,
  NOMBRE_EMISOR                                  ,
  NOMBRE_CORTO_EMISOR                            ,
  ACTIVO_EMISOR                                  ,
  CODIGO_UNICO_INSTITUCION_EMISOR                ,
  BANDERA_MEZCLA_EMISOR                          ,
  TIPO_INSTRUMENTO_EMISOR                        ,
  RELLENO_1_EMISOR                               ,

// Tabla Global de Comitentes
DATOS_COMITENTE_COMITENTES                       ,
    CLASE_CODIGO_COMITENTES                      ,
    CODIGO_COMITENTE_COMITENTES                  ,
    NOMBRE_COMITENTES                            ,
      NOMBRE_1_COMITENTES                        ,
      NOMBRE_2_COMITENTES                        ,
    ORIGEN_COMITENTES                            ,
      SUCURSAL_INGRESA_COMITENTE_COMITENTES      ,
        CODIGO_UNICO_INSTITUCION_COMITENTES      ,
        CODIGO_CIUDAD_3C_COMITENTES              ,
        CODIGO_AGENCIA_COMITENTES                ,
      USUARIO_INGRESA_COMITENTE_COMITENTES       ,
    NO_MODIFICABLE_COMITENTES                    ,
    FECHA_INGRESO_MODIFICACION_COMITENTES        ,
    SECTOR_COMITENTES                            ,
    CODIGO_IMC_COMITENTES                        ,
    TIPO_INVERSIONISTA_COMITENTES                ,
    CONDICION_TRIBUTARIA_VJO_COMITENTES          ,
    PAIS_COMITENTES                              ,
    AUTORETENEDOR_COMITENTES                     ,
    SUJETO_COMITENTES                            ,
    EXENTO_IVA_COMITENTES                        ,
    TIPO_CAMBIO_COMITENTES                       ,
    CODIGO_CAMBIO_COMITENTES                     ,
    BANDERA_TIPO_ENTIDAD_COMITENTES              ,
    RELLENO_COMITENTES                           ,
    BANDERA_VERIFICADO_COMITENTES                ,

// Tabla Global de SubComitentes
DATOS_SUBCOMITENTE                               ,
  DATOS_COMITENTE_PADRE_SUBCOMITENTE             ,
    CLASE_CODIGO_PADRE_SUBCOMITENTE              ,
    CODIGO_COMITENTE_PADRE_SUBCOMITENTE          ,
  DATOS_SUBCOMITENTE_SUBCOMITENTE                ,
    CLASE_CODIGO_SUBCOMITENTE_SUBCOMITENTE       ,
    CODIGO_SUBCOMITENTE_SUBCOMITENTE             ,
  RELLENO_SUBCOMITENTE                           ,
BANDERA_VERIFICADO_SUBCOMITENTE                  ,

// Tabla global de fiduciarios
DATOS_ESPECIAL_FIDUCIARIO_FIDUCIARIOS            ,
                                                  
  CODIGO_INSTITUCION_NUESTRA_FIDUCIARIOS         ,
  CODIGO_FIDUCIARIO_FIDUCIARIOS                  ,
  NOMBRE_FIDUCIARIO_FIDUCIARIOS                  ,
  RELLENO_FIDUCIARIOS                            ,

// Tabla global de empleados
DATOS_EMPLOYEE                                  ,
                                                 
  CODIGO_EMPLOYEE                               ,
    PAIS_DATAMANAGER_EMPLOYEE                   ,
    SECUENCIAL_EMPLOYEE                         ,
  CODIGO_SUCURSAL_EMPLOYEE                      ,
    CODIGO_UNICO_INSTITUCION_EMPLOYEE           ,
    CODIGO_CIUDAD_3C_EMPLOYEE                   ,
    AGENCIA_EMPLEADO_EMPLOYEE                   ,
  SUCURSAL_4C_EMPLOYEE                          ,
  NOMBRE_COMPLETO_EMPLOYEE                      ,
  CARGO_EMPLOYEE                                ,
  CODIGO_IDENTIFICACION_EMPLOYEE                ,
  NUMERO_IDENTIFICACION_EMPLOYEE                ,
  ESTADO_EMPLOYEE                               ,
  RELLENO_EMPLOYEE                              ,

// Tabla global de esquemas
DATOS_ESQUEMA                                   ,
                                                 
  CODIGO_COMPARABLES_DMC_ESQUEMA                ,
    CODIGO_ESQUEMA_ESQUEMA                      ,
    TIPO_REGISTRO_ESQUEMA                       ,
    NOMBRE_ESQUEMA                              ,
    ID_ELEMENTO_ESQUEMA                         ,
    TIPO_ELEMENTO_ESQUEMA                       ,
    BANDERA_COLOR_ESQUEMA                       ,
  COLOR_RGB_1_ESQUEMA                           ,
  COLOR_RGB_2_ESQUEMA                           ,
  ESTILO_LINEA_ESQUEMA                          ,
  GROSOR_LINEA_ESSQUEMA                         ,
  BANDERA_MX_RF_ESQUEMA                         ,
  BANDERA_PIBLICADO_ESQUEMA                     ,
  RELLENO_ESQUEMA                               ,
BANDERA_VERIFICADO_ESQUEMA                      ,
#endif 

// Branches global table
DATOS_BRANCHES,

CODIGO_SUCURSAL_BRANCHES,
CODIGO_UNICO_INSTITUCION_BRANCHES,
CODIGO_CIUDAD_3C_BRANCHES,
CODIGO_AGENCIA,
CODIGO_PAIS_BRANCHES,
IDENTIFICADOR_4C,
IDENTIFICADOR_7C,
NOMBRE,
DIRECCION,
TELEFONO,
SONIDO_RUEDA,
BANDERA_CONFIRMA_REGISTRO,
ENVIAR_RFQ,
RELLENO_0,
CODIGO_RUC,
CODIGO_BV_1,
CODIGO_BV_2,
CODIGO_REUTER,
CODIGO_GUIBOS,
ACTIVO,
BANDERA_NO_MOSTRAR_NOMBRE, // BANDERA_NO_MOSTRAR_NOMBRE = N ==> no mostrar nombre
RELLENO_B_BRANCHES,
DIRECTOR_SUBASTA,
BANDERA_HISTORIA_TRANSACCIONES,
FILIACION_BV,
FILIACION_BV_1,
FILIACION_BV_2,
FILIACION_BV_3,
FILIACION_BV_4,
FILIACION_BV_5,
GRUPO_MERCADOS_BRANCHES,
CODIGO_BROKER_HOME,
BANDERA_HISTORIA_PRECIOS_POR_HORA,
BANDERA_CLS_BRANCHES,
BANDERA_PRECIOS_MONTOS_BRANCHES,
BANDERA_RFQ_BRANCHES,
CODIGO_BIC_BRANCHES,
RELLENO_1_BRANCHES,
DATOS_ADICIONALES,
CLASE_BRANCHES,
TIPO_ENTIDAD,
NOMBRE_CIUDAD,
CLASE_DERIVADA,

// RFGS Branches
DATOS_BRANCHESRFQS,                               
CODIGO_BRANCHESRFQS,                             
MERCADO_BRANCHESRFQS,                            
COD_REPLY_BRANCH_BRANCHESRFQS,                   
COD_REQUEST_BRANCH_BRANCHESRFQS,                 
FLAG_BRANCHESRFQS,                               
RELLENO_BRANCHESRFQS,                             

// RFQ Status Update Msg
DATOS_RFQUPDATE,
FLAG_RFQUPDATE,                                 
CODIGO_INF_RFQUPDATE,                           
INFORMACION_RFQUPDATE,                          
MERCADO_RFQUPDATE,                              
COD_REPLY_BRANCH_RFQUPDATE,                     
COD_REQUEST_BRANCH_RFQUPDATE,                   
RELLENO_RFQUPDATE,                              

//////
// User global table
DATOS_USER,
CODIGO_USUARIO,
PAIS_DATAMANAGER,
SECUENCIAL,
CODIGO_SUCURSAL_USUARIO,
CODIGO_UNICO_INSTITUCION_USUARIO,
CODIGO_CIUDAD_3C,
CODIGO_AGENCIA_USUARIO,
SUCURSAL_4C,
CODIGO_PRIMARYUSER_ACTUAL,
NOMBRE_CORTO,
NOMBRE_USUARIOS,

NOMBRE_COMPLETO,
CARGO,
TELEFONO_USUARIOS,
BANDERA_CUPOS,
BANDERA_ENVIAR_RUEDAS,
BANDERA_ENVIAR_MEMOS,
CODIGO_BV_1_USUARIOS,
CODIGO_BV_2_USUARIOS,
CODIGO_GUIBOS_USUARIOS,
CLASE_USUARIOS,
MES_DIA_CUMPLEANIOS,
ACCESO_MERCADOS_VER,
ACCESO_MERCADOS_OPERAR,
ACCESO_MERCADOS_RECIBIR_MENSAJES,
CODIGO_USUARIO_OTRO_AMBIENTE,
CODIGO_EQUIPO,
DIRECCION_MAIL,
BANDERA_ENVIAR_RECIBIR_DIALOGO,
CLAVE_NUNCA_EXPIRA,
PERMITIR_RATIFICAR_CLAVE,
CLAVE_TEMPORAL,
BANDERA_INGRESAR_PRECIOS_RFQ,
BANDERA_EJECUTAR_DMCLIENTE,
BANDERAS_ACCESOS,
APLICACION_PERMITIDA,
BANDERA_MODIFICAR_CUPO,
BANDERA_SUPERVISOR,
CLASE_SUPERVISOR,
BANDERA_REGISTRAR_POR_OTROS,
CODIGO_IDENTIFICACION,
NUMERO_IDENTIFICACION,
MODALIDAD_OPERATIVA,                          
BANDERA_HABILITAR_FILTRO_INSTITUT,            
ACCESO_MERCADOS_REGISTRAR,                    
BANDERA_PERMITE_CREAR_COMITENTES,             
BANDERA_PERMISO_IMPORTAR_TRANSAC,             
FECHA_RETIRO_AUX,                             
BANDERA_NO_MOSTRAR_NOMBRE_USR,  // BANDERA_NO_MOSTRAR_NOMBRE_USR = N ==> no mostrar nombre     
PISO_USUARIO_EBS,
IDENTIFICACION_USUARIO_EBS,
GRUPO_STRESS,
BANDERA_ACTIVO_STRESS,
BANDERA_LANZAR_CLIENTES_XDSTSC,
NOMBRE_USUARI_ETC,
BANDERA_ACCESOS_1,
MERCADO_ETC,
BANDERAS_ACCESOS_FIXING_SPOT,
BANDERAS_ACCESOS_RFQC,
RELLENO_USUARIOS,
DATOS_DATAMANAGER,
CLAVE_USUARIO_DATAMANAGER,
//CLAVE_USUARIO_DATAMANAGER_A,
CLAVE_USUARIO_1,
//CLAVE_USUARIO_1_A,
CLAVE_USUARIO_2,
//CLAVE_USUARIO_2_A,
CLAVE_USUARIO_3,
//CLAVE_USUARIO_3_A,
CLAVE_USUARIO_4,
//CLAVE_USUARIO_4_A,
CLAVE_USUARIO_5,
//CLAVE_USUARIO_5_A,
CLAVE_USUARIO_6,
//CLAVE_USUARIO_6_A,
FECHA_CAMBIO_CLAVE,
BANDERA_INGRESO,
DATOS_PRIMARYUSER_PUSUARIO,
LOCAL_PUSUARIO,
FECHA_RETIRO_PUSUARIO,
CONECTADO_PUSUARIO,
FECHA_ULTIMO_INGRESO_PUSUARIO,
HORA_ULTIMO_INGRESO_PUSUARIO,
HORAS_CONECTADAS_HOY_PUSUARIO,
MENSAJES_CHARLA_PUSUARIO,
EQUIPO_PUSUARIO,
PROGRAMA_USADO_PUSUARIO,
RELLENO_1_PUSUARIO,

// Markets Global Table
DATOS_MARKETS                                    ,

CODIGO_MARKETS                                   ,
NOMBRE_MARKETS                                   ,
NOMBRE_1_MARKETS,
NOMBRE_2_MARKETS,
NOMBRE_3_MARKETS,
NOMBRE_4_MARKETS,
NOMBRE_5_MARKETS,
NOMBRE_6_MARKETS,
NOMBRE_CORTO_MARKETS,
NOMBRE_CORTO_1_MARKETS,
NOMBRE_CORTO_2_MARKETS,
NOMBRE_CORTO_3_MARKETS,
NOMBRE_CORTO_4_MARKETS,
NOMBRE_CORTO_5_MARKETS,
NOMBRE_CORTO_6_MARKETS,
IDENTIFICADOR_GRUPO_MERCADOS                     ,
MONEDA_MARKETS                                   ,
MONEDA_CONTRAPARTE_MARKETS                       ,
PAIS_FERIADOS_1                                  ,
PAIS_FERIADOS_2                                  ,
REGLA_UNION_FERIADOS                             ,
BANDERA_VIA_PROCESAMIENTO_MARKETS                ,
PORCENTAJE_VALIDACION                            ,
BANDERA_HISTORIA_TRANSACCIONES_MARKETS           ,
BANDERA_RESUMEN_TRANSACCIONES_MARKETS            ,
BANDERA_CONFIRMAR_ANULACIONES_MARKETS            ,
TIEMPO_PARA_ANULACION                            ,
TIEMPO_PARA_CONFIRMACION_ANULACION               ,
BANDERA_CONFIRMAR_TRANSACCIONES                  ,
TIEMPO_PARA_CONFIRMACION_REGISTRO                ,
BANDERA_CALCULAR_IVA                             ,
PORCENTAJE_IVA                                   ,
BANDERA_MERCADO_SUBASTA                          ,
BANDERA_GENERA_INTERESES                         ,
BANDERA_ACEPTA_PRECIO_MODIFICADO_CON_VENTAJA     ,
BANDERA_RETIRAR_POSTURA_EN_NO_TRANSACCION        ,
BANDERA_TIPO_TASA_MARKETS                        ,
BANDERA_CALCULAR_POSICION                        ,
BANDERA_POSICION_SIN_PROMEDIO                    ,
BANDERA_MERCADO_INTERBANCARIO                    ,
BANDERA_MERCADO_FORWARD                          ,
BANDERA_SEMICIEGO                                ,
BANDERA_FACTOR_DE_CALCE                          ,
TIEMPO_PARA_COTIZAR                              ,
TIEMPO_PARA_ADJUDICAR                            ,
TIEMPO_PARA_PUBLICAR                             ,
BANDERA_MONTO_MINIMO                             ,
MONTO_MINIMO_MARKETS                             ,
BANDERA_MONTO_MAXIMO                             ,
MONTO_MAXIMO_MARKETS                             ,
LIMITE_MINIMO_MARKETS                            ,
HORA_APERTURA_MARKETS                            ,
HORA_CIERRE_MARKETS                              ,
SPREAD_MAXIMO_MARKETS                            ,
BANDERA_MONTO_MINIMO_EN_LIMITES_MARKETS          ,
BANDERA_SPREAD_MARKETS                           ,
BANDERA_CHEQUEAR_PORCENTAJE_VARIACION            ,
BANDERA_MERCADO_CON_RONDAS                       ,
BANDERA_PUBLICA_INFORMACION_DE_OTROS_MERCADOS    ,
HORA_FIN_DIA                                     ,
BANDERA_MODIFICAR_CUPOS_MARKETS                  ,
BANDERA_DIAS_COBRANZA                            ,
NUMERO_DIAS_COBRANZA                             ,
CODIGO_GUIBOS_MARKETS                            ,
CODIGO_ICAP_MARKETS                              ,
MONEDA_PRECIO_SPOT_MARKETS                       ,
BANDERA_FRACCION_BASICA                          ,
FRACCION_BASICA_MARKETS                          ,
BASE_MARKETS                                     ,
TIEMPO_PARA_CONFIRMACION_TRANSACCIONES           ,
BANDERA_TIEMPO_CONFIRMAR_TRANSACCIONES           ,
BANDERA_FRACCION_BASICA_PRECIO                   ,
FRACCION_BASICA_PRECIO                           ,
BANDERA_TITILAR_CAMBIOS_DE_MERCADO               ,
TIEMPO_TITILAR_CAMBIOS_DE_MERCADO                ,
NUMERO_POSTURAS_SUCURSAL                         ,
NEGOCIAR_PRECIO_SPOT_CIERTOS_PLAZOS              ,
CODIGO_INSTIT_GARANTIZADORA_MARKETS              ,
CODIGO_INSTIT_POSTULANTE_MARKETS                 ,
CODIGO_INSTIT_LIQUIDADORA_MARKETS                ,
VALUE_DATE_MONEDA_MARKETS                        ,
VALUE_DATE_MONEDA_CONTRAPARTE_MARKETS            ,
BANDERA_DIA_VALIDO_US_MARKETS                    ,
BANDERA_INGRESAR_POSTURA_FUERA_HORARIO_MARKETS   ,
BANDERA_CONTROL_REGISTRO_MONTO_MINIMO_MARKETS    ,
BANDERA_CONTROL_REGISTRO_MONTO_MAXIMO_MARKETS    ,
BANDERA_CONTROL_REGISTRO_FRACCION_BASICA_MARKETS ,
TIEMPO_PARA_INTERRUPCION_MARKETS                 ,
HORA_INICIO_ESTADISTICAS_MARKETS                 ,
HORA_CIERRE_ESTADISTICAS_MARKETS                 ,
ORDEN_COMPRA_VENTA_TIEMPO_DE_VIDA_MARKETS        ,
BANDERA_VER_NOMBRES_EN_PRECIOS_MONTOS_ANULADOS_MARKETS,

NO_PERMITIR_SUBASTAS_SPREAD_MARKETS              ,
CONTROLAR_TIEMPO_ADJUDICACION_MARKETS            ,
FACTOR_DISCRIMINACION_GRAFICO_MARKETS            ,
BANDERA_ADMINISTRACION_CREDITO_MARKETS           ,
TIEMPO_VALIDEZ_MARKETS                           ,
MONTO_INICIAL_CONVOCATORIA_MARKETS               ,
TIEMPO_MINIMO_MARKETS                            ,
BANDERA_REGISTRO_OTR_CON_CALCE_MARKETS           ,
TIEMPO_ADICIONAL_CAMBIO_CAMARA_MARKETS           ,
BANDERA_VALIDAR_FERIADOS_HOY_PARA_PENDIENTES_MARKETS,

BANDERA_CONTROL_CUPOS_NEGATIVOS_EN_REGISTRO_MARKETS, 

HORA_APERTURA_REGISTRO_MARKETS                   , 
HORA_CIERRE_REGISTRO_MARKETS                     , 
HORA_RETIRAR_POSTURAS_MARKETS                    , 
HORA_RECALCULO_CUPOS_MARKETS                     , 
TIEMPO_PARA_DERECHO_TANTO_MARKETS                ,
TIEMPO_ADICIONAL_DERECHO_TANTO_MARKETS           ,
TIEMPO_VIGENCIA_POSTURAS_RETIRADAS_MARKETS       ,
TERM_CHEQUEO_CUPOS_MARKETS                       ,
BANDERA_ACEPTAR_POSTURA_MAS_COMPETITIVA_MARKETS  ,
BANDERA_NO_ACEPTAR_POSTURAS_TOTAL_MARKETS        ,
BANDERA_ENVIAR_TRANSACCION_ROUTERS_MARKETS       ,
BANDERA_MERCADO_CON_BROKER_MARKETS               ,
BANDERA_CALCE_FIXING_MARKETS                     ,
BANDERA_TITILAR_TRANSACCION_DE_MERCADO_MARKETS   ,
TIEMPO_TITILAR_TRANSACCION_DE_MERCADO_MARKETS    ,
BANDERA_CALCE_AUTOMATICO_MARKETS                 ,
BANDERA_LOTE_MAXIMO_MARKETS                      ,
LOTE_MAXIMO_MARKETS                              ,
SIN_CUPOS_MARKETS                                ,
FIXING_X_DIA_X_INSTITUCION_MARKETS               ,
SPREAD_MIN_SPOT_MIDP_MARKETS                     ,
SPREAD_MIN_1M_MIDP_MARKETS                       ,
RELLENO_MARKETS                                  ,
NUMERO_ITERACIONES_PARA_IMPLICITAS_MARKETS       ,
BANDERA_VER_CODIGO_RFQ_MARKETS                   ,

DATOS_DDME_MERCADO                               , 
RELLENO_DATOS_DDME_MERCADO                       ,

DATOS_ADICIONALES_MERCADO                        ,
OUTRIGHT_POINT_PRECISION                         ,
POINTS_SCALE                                     ,
DAYS_BASE                                        ,
NEAR_RATE_LENGTH                                 ,
NEAR_RATE_DECIMALS                               ,
NEAR_RATE_ALTERNATIVE                            ,
OUTRIGHT_RATE_LENGTH                             ,
OUTRIGHT_RATE_DECIMALS                           ,
NEAR_AMOUNT_LENGTH_CCY1                          ,
NEAR_AMOUNT_DECIMALS_CCY1                        ,
NEAR_AMOUNT_LENGTH_CCY2                          ,
NEAR_AMOUNT_DECIMALS_CCY2                        ,
FAR_AMOUNT_LENGTH_CCY1                           ,
FAR_AMOUNT_DECIMALS_CCY1                         ,
FAR_AMOUNT_LENGTH_CCY2                           ,
FAR_AMOUNT_DECIMALS_CCY2                         ,
INTEREST_RATE_LENGTH                             ,
INTEREST_RATE_DECIMALS                           ,
POINTS_LENGTH                                    ,
POINTS_DECIMALS                                  ,
MINIMUM_AMOUNT_IN_TRADE                          ,
DEFAULT_CREDIT_POLICY_MARKETS                    ,
ESCALA_PRECIO_MARKETS                            ,
POSICION_PICTURE_PRECIO_MARKETS                  ,
POSICION_PICTURE_PRECIO_FINAL_MARKETS            ,
PAIS_DATAMANAGER_MARKETS                         ,
AMBIENTE_MERCADO_MARKETS                         ,

// These definitions have been created in order to
// maintain compatibily with previous system versions
DATOS_MARKETS_OLD                                ,
CODIGO_MARKETS_OLD                               ,
NOMBRE_MARKETS_OLD                               ,
NOMBRE_CORTO_MARKETS_OLD                         ,
CUERPO_COMUN_MERCADOS_OLD                        ,
DATOS_ADICIONALES_MERCADO_OLD                    ,
OUTRIGHT_POINT_PRECISION_OLD                     ,
POINTS_SCALE_OLD                                 ,
DAYS_BASE_OLD                                    ,
NEAR_RATE_LENGTH_OLD                             ,
NEAR_RATE_DECIMALS_OLD                           ,
NEAR_RATE_ALTERNATIVE_OLD                        ,
OUTRIGHT_RATE_LENGTH_OLD                         ,
OUTRIGHT_RATE_DECIMALS_OLD                       ,
NEAR_AMOUNT_LENGTH_CCY1_OLD                      ,
NEAR_AMOUNT_DECIMALS_CCY1_OLD                    ,
NEAR_AMOUNT_LENGTH_CCY2_OLD                      ,
NEAR_AMOUNT_DECIMALS_CCY2_OLD                    ,
FAR_AMOUNT_LENGTH_CCY1_OLD                       ,
FAR_AMOUNT_DECIMALS_CCY1_OLD                     ,
FAR_AMOUNT_LENGTH_CCY2_OLD                       ,
FAR_AMOUNT_DECIMALS_CCY2_OLD                     ,
INTEREST_RATE_LENGTH_OLD                         ,
INTEREST_RATE_DECIMALS_OLD                       ,
POINTS_LENGTH_OLD                                ,
POINTS_DECIMALS_OLD                              ,
MINIMUM_AMOUNT_IN_TRADE_OLD                      ,
DEFAULT_CREDIT_POLICY_MARKETS_OLD                ,
ESCALA_PRECIO_MARKETS_OLD                        ,
POSICION_PICTURE_PRECIO_MARKETS_OLD              ,
POSICION_PICTURE_PRECIO_FINAL_MARKETS_OLD        ,
PAIS_DATAMANAGER_MARKETS_OLD                     ,
AMBIENTE_MERCADO_MARKETS_OLD                     ,

// Summary global table (Voice markets)
DATOS_GLOBALES_VOICESUMMARY         ,

MERCADO_VOICESUMMARY                ,
TEXTO_TERM_VOICESUMMARY             ,
REFERENCIA_TITULO_VOICESUMMARY      ,
ORDEN_POSTURAS_VOICESUMMARY         ,
REFERENCIA_TITULO_1_VOICESUMMARY    ,
REFERENCIA_TITULO_2_VOICESUMMARY    ,
REFERENCIA_TITULO_3_VOICESUMMARY    ,
MONEDA_VOICESUMMARY                 ,
CODIGO_GRUPO_VOICESUMMARY           ,
CODIGO_SUPER_GRUPO_VOICESUMMARY     ,
FECHA_VALOR_VOICESUMMARY            ,
LIQUIDACION_VOICESUMMARY            ,
CONCERTACION_VOICESUMMARY           ,
XDIAS_VOICESUMMARY                  ,
DIAS_VOICESUMMARY                   ,
BANDERA_VENCIMIENTO_VOICESUMMARY    ,
BANDERA_ESTANDAR_LIBRE_VOICESUMMARY ,
BANDERA_CAMBIAR_COLOR_VOICESUMMARY  ,
COLOR_VOICESUMMARY                  ,
CAMA_DE_MONTO_VOICESUMMARY          ,
SECUENCIAL_FUTUROS_VOICESUMMARY     ,
BANDERA_PINTAR_LINEA_VOICESUMMARY   ,
CODIGO_LINEA_VOICESUMMARY           ,
TIPO_OPERACION_VOICESUMMARY         ,
LINEA_PICO_VOICESUMMARY             ,
CODIGO_EMISION_VOICESUMMARY         ,
BANDERA_TIPO_FUTURO_VOICESUMMARY    ,
ORIGEN_POSTURA_VOICESUMMARY         ,
CODIGO_MERCADO_RF_VOICESUMMARY      ,
CODIGO_BACK_OFFICE_VOICESUMMARY     ,
CODIGO_UNICO_TV_VOICESUMMARY        ,
FECHA_VENCIMIENTO_VOICESUMMARY      ,
NUMERO_PAGINA_VOICESUMMARY,
DATOS_LOCALES_VOICESUMMARY,                
  NUMERO_GRUPO_VOICESUMMARY,               
  NIVEL_VOICESUMMARY,                      
  SUB_NIVEL_VOICESUMMARY,                  
  CODIGO_VENTANA_VOICESUMMARY,             
  COLOR_DETALLES_INSTRUMENTO_VOICESUMMARY, 
  ESTILO_VOICESUMMARY,                     
  ULTIMO_MONTO_VOICESUMMARY,               
  ULTIMO_PRECIO_VOICESUMMARY,              
  HORA_ULTIMA_TRANSACCION_VOICESUMMARY,
  COLOR_ULTIMO_PRECIO_VOICESUMMARY,        
  TEXTO_COTEJAMIENTO_VOICESUMMARY,         
  TEXTO_COTEJAMIENTO_1_VOICESUMMARY,       
  NUMERO_LINEA_VOICESUMMARY,               
  TEXTO_LIQUIDACION_VOICESUMMARY,          
  ORDEN_OPERACION_VOICESUMMARY,            
  SECUENCIAL_1_VOICESUMMARY,               
  SECUENCIAL_2_VOICESUMMARY,               
  TV_VOICESUMMARY,                         
  TEXTO_MEZCLA_VOICESUMMARY,               
  NO_MOSTRAR_ULTIMO_HECHO_VOICESUMMARY,    
  FAVORITOS_VOICESUMMARY,                  
  TIPO_FAVORITOS_VOICESUMMARY,
  PICTURE_PRECIO_VOICESUMMARY,
  ESCALA_PRECIO_VOICESUMMARY,
  PICTURE_MONTOS_VOICESUMMARY,
  BANDERA_POSTURAS_RETIRADAS_VOICESUMMARY,
  MARCADO_VOICESUMMARY,
  BANDERA_IM_VOICESUMMARY,
  BANDERA_MM_VOICESUMMARY,
  ORDENES_COMPRA_VENTA_VOICESUMMARY,
  HORA_PARA_TITILAR_VOICESUMMARY,
  CODIGO_UNICO_INSTRUMENTO_DFIX_VOICESUMMARY,

// Super group global table (Voice markets)
DATOS_VOICESUPERGROUP         , 
CODIGO_VOICESUPERGROUP        ,
NOMBRE_VOICESUPERGROUP        ,
BANDERA_EMISOR_VOICESUPERGROUP,
EMISOR_VOICESUPERGROUP        ,
CLASE_REPO_VOICESUPERGROUP    ,
MIN_LINEA_VOICESUPERGROUP     ,
MAX_LINEA_VOICESUPERGROUP     ,
NUMERO_LINEAS_VOICESUPERGROUP ,
RELLENO_VOICESUPERGROUP       ,
// Field used internally to keep the number or current voice summary
// records belonging to this supergroup.
NUMERO_REGISTROS_SUPERGROUP,

#ifndef DAPI

// NAMECHECK global table fields.
DATOS_NAMECHECK,
MERCADO_CODIGO_SUCURSAL,
MERCADO_NAMECHECK,
CODIGO_SUCURSAL,
CODIGO_INSTITUCION_SUCURSAL,
CIUDAD_3C_SUCURSAL,
AGENCIA_SUCURSAL,
NUMERO_SUCURSAL_NAMECHECK,
ARREGLO_CHECK_NAME_COMPRA,
ARREGLO_CHECK_NAME_VENTA,
BANDERA_INDICADOR_CAMBIOS,
NUMERO_SUCURSAL_ULTIMO_CAMBIO,
CODIGO_SUCURSAL_ULTIMO_CAMBIO,
USUARIO_ORIGEN_CAMBIO,
RELLENO_NAMECHECK,
AVAILABLE_0001,
AVAILABLE_0002,
AVAILABLE_0003,
AVAILABLE_0004,
AVAILABLE_0005,
AVAILABLE_0006,
AVAILABLE_0007,
AVAILABLE_0008,
AVAILABLE_0009,

// Msg NMCHKPLZ
BANDERA_NMCHKPLZ,

// NAMECHECK CIERTOS PLAZOS (ANTES FREERISKTERM)
DATOS_NMCHKPLZ                                   ,
  MERCADO_NMCHKPLZ                               ,
  SUCURSAL_NUESTRA_NMCHKPLZ                      ,
    CODIGO_INSTITUCION_NUESTRA_NMCHKPLZ          ,
    CIUDAD_3C_NUESTRA_NMCHKPLZ                   ,
    AGENCIA_NUESTRA_NMCHKPLZ                     ,
  CODIGO_SUCURSAL_OTRA_NMCHKPLZ                  ,
    CODIGO_INSTITUCION_OTRA_NMCHKPLZ             ,
    CIUDAD_3C_NUESTRA_OTRA_NMCHKPLZ              ,
    AGENCIA_NUESTRA_OTRA_NMCHKPLZ                ,
  C_V_NMCHKPLZ                                   ,
  TEXTO_TERM_INICIAL_NMCHKPLZ                    ,
  TEXTO_TERM_FINAL_NMCHKPLZ                      ,
  BANDERA_AUTORIZACION_NMCHKPLZ                  ,
  RELLENO_NMCHKPLZ                               ,

//Term Table
MERCADO_TERM,
DATOS_BUSQUEDA_G7,
DIAS_TERM,
XDIAS_TERM,
NIVEL_TERM,
VENCIMIENTO_TERM,
TEXTO_TERM_TERM,
VENCIMIENTO_SPOT,
SECUENCIA,
BANDERA_PREDETERMINADO,
TEXTO_TERM_ALTERNO,
SUB_MERCADO_TERM,
FIXING_DATE_TERM,
BANDERA_ESTANDARD_LIBRE_TERM,

//Summary Table
DATOS_DETALLE_PLAZO,
DATOS_PLAZO,
MERCADO_PLAZO,
DATOS_BUSQUEDA_PLAZO,
DIAS_PLAZO,
XDIAS_PLAZO,
NIVEL_PLAZO,
FECHA_VENCIMIENTO_PLAZO,
TEXTO_TERM_PLAZO,
FECHA_VENCIMIENTO_XDIAS_PLAZO,
BANDERA_ESTANDAR_LIBRE_PLAZO,
REGISTRO_FIJO,
TEXTO_DIAS_PLAZO,
NUMERO_DEMANDAS_OFERTAS,

DATOS_DEMANDA,
DATOS_POSTULANTE_DEMANDA,
CODIGO_PRIMARYUSER_POSTURA_DEMANDA,
CODIGO_POSTURA_DEMANDA,
USUARIO_POSTURA_DEMANDA,
MCOD_POSTURA_DEMANDA,
SUCURSAL_POSTULANTE_DEMANDA,
CODIGO_SUCURSAL_POSTURA_DEMANDA,
CODIGO_INSTITUCION_POSTURA_DEMANDA,
CIUDAD_3C_POSTURA_DEMANDA,
AGENCIA_POSTURA_DEMANDA,
SUCURSAL_4C_POSTURA_DEMANDA,
CIUDAD_POSTURA_DEMANDA,
BANCO_POSTULANTE_DEMANDA,
CODIGO_BANCO_POSTURA_DEMANDA,
CODIGO_INSTITUCION_BANCO_POSTURA_DEMANDA,
CIUDAD_3C_BANCO_POSTURA_DEMANDA,
AGENCIA_BANCO_POSTURA_DEMANDA,
SUCURSAL_4C_BANCO_POSTURA_DEMANDA,
CIUDAD_BANCO_POSTURA_DEMANDA,
USUARIO_BANCO_DEMANDA,
BANDERA_CLIENTE_ETC_POSTURA_DEMANDA,
BANDERA_BROKER_POSTURA_DEMANDA,
NUMERO_SUCURSAL_POSTURA_DEMANDA,
NUMERO_USUARIO_POSTURA_DEMANDA,
RELLENO_POSTULANTE_DEMANDA,
DATOS_GENERALES_POSTURA_DEMANDA,
MERCADO_DEMANDA,
SUB_MERCADO_DEMANDA,
O_D_DEMANDA,
BANDERA_VIA_PROCESAMIENTO_DEMANDA,
HORA_OPERACION_DEMANDA,
TICKS_OPERACION_DEMANDA,
HORA_PARA_TITILAR_DEMANDA,
FECHA_POSTURA_DEMANDA,
HORA_POSTURA_DEMANDA,
TOTAL_POSTURA_DEMANDA,
FECHA_VALOR_DEMANDA,
FECHA_ENTREGA_DEMANDA,
DIAS_DEMANDA,
XDIAS_DEMANDA,
FECHA_VENCIMIENTO_XDIAS_DEMANDA,
NIVEL_DEMANDA,
TEXTO_TERM_DEMANDA,
BANDERA_FISICO_COMPENSACION_DEMANDA,
BANDERA_ESTANDAR_LIBRE_DEMANDA,
IDENTIFICADOR_GRUPO_POSTURAS_DEMANDA,
IDENTIFICADOR_GRUPO_POSTURAS_A_DEMANDA,
IDENTIFICADOR_GRUPO_POSTURAS_B_DEMANDA,
BANDERA_RETIRAR_POSTURA_TRANS_PARCIAL_DEMANDA,
PRECIO_DEMANDA,
POINTS_FORWARD_DEMANDA,
NUMERO_DEMANDA,
NUMERO_MINIMO_DEMANDA,
NUMERO_TRANSADO_DEMANDA,
NUMERO_TOTAL_DEMANDA,
FRACCION_BASICA_DEMANDA,
BANDERA_MINIMO_DEMANDA,
BANDERA_FORMA_ADJUDICACION_DEMANDA,
BANDERA_OPERACION_AUTOMATICA_DEMANDA,
BANDERA_AJUSTE_PRECIO_DEMANDA,
BANDERA_INGRESADA_CON_CALCULOS_DEMANDA,
BANDERA_TIPO_POSTURA_DEMANDA,
OVERRIDE_INDICATIVE_DEMANDA,
BANDERA_POSTURA_PENDIENTE_DEMANDA,
BANDERA_ENLAZADA_POR_MONTO_DEMANDA,
BANDERA_EFECTIVO_CHEQUE_DEMANDA,
BANDERA_CLASE_POSTURA_DEMANDA,
BANDERA_SUB_CLASE_POSTURA_DEMANDA,
DATOS_PLAZO_ENLACE_DEMANDA,
IDENTIFICADOR_PLAZO_ENLACE_DEMANDA,
DIAS_ENLACE_DEMANDA,
XDIAS_ENLACE_DEMANDA,
NIVEL_ENLACE_DEMANDA,
FECHA_VENCIMIENTO_ENLACE_DEMANDA,
TEXTO_TERM_ENLACE_DEMANDA,
SUB_MERCADO_ENLACE_DEMANDA,
O_D_ENLACE_DEMANDA,
BANDERA_POSTURA_CON_EXPIRACION_DEMANDA,
HORA_EXPIRACION_POSTURA_DEMANDA,
BANDERA_ENLACE_A_PRECIO_SPOT_DEMANDA,
PRECIO_SPOT_MINIMO_DEMANDA,
PRECIO_SPOT_MAXIMO_DEMANDA,
CODIGO_ORDEN_ENLACE_DEMANDA,
USUARIO_ORDEN_ENLACE_DEMANDA,
MCOD_ORDEN_ENLACE_DEMANDA,
SUCURSAL_INTERMEDIARIA_POSTULANTE_DEMANDA,
CODIGO_SUCURSAL_INTERMEDIARIA_POSTURA_DEMANDA,
CODIGO_INSTITUCION_INTERMEDIARIA_POSTURA_DEMANDA,
CIUDAD_3C_INTERMEDIARIA_POSTURA_DEMANDA,
AGENCIA_INTERMEDIARIA_POSTURA_DEMANDA,
SUCURSAL_4C_INTERMEDIARIA_POSTURA_DEMANDA,
CIUDAD_INTERMEDIARIA_POSTURA_DEMANDA,
BANDERA_VIA_INTERMEDIARIO_POSTURA_DEMANDA,
BANDERA_ENLACE_OTRO_MERCADO_DEMANDA,
CODIGO_CATEGORIA_DEMANDA,
BANDERAS_POSTURA_DEMANDA,
TICKS_PRECIO_SPOT_MINIMO_DEMANDA,
TICKS_PRECIO_SPOT_MAXIMO_DEMANDA,
ACTUALIZAR_HORA_OPERACION_DEMANDA                ,
BANDERAS_POSTURA_2_DEMANDA                       ,
BANDERAS_POSTURA_3_DEMANDA,
MONEDA_DEMANDA,
MONEDA_1C_DEMANDA,
FECHA_VENCIMIENTO_DEMANDA,
MONTO_TOTAL_DEMANDA,
TENDENCIA_DEMANDA,
NUMERO_POSTURAS_DEMANDA,
RELLENO_DEMANDA,

DATOS_OFERTA,
DATOS_POSTULANTE_OFERTA,
CODIGO_PRIMARYUSER_POSTURA_OFERTA,
CODIGO_POSTURA_OFERTA,
USUARIO_POSTURA_OFERTA,
MCOD_POSTURA_OFERTA,
SUCURSAL_POSTULANTE_OFERTA,
CODIGO_SUCURSAL_POSTURA_OFERTA,
CODIGO_INSTITUCION_POSTURA_OFERTA,
CIUDAD_3C_POSTURA_OFERTA,
AGENCIA_POSTURA_OFERTA,
SUCURSAL_4C_POSTURA_OFERTA,
CIUDAD_POSTURA_OFERTA,
BANCO_POSTULANTE_OFERTA,
CODIGO_BANCO_POSTURA_OFERTA,
CODIGO_INSTITUCION_BANCO_POSTURA_OFERTA,
CIUDAD_3C_BANCO_POSTURA_OFERTA,
AGENCIA_BANCO_POSTURA_OFERTA,
SUCURSAL_4C_BANCO_POSTURA_OFERTA,
CIUDAD_BANCO_POSTURA_OFERTA,
USUARIO_BANCO_OFERTA,
BANDERA_CLIENTE_ETC_POSTURA_OFERTA,
BANDERA_BROKER_POSTURA_OFERTA,
NUMERO_SUCURSAL_POSTURA_OFERTA,
NUMERO_USUARIO_POSTURA_OFERTA,
RELLENO_POSTULANTE_OFERTA,
DATOS_GENERALES_POSTURA_OFERTA,
MERCADO_OFERTA,
SUB_MERCADO_OFERTA,
O_D_OFERTA,
BANDERA_VIA_PROCESAMIENTO_OFERTA,
HORA_OPERACION_OFERTA,
TICKS_OPERACION_OFERTA,
HORA_PARA_TITILAR_OFERTA,
FECHA_POSTURA_OFERTA,
HORA_POSTURA_OFERTA,
TOTAL_POSTURA_OFERTA,
FECHA_VALOR_OFERTA,
FECHA_ENTREGA_OFERTA,
DIAS_OFERTA,
XDIAS_OFERTA,
FECHA_VENCIMIENTO_XDIAS_OFERTA,
NIVEL_OFERTA,
TEXTO_TERM_OFERTA,
BANDERA_FISICO_COMPENSACION_OFERTA,
BANDERA_ESTANDAR_LIBRE_OFERTA,
IDENTIFICADOR_GRUPO_POSTURAS_OFERTA,
IDENTIFICADOR_GRUPO_POSTURAS_A_OFERTA,
IDENTIFICADOR_GRUPO_POSTURAS_B_OFERTA,
BANDERA_RETIRAR_POSTURA_TRANS_PARCIAL_OFERTA,
PRECIO_OFERTA,
POINTS_FORWARD_OFERTA,
NUMERO_OFERTA,
NUMERO_MINIMO_OFERTA,
NUMERO_TRANSADO_OFERTA,
NUMERO_TOTAL_OFERTA,
FRACCION_BASICA_OFERTA,
BANDERA_MINIMO_OFERTA,
BANDERA_FORMA_ADJUDICACION_OFERTA,
BANDERA_OPERACION_AUTOMATICA_OFERTA,
BANDERA_AJUSTE_PRECIO_OFERTA,
BANDERA_INGRESADA_CON_CALCULOS_OFERTA,
BANDERA_TIPO_POSTURA_OFERTA,
OVERRIDE_INDICATIVE_OFERTA,
BANDERA_POSTURA_PENDIENTE_OFERTA,
BANDERA_ENLAZADA_POR_MONTO_OFERTA,
BANDERA_EFECTIVO_CHEQUE_OFERTA,
BANDERA_CLASE_POSTURA_OFERTA,
BANDERA_SUB_CLASE_POSTURA_OFERTA,
DATOS_PLAZO_ENLACE_OFERTA,
IDENTIFICADOR_PLAZO_ENLACE_OFERTA,
DIAS_ENLACE_OFERTA,
XDIAS_ENLACE_OFERTA,
NIVEL_ENLACE_OFERTA,
FECHA_VENCIMIENTO_ENLACE_OFERTA,
TEXTO_TERM_ENLACE_OFERTA,
SUB_MERCADO_ENLACE_OFERTA,
O_D_ENLACE_OFERTA,
BANDERA_POSTURA_CON_EXPIRACION_OFERTA,
HORA_EXPIRACION_POSTURA_OFERTA,
BANDERA_ENLACE_A_PRECIO_SPOT_OFERTA,
PRECIO_SPOT_MINIMO_OFERTA,
PRECIO_SPOT_MAXIMO_OFERTA,
CODIGO_ORDEN_ENLACE_OFERTA,
USUARIO_ORDEN_ENLACE_OFERTA,
MCOD_ORDEN_ENLACE_OFERTA,
SUCURSAL_INTERMEDIARIA_POSTULANTE_OFERTA,
CODIGO_SUCURSAL_INTERMEDIARIA_POSTURA_OFERTA,
CODIGO_INSTITUCION_INTERMEDIARIA_POSTURA_OFERTA,
CIUDAD_3C_INTERMEDIARIA_POSTURA_OFERTA,
AGENCIA_INTERMEDIARIA_POSTURA_OFERTA,
SUCURSAL_4C_INTERMEDIARIA_POSTURA_OFERTA,
CIUDAD_INTERMEDIARIA_POSTURA_OFERTA,
BANDERA_VIA_INTERMEDIARIO_POSTURA_OFERTA,
BANDERA_ENLACE_OTRO_MERCADO_OFERTA,
CODIGO_CATEGORIA_OFERTA,
BANDERAS_POSTURA_OFERTA,
TICKS_PRECIO_SPOT_MINIMO_OFERTA,
TICKS_PRECIO_SPOT_MAXIMO_OFERTA,
ACTUALIZAR_HORA_OPERACION_OFERTA                 ,
BANDERAS_POSTURA_2_OFERTA                        ,
BANDERAS_POSTURA_3_OFERTA,
MONEDA_OFERTA,
MONEDA_1C_OFERTA,
FECHA_VENCIMIENTO_OFERTA,
MONTO_TOTAL_OFERTA,
TENDENCIA_OFERTA,
NUMERO_POSTURAS_OFERTA,
RELLENO_OFERTA,
DATOS_HISTORICOS,
PRECIO_ULTIMA_TRANSACCION,
TENDENCIA_ULTIMA_TRANSACCION,
O_D_ULTIMA_TRANSACCION,
HORA_ULTIMA_TRANSACCION_SUMMARY,
RELLENO_DATOS_HISTORICOS_SUMMARY,
DATOS_HISTORICOS_ETC,
PRECIO_ULTIMA_TRANSACCION_ETC,
TENDENCIA_ULTIMA_TRANSACCION_ETC,
O_D_ULTIMA_TRANSACCION_ETC,
HORA_ULTIMA_TRANSACCION_SUMMARY_ETC,
DATOS_ADICIONALES_O_D_SUMMARY_ETC,
FIX_PRICE_SUMMARY_ETC,
SUB_MERCADO_SUMMARY_ETC,
BANDERA_FIX_PRICE_SUMMARY_ETC,
HORA_FIX_TIME_SUMMARY_ETC,
RELLENO_DATOS_ADICIONALES_O_D_SUMMARY_ETC,
DATOS_LOCALES,
DATOS_ENLACE_GTN,
ISSUE_TYPE,
ISSUE_NUMBER,
ARREGLO_PRECIOS_HISTORIA_INSTRUMENTOS,
BANDERA_ESTADO,
RELLENO_SYMMARY,

// History currency summary
FECHA_HISTORIA,
ANO,
MES,
DIA,
MERCADO_STATISTICS,
DATOS_PRECIO_MONTO_DIA,
PRECIO_APERTURA,
PRECIO_CIERRE,
PRECIO_PROMEDIO,
PRECIO_MINIMO,
PRECIO_MAXIMO,
PRECIO_PROMEDIO_CALCULOS,
MONTO_TOTAL,
MONTO_MINIMO,
MONTO_MAXIMO,
MONTO_PROMEDIO,
NUMERO_TRANSACCIONES,
MONTO_ULTIMO,
XDIAS_STATISTICS,
DIAS_STATISTICS,
TEXTO_TERM_STATISTICS,
HORA_ULTIMA_TRANSACCION,
HORA_PRIMERA_TRANSACCION,
CONSOLIDADO,
COLOR_ULTIMA_TRANS,
TENDENCIA,
SUB_MERCADO_STATISTICS,
DIAS_AUX,
RELLENO_STATISTICS,
AVAILABLE_0071,
AVAILABLE_0072,
AVAILABLE_0073,
AVAILABLE_0074,
AVAILABLE_0075,
AVAILABLE_0076,
AVAILABLE_0077,
AVAILABLE_0078,
AVAILABLE_0079,

// SPOT Price global table
DATOS_SPOT,
CODIGO_PAR_SPOT,
CURRENCY_PAIR_CODIGO_GUIBOS_SPOT,
PRECIO_DEMANDA_SPOT,
PRECIO_OFERTA_SPOT,
PRECIO_MEDIO_SPOT,
FECHA_SPOT,
HORA_SPOT,
O_D_ULTIMO_CAMBIO_SPOT,
ESCALA_PRECIO_SPOT,
PICTURE_PRECIO_SPOT,
CODIGO_POSTURA_SPOT,
RELLENO_SPOT,

// Msg NAMECHECK
BANDERA_NMCHK,

// Msg ONECFGCREDIT
BANDERA_ONECFGCREDIT,
MERCADO_ONECFGCREDIT,
CODIGO_INSTITUCION_PROPIA_ONECFGCREDIT,
CODIGO_INSTITUCION_OTRA_ONECFGCREDIT,
CONFIGURACION_MIA_ONECFGCREDIT,
CONFIGURACION_OTRO_ONECFGCREDIT,
M_S_ONECFGCREDIT,
NUMERO_INSTITUCION_MIA_ONECFGCREDIT,
NUMERO_INSTITUCION_OTRA_ONECFGCREDIT,
RELLENO_ONECFGCREDIT,

// Msg ONEPLCCREDIT
BANDERA_ONEPLCCREDIT,
MERCADO_ONEPLCCREDIT,
CODIGO_SUCURSAL_MIA_ONEPLCCREDIT,
CODIGO_SUCURSAL_OTRA_ONEPLCCREDIT,
POLITICA_CREDITO_COMPRA_ONEPLCCREDIT,
POLITICA_CREDITO_VENTA_ONEPLCCREDIT,
USUARIO_ORIGEN_CAMBIO_ONEPOLITICCREDIT,
RELLENO_1_M_S_ONEPOLITICCREDIT,
M_S_ONEPOLITICCREDIT,
NUMERO_SUCURSAL_MIA_ONEPLCCREDIT,
NUMERO_SUCURSAL_OTRA_ONEPLCCREDIT,
RELLENO_ONEPLCCREDIT,

// Msg CUPOS global table message fields that come after cabeza header.
BANDERA_CUPO,
BANDERA_CUPO_LIMITE,
// CUPOS message data that comes after the order global table data.
DATOS_ADICIONALES_CUPO,

TRANSACCIONES_ANTERIOR,
CUPO_ANTERIOR,
RELLENO_DATOS_ADICIONALES_CUPO,

TEXTO_TERM_CUPO,

// Msg CONFIGCREDIT DME ==> PU
DATOS_CONFIGCREDIT,

MERCADO_CONFIGCREDIT,
CODIGO_INSTITUCION_CONFIGCREDIT,
M_S_CONFIGCREDIT,
RELLENO_CONFIGCREDIT,
ARREGLO_CONFIGURACION_CUPO_CONFIGCREDIT,
RELLENO1_CONFIGCREDIT,

// Msg POLITICCREDIT DME ==> PU
DATOS_POLITICCREDIT,

MERCADO_POLITICCREDIT,
CODIGO_SUCURSAL_POLITICCREDIT,
M_S_POLITICCREDIT,
C_V_POLITICCREDIT,
RELLENO_POLITICCREDIT,
ARREGLO_POLITICAS_CUPO,

RELLENO1_POLITICCREDIT,

// Msg ELIMINAR POSTURAS RETIRO DIFERIDO DELDEFERRED
DATOS_GENERALES_POSTURA_RETIRODIF,

MERCADO_RETIRODIF,
SUB_MERCADO_RETIRODIF,
O_D_RETIRODIF,
DIAS_RETIRODIF,
XDIAS_RETIRODIF,
NIVEL_RETIRODIF,
FECHA_VENCIMIENTO_RETIRODIF,
TEXTO_TERM_RETIRODIF,
FECHA_VALOR_RETIRODIF,
CODIGO_TITULO_RETIRODIF,
EMISOR_RETIRODIF,
CODIGO_PAIS_RETIRODIF,
CODIGO_EMISOR_RETIRODIF,
REFERENCIA_RETIRODIF,
MONEDA_RETIRODIF,
TIPO_PAPEL_RETIRODIF,
CODIGO_GRUPO_RETIRODIF,
CONCERTACION_RETIRODIF,
REFERENCIA_TITULO_RETIRODIF,
MONTO_RETIRODIF,
PRECIO_RETIRODIF,
RESTRICCION_RETIRODIF           ,
BANDERA_O_D_ASIGNACION_RETIRODIF,
CAMA_DE_MONTO_RETIRODIF         ,
TIPO_OPERACION_RETIRODIF        ,
LINEA_PICO_RETIRODIF            ,
PENDIENTE_RETIRODIF                              ,
ORDEN_OPERACION_RETIRODIF                        ,
BANDERA_MODIFICACION_RETIRODIF                   ,
BANDERA_ON_OFF_SCREEN_RETIRODIF                  ,
BANDERA_AFECTA_UH_RETIRODIF                      ,
BANDERA_TITILAR_UH_RETIRODIF                     ,
BANDERA_REGISTRO_RETIRODIF                       ,
BANDERA_OPERACION_RETIRODIF                      ,
BANDERA_GRABAR_COMANDO_RETIRODIF                 ,
TEXTO_COMANDO_RETIRODIF                          ,
ESCALA_PRECIO_RETIRODIF                          ,
CODIGO_UNICO_REGISTRO_RESUMENES_RETIRODIF        ,

// Msg Credit Administration
BANDERA_CREDITADM,

// Tradenegotiation msg
PRIMARYUSER_DESTINATARIO       ,
BANDERA_TRADENEG               ,
BANDERA_CAMBIO_TURNO           ,
CODIGO_TRANSACCION             ,
  MERCADO_TRADENEG             ,
  HORA_MENSAJE                 ,
  CODIGO_POSTURA_TRADENEG      ,
    USUARIO_POSTURA_TRADENEG   ,
    MCOD_POSTURA_TRADENEG      ,
  CODIGO_POSTURA_1_TRADENEG    ,
    USUARIO_POSTURA_1_TRADENEG ,
    MCOD_POSTURA_1_TRADENEG    ,
  C_V_TRADENEG                 ,
USUARIO_SUGERIDOR              ,
SUCURSAL_4C_SUGERIDORA         ,
NOMBRE_USUARIO_SUGERIDOR       ,
HORA_OPERACION_TRADENEG        ,
BANDERA_LOCAL                  ,
// Datos acuerdo (Msg Tradenegotiation)
DATOS_ESPECIALES_ACUERDO_SUGERIDO,
CODIGO_BANCO_MIO_SUGERIDO        ,
USUARIO_BANCO_MIO_SUGERIDO       ,
CODIGO_BANCO_OTRO_SUGERIDO       ,
USUARIO_BANCO_OTRO_SUGERIDO      ,
DATOS_ACUERDO_SUGERIDO        ,
START_DATE_SUGERIDO           ,
XDIAS_SUGERIDO                ,
END_DATE_SUGERIDO             ,
DIAS_SUGERIDO                 ,
BANDERA_ESTANDAR_LIBRE_SUGERIDO,
TEXTO_TERM_SUGERIDO            ,
NIVEL_SUGERIDO                 ,
POINTS_SUGERIDO               ,
PRECIO_SPOT_SUGERIDO          ,
NEAR_AMOUNT_SUGERIDO          ,
FAR_AMOUNT_SUGERIDO           ,
MONEDA_SUGERIDO               ,
FAR_AMOUNT_CALCULADO_SUGERIDO ,
TASA_INTERES_SUGERIDO         ,
BANDERA_CLS_SUGERIDO          ,
PRECIO_FINAL_SUGERIDO         ,
RELLENO_SUGERIDO              ,
// Banderas Acuerdo (Msg Tradenegotiation)
BANDERAS_ACUERDO_TODAS        ,
BANDERAS_ESPECIALES_ACUERDO   ,
BANDERA_CODIGO_BANCO_MIO      ,
BANDERA_USUARIO_BANCO_MIO     ,
BANDERA_CODIGO_BANCO_OTRO     ,
BANDERA_USUARIO_BANCO_OTRO    ,
BANDERAS_ACUERDO              ,
BANDERA_PRECIO_SPOT           ,
BANDERAS_ACUERDO_EXPANDIDAS   ,
BANDERA_START_DATE            ,
BANDERA_XDIAS                 ,
BANDERA_END_DATE              ,
BANDERA_DIAS                  ,
BANDERA_POINTS                ,
BANDERA_NEAR_AMOUNT           ,
BANDERA_FAR_AMOUNT            ,
BANDERA_MONEDA                ,
BANDERA_CAMBIAR_CLS           ,
BANDERA_PRECIO_FINAL          ,
BANDERA_RELLENO               ,

// Datos sin acuerdo (Msg Tradenegotiation)
DATOS_SIN_ACUERDO_TRADENEG                       ,
BANDERA_BROKERAGE_COMPRADOR_TRADENEG             ,
BANDERA_BROKERAGE_VENDEDOR_TRADENEG              ,
BANDERA_ESTANDAR_LIBRE_TRADENEG                  ,
USUARIO_BANCO_TRADENEG                           ,
USUARIO_BANCO_1_TRADENEG                         ,
CODIGO_BANCO_TRADENEG                            ,
SUCURSAL_4C_CODIGO_BANCO_TRADENEG                ,
CODIGO_BANCO_1_TRADENEG                          ,
SUCURSAL_4C_CODIGO_BANCO_1_TRADENEG              ,
SUCURSAL_INTERMEDIARIA_COMPRADOR                 ,
  SUCURSAL_INTERMEDIARIA_COMPRADOR_1             ,
BANDERA_VIA_INTERMEDIARIO_COMPRADOR_TRADENEG     ,
SUCURSAL_INTERMEDIARIA_VENDEDOR                  ,
  SUCURSAL_INTERMEDIARIA_VENDEDOR_1              ,
BANDERA_VIA_INTERMEDIARIO_VENDEDOR_TRADENEG      ,
CODIGO_SUCURSAL_POSTURA_TRADENEG                 ,
CODIGO_SUCURSAL_POSTURA_1_TRADENEG               ,
BANDERA_BROKER_POSTURA_TRADENEG                  ,
BANDERA_BROKER_POSTURA_1_TRADENEG                ,
BANDERA_CLIENTE_ETC_POSTURA_TRADENEG             ,
BANDERA_CLIENTE_ETC_POSTURA_1_TRADENEG           ,
CODIGO_BANCO_POSTURA_TRADENEG                    ,
CODIGO_BANCO_POSTURA_1_TRADENEG                  ,
CODIGO_SUCURSAL_SUGERIDORA_TRADENEG              ,
BANDERA_CAMBIAR_NUMERO_TRANSADO_ORIGINAL_TRADENEG,
NUEVO_NUMERO_TRANSADO_ORIGINAL_TRADENEG          ,
BANDERA_TIPO_RECHAZO_TRADENEG                    ,
SUB_MERCADO_TRADENEG                             ,
O_D_TRADENEG                                     ,
BANDERA_MONTO_REDUCIDO_TRADENEG                  ,
BANDERA_TRANSACCION_RFQ_TRADENEG                 ,
BANDERA_PRECIOS_BROKER_TRADENEG                  ,

// TextTradenegotiation msg
SUCURSAL_DESTINATARIO_TEXTTRADENEG,
DATOS_MENSAJE_TRANSACCION_TEXTTRADENEG,
CODIGO_TRANSACCION_TEXTTRADENEG,
MERCADO_TEXTTRADENEG,
HORA_MENSAJE_TEXTTRADENEG,
CODIGO_POSTURA_TEXTTRADENEG,
USUARIO_POSTURA_TEXTTRADENEG,
MCOD_POSTURA_TEXTTRADENEG,
CODIGO_POSTURA_1_TEXTTRADENEG,
USUARIO_POSTURA_1_TEXTTRADENEG,
MCOD_POSTURA_1_TEXTTRADENEG,
C_V_TEXTTRADENEG,
SECUENCIA_TEXTTRADENEG,
TEXTO_TEXTTRADENEG,
HORA_OPERACION_TEXTTRADENEG,
AVAILABLE_0117,
AVAILABLE_0118,
AVAILABLE_0119,
AVAILABLE_0120,

// CUPOS global Table (para politicas de crdito G7 y MX)                                                    
DATOS_CUPO,

DATOS_1,
MERCADO_CUPO,
SUCURSAL_NUESTRA_CUPO,
CODIGO_INSTITUCION_NUESTRA_CUPO,
CIUDAD_3C_NUESTRA_CUPO,
AGENCIA_NUESTRA_CUPO,
SUCURSAL_OTRA_CUPO,
CODIGO_INSTITUCION_OTRA_CUPO,
CIUDAD_3C_OTRA_CUPO,
AGENCIA_OTRA_CUPO,
C_V_CUPO,
LIMITE_CUPO,
LIMITE_DIARIO_CUPO,
PLAZO_MAXIMO,
TRANSACCIONES,
CUPO_MAX,
CUPO_ACTUAL,
RELLENO_DATOS_CUPO,

// CUPOSL global Table (para mercados latinos)                                                   
DATOS_CUPOL                                      ,
                                                  
  DATOS_1_CUPOL                                  ,
    MERCADO_CUPOL                                ,
    SUCURSAL_NUESTRA_CUPOL                       ,
      CODIGO_INSTITUCION_NUESTRA_CUPOL           ,
      CIUDAD_3C_NUESTRA_CUPOL                    ,
      AGENCIA_NUESTRA_CUPOL                      ,
    CODIGO_INSTITUCION_OTRA_CUPOL                ,
    C_V_CUPOL                                    ,
    LIMITE_CUPOL                                 ,
    LIMITE_DIARIO_CUPOL                          ,
    BANDERA_CUPOS_CUPOL                          ,
    BANDERA_VIA_PROCESAMIENTO_CUPOL              ,
    RELLENO_CUPOL                                ,
    PLAZO_MAXIMO_CUPOL                           ,
    TRANSACCIONES_CUPOL                          ,
  CUPO_MAX_CUPOL                                 ,
  CUPO_ACTUAL_CUPOL                              ,
  CODIGO_PU_ORIGEN_CAMBIO_CUPOL                  ,
  CODIGO_PU_ORIGEN_ACEPTACION_CUPOL              ,
  BANDERA_TIPO_CAMBIO_CUPOL                      ,
  MONTO_ULTIMA_TRANSACCION_CUPOL                 ,
  CODIGO_AMBIENTE_CUPOL                          ,

// Tabla para cupos por da.
DATOS_CUPOXDIA                                   ,
                                                  
  MERCADO_CUPOXDIA                               ,
  SUCURSAL_NUESTRA_CUPOXDIA                      ,
    CODIGO_INSTITUCION_NUESTRA_CUPOXDIA          ,
    CIUDAD_3C_NUESTRA_CUPOXDIA                   ,
    AGENCIA_NUESTRA_CUPOXDIA                     ,
  CODIGO_INSTITUCION_OTRA_CUPOXDIA               ,
    CODIGO_INSTITUCION_OTRA_PAIS_DM_CUPOXDIA     ,
    CODIGO_INSTITUCION_OTRA_RESTO_CODIGO_CUPOXDIA,
  C_V_CUPOXDIA                                   ,
  RANGO_PLAZO_CUPOXDIA                           ,
    PLAZO_INFERIOR_CUPOXDIA                      ,
    PLAZO_SUPERIOR_CUPOXDIA                      ,
  LIMITE_CUPOXDIA                                ,
  TRANSACCIONES_CUPOXDIA                         ,
  TRANSACCIONES_1_CUPOXDIA                       ,
  TRANSACCIONES_2_CUPOXDIA                       ,
  TRANSACCIONES_3_CUPOXDIA                       ,
  TRANSACCIONES_4_CUPOXDIA                       ,
  TRANSACCIONES_5_CUPOXDIA                       ,
  TRANSACCIONES_6_CUPOXDIA                       ,
  TRANSACCIONES_7_CUPOXDIA                       ,
  TRANSACCIONES_8_CUPOXDIA                       ,
  TRANSACCIONES_9_CUPOXDIA                       ,
  TRANSACCIONES_10_CUPOXDIA                      ,
  TRANSACCIONES_11_CUPOXDIA                      ,
  CUPO_ACTUAL_CUPOXDIA                           ,
  CUPO_ACTUAL_1_CUPOXDIA                         ,
  CUPO_ACTUAL_2_CUPOXDIA                         ,
  CUPO_ACTUAL_3_CUPOXDIA                         ,
  CUPO_ACTUAL_4_CUPOXDIA                         ,
  CUPO_ACTUAL_5_CUPOXDIA                         ,
  CUPO_ACTUAL_6_CUPOXDIA                         ,
  CUPO_ACTUAL_7_CUPOXDIA                         ,
  CUPO_ACTUAL_8_CUPOXDIA                         ,
  CUPO_ACTUAL_9_CUPOXDIA                         ,
  CUPO_ACTUAL_10_CUPOXDIA                        ,
  CUPO_ACTUAL_11_CUPOXDIA                        ,
  RELLENO_CUPOXDIA                               ,
DATOS_ADICIONALES_CUPO_FV_CUPOXDIA               ,
  CODIGO_PU_ORIGEN_CAMBIO_CUPOXDIA               ,
  CODIGO_PU_ORIGEN_ACEPTACION_CUPOXDIA           ,
  BANDERA_TIPO_CAMBIO_CUPOXDIA                   ,
  CODIGO_AMBIENTE_CUPOXDIA                       ,

// CUPO_X_PLAZO global Table 
DATOS_CUPOXPL                                    ,
DATOS_1_CUPOXPL                                  ,

//    MERCADO_CUPOL                                 ,
//    SUCURSAL_NUESTRA_CUPOL                        ,
//      CODIGO_INSTITUCION_NUESTRA_CUPOL            ,
//      CIUDAD_3C_NUESTRA_CUPOL                     ,
//      AGENCIA_NUESTRA_CUPOL                       ,
    RANGO_PLAZO_CUPOXPL                           ,
      PLAZO_INFERIOR_CUPOXPL                      ,
      PLAZO_SUPERIOR_CUPOXPL                      ,
//    C_V_CUPOL                                     ,
//    LIMITE_CUPOL                                  ,
//    LIMITE_DIARIO_CUPOL                           ,
//    BANDERA_CUPOS_CUPOL                           ,
//    BANDERA_VIA_PROCESAMIENTO_CUPOL               ,
//    RELLENO_CUPOL                                 ,
//    PLAZO_MAXIMO_CUPOL                            ,
//    TRANSACCIONES_CUPOL                           ,
//  CUPO_MAX_CUPOL                                  ,
//  CUPO_ACTUAL_CUPOL                               ,
//  CODIGO_PU_ORIGEN_CAMBIO_CUPOL                   ,
//  CODIGO_PU_ORIGEN_ACEPTACION_CUPOL               ,
//  BANDERA_TIPO_CAMBIO_CUPOL                       ,
//  MONTO_ULTIMA_TRANSACCION_CUPOL                  ,
//  CODIGO_AMBIENTE_CUPOL                           ,

// Estructura de la tabla de cobranzas para cupos
DATOS_COBRANZAS,

  CODIGO_INSTITUCION_NUESTRA_COBRANZAS,  
  CODIGO_INSTITUCION_COBRANZA_COBRANZAS, 
  DIAS_COBRANZA_COBRANZAS,               
  RELLENO_COBRANZAS,                                                                       

BANDERA_PENDCOBRANZA                             ,

// Tabla pendientes de cobranza
DATOS_PENDCOBRANZA                               ,
                                                  
  CODIGO_POSTURA_PENDCOBRANZA                    ,
    USUARIO_POSTURA_PENDCOBRANZA                 ,
    MCOD_POSTURA_PENDCOBRANZA                    ,
  FECHA_TRANSACCION_ALFANUMERICA_PENDCOBRANZA    ,
    FECHA_TRANSACCION_PENDCOBRANZA               ,
  FECHA_POSTURA_PENDCOBRANZA                     , 
  HORA_POSTURA_PENDCOBRANZA                      ,
  HORA_TRANSACCION_PENDCOBRANZA                  ,
  MERCADO_MASTER_PENDCOBRANZA                    ,
  MERCADO_PENDCOBRANZA                           ,
  MONEDA_PENDCOBRANZA                            ,
  ORIGEN_POSTURA_PENDCOBRANZA                    ,
  FECHA_COBRO_PENDCOBRANZA                       ,
  FECHA_VALOR_PENDCOBRANZA                       ,
  FECHA_ENTREGA_PENDCOBRANZA                     ,
  DIAS_PENDCOBRANZA                              ,
  XDIAS_PENDCOBRANZA                             ,
  FECHA_VENCIMIENTO_PENDCOBRANZA                 ,
  FECHA_VENCIMIENTO_XDIAS_PENDCOBRANZA           ,
  SUCURSAL_POSTULANTE_PENDCOBRANZA               ,
    CODIGO_SUCURSAL_POSTURA_PENDCOBRANZA         ,
      CODIGO_INSTITUCION_POSTURA_PENDCOBRANZA    ,
      CIUDAD_3C_POSTURA_PENDCOBRANZA             ,
      AGENCIA_POSTURA_PENDCOBRANZA               ,
    SUCURSAL_4C_POSTURA_PENDCOBRANZA             ,
    CIUDAD_POSTURA_PENDCOBRANZA                  ,
  DATOS_SUCURSAL_NUESTRA_PENDCOBRANZA            ,
    CODIGO_SUCURSAL_NUESTRA_PENDCOBRANZA         ,
      CODIGO_INSTITUCION_NUESTRA_PENDCOBRANZA    ,
      CIUDAD_3C_NUESTRA_PENDCOBRANZA             ,
      AGENCIA_NUESTRA_PENDCOBRANZA               ,
    SUCURSAL_4C_NUESTRA_PENDCOBRANZA             ,
    CIUDAD_NUESTRA_PENDCOBRANZA                  ,
  USUARIO_NUESTRO_PENDCOBRANZA                   ,
  BANDERA_USUARIO_NUESTRO_PENDCOBRANZA           ,
  DATOS_SUCURSAL_VENDEDOR_PENDCOBRANZA           ,
    CODIGO_SUCURSAL_VENDEDOR_PENDCOBRANZA        ,
      CODIGO_INSTITUCION_VENDEDOR_PENDCOBRANZA   ,
      CIUDAD_3C_VENDEDOR_PENDCOBRANZA            ,
      AGENCIA_VENDEDOR_PENDCOBRANZA              ,
    SUCURSAL_4C_VENDEDOR_PENDCOBRANZA            ,
    CIUDAD_VENDEDOR_PENDCOBRANZA                 ,
  USUARIO_VENDEDOR_PENDCOBRANZA                  ,
  DATOS_SUCURSAL_COMPRADOR_PENDCOBRANZA          ,
    CODIGO_SUCURSAL_COMPRADOR_PENDCOBRANZA       ,
      CODIGO_INSTITUCION_COMPRADOR_PENDCOBRANZA  ,
      CIUDAD_3C_COMPRADOR_PENDCOBRANZA           ,
      AGENCIA_COMPRADOR_PENDCOBRANZA             ,
    SUCURSAL_4C_COMPRADOR_PENDCOBRANZA           ,
    CIUDAD_COMPRADOR_PENDCOBRANZA                ,
  USUARIO_COMPRADOR_PENDCOBRANZA                 ,
  NUMERO_PENDCOBRANZA                            ,
  NUMERO_TRANSADO_PENDCOBRANZA                   ,
  VALOR_A_NEGOCIAR_PENDCOBRANZA                  ,
  VALOR_EFECTIVO_PENDCOBRANZA                    ,
  VALOR_TOTAL_PENDCOBRANZA                       ,
  COMENTARIO_PENDCOBRANZA                        ,
  CODIGO_POSTURA_1_PENDCOBRANZA                  ,
    USUARIO_POSTURA_1_PENDCOBRANZA               ,
    MCOD_POSTURA_1_PENDCOBRANZA                  ,
  SUCURSAL_ACEPTANTE_PENDCOBRANZA                ,
    CODIGO_SUCURSAL_POSTURA_1_PENDCOBRANZA       ,
       CODIGO_INSTITUCION_POSTURA_1_PENDCOBRANZA ,
       CIUDAD_3C_POSTURA_1_PENDCOBRANZA          ,
       AGENCIA_POSTURA_1_PENDCOBRANZA            ,
    SUCURSAL_4C_POSTURA_1_PENDCOBRANZA           ,
    CIUDAD_POSTURA_1_PENDCOBRANZA                ,
  O_D_PENDCOBRANZA                               ,
  C_V_PENDCOBRANZA                               ,
  FACTOR_CONVERSION_PENDCOBRANZA                 ,
  FORMA_DE_PAGO_PENDCOBRANZA                     ,
  CODIGO_INSTIT_DIRECTOR_RUEDA_PENDCOBRANZA      ,
  IP_ACREDITAR_COMPRADOR_MONEDA_1_PENDCOBRANZA   ,
  IP_DEBITAR_COMPRADOR_MONEDA_2_PENDCOBRANZA     ,
  IP_DEBITAR_VENDEDOR_MONEDA_1_PENDCOBRANZA      ,
  IP_ACREDITAR_VENDEDOR_MONEDA_2_PENDCOBRANZA    ,
  BANDERA_VIA_PROCESAMIENTO_PENDCOBRANZA         ,
  TIPO_OPERACION_PENDCOBRANZA                    , 
  DATOS_SUCURSAL_OTRA_PENDCOBRANZA               ,
    CODIGO_SUCURSAL_OTRA_PENDCOBRANZA            ,
      CODIGO_INSTITUCION_OTRA_PENDCOBRANZA       ,
      CIUDAD_3C_OTRA_PENDCOBRANZA                ,
      AGENCIA_OTRA_PENDCOBRANZA                  ,
    SUCURSAL_4C_OTRA_PENDCOBRANZA                ,
    CIUDAD_OTRA_PENDCOBRANZA                     ,
  RELLENO_PENDCOBRANZA                           ,
  CODIGO_AMBIENTE_PENDCOBRANZA                   ,

// Tabla factores de riesgo
BANDERA_FACTRIESGO                               ,
CLASE_FACTRIESGO                                 ,

DATOS_FACTRIESGO                                 ,
                                                  
  CODIGO_FACTRIESGO                              ,
    MERCADO_SUCURSALES_C_V_FACTRIESGO            ,
      MERCADO_FACTRIESGO                         ,
      SUCURSAL_NUESTRA_FACTRIESGO                ,
        CODIGO_INSTITUCION_NUESTRA_FACTRIESGO    ,
        CIUDAD_3C_NUESTRA_FACTRIESGO             ,
        AGENCIA_NUESTRA_FACTRIESGO               ,
      CODIGO_SUCURSAL_OTRA_FACTRIESGO            ,
        CODIGO_INSTITUCION_OTRA_FACTRIESGO       ,
        CIUDAD_3C_NUESTRA_OTRA_FACTRIESGO        ,
        AGENCIA_NUESTRA_OTRA_FACTRIESGO          ,
      C_V_FACTRIESGO                             ,
    RANGO_INFERIOR_PLAZO_FACTRIESGO              ,
    RANGO_SUPERIOR_PLAZO_FACTRIESGO              ,
  PORCENTAJE_RIESGO_FACTRIESGO                   ,
  BANDERA_AUTORIZACION_FACTRIESGO                ,
  TEXTO_TERM_FACTRIESGO                          ,
  RELLENO_1_FACTRIESGO                           ,
  BANDERA_VIA_PROCESAMIENTO_FACTRIESGO           ,
  BANDERA_CREDITO_USA_CAMPO_FACTRIESGO           ,
  FECHA_RIESGO_FACTRIESGO                        ,
  RELLENO_2_FACTRIESGO                           ,
  CODIGO_AMBIENTE_FACTRIESGO                     ,

BANDERA_COMPARTCUPOS                             ,

// Comparticion de cupos
DATOS_COMPARTCUPOS                               ,
                                                  
  INSTITUCION_NUESTRA_COMPARTCUPOS               ,
  MERCADO_COMPARTCUPOS                           ,
  MERCADO_CUPO_COMPARTCUPOS                      ,
  FACTOR_CONVERSION_COMPARTCUPOS                 ,
  RELLENO_COMPARTCUPOS                           ,

// Comparticion de cupos
DATOS_CONFCUPOS                                  ,
                                                  
  CODIGO_CONFCUPOS                               ,
    INSTITUCION_CONFCUPOS                        ,  
    MERCADO_CONFCUPOS                            ,
    CODIGO_PRODUCTO_CONFCUPOS                    ,
  MANEJA_CUPOS_CONFCUPOS                         ,
  CLASE_CUPOS_CONFCUPOS                          ,
  COMPENSACION_CAMARA_CONFCUPOS                  ,
  COMPENSACION_CAMARA_REGISTROS_CONFCUPOS        ,
  BANDERA_VIA_PROCESAMIENTO_CONFCUPOS            ,
  BANDERAS_CONFIGURACION_CONFCUPOS               ,
  RELLENO_CONFCUPOS                              ,
  CODIGO_AMBIENTE_CONFCUPOS                      ,

BANDERA_LIMINSTIT                                ,

// Mensaje limites instituciones
DATOS_LIMITE_LIMINSTIT                           ,
                                                  
  SUCURSAL_LIMITE_LIMINSTIT                      ,
    CODIGO_INSTITUCION_LIMITE_LIMINSTIT          ,
    CIUDAD_3C_LIMITE_LIMINSTIT                   ,
    AGENCIA_LIMITE_LIMINSTIT                     ,
  LIMITE_COMPRA_LIMINSTIT                        ,
  LIMITE_VENTA_LIMINSTIT                         ,
  MERCADO_LIMINSTIT                              ,
  CLASE_CUPOS_LIMINSTIT                          ,
  CODIGO_GARANTIZADORA_LIMINSTIT                 ,
  BANDERA_VIA_PROCESAMIENTO_LIMINSTIT            , 
  RELLENO_LIMINSTIT                              ,

// Tabla precios promedio de compra (mercados 71 y 79)
DATOS_BUYAVERPRICE                               ,
                                                  
  CODIGO_BUYAVERPRICE                            ,
    CODIGO_INSTITUCION_SUCURSAL_BUYAVERPRICE     ,
    CIUDAD_3C_SUCURSAL_BUYAVERPRICE              ,
    AGENCIA_SUCURSAL_BUYAVERPRICE                ,
  MERCADO_EXTRA_BUYAVERPRICE                     ,
  MERCADO_BUYAVERPRICE                           ,
  PRECIO_PROMEDIO_COMPRA_BUYAVERPRICE            ,
  FECHA_REGISTRO_BUYAVERPRICE                    ,

// Tabla precios spot por mercado 
DATOS_MARKETSPOTPRICES                           ,
                                                  
  MERCADO_MARKETSPOTPRICES                       ,
  PRECIO_DEMANDA_MARKETSPOTPRICES                ,
  PRECIO_OFERTA_MARKETSPOTPRICES                 ,
  PRECIO_MEDIO_MARKETSPOTPRICES                  ,
  FECHA_MARKETSPOTPRICES                         ,
  HORA_MARKETSPOTPRICES                          ,
  O_D_ULTIMO_CAMBIO_MARKETSPOTPRICES             ,
  BANDERA_VIA_PROCESAMIENTO_MARKETSPOTPRICES     ,
  RELLENO_MARKETSPOTPRICES                       ,

// Estructura de la tabla que guarda los datos de una trasaccin manual pendiente de confirmacin
DATOS_CONFIRMPEND                                , 
                                                   
  CONFIG_CONFIRMPEND                             , 

  CURTIME_CONFIRMPEND                            , 
  ESTADO_SOLICITUD_CONFIRMPEND                   , 
  BANDERA_CONFIRMAR_TRANSACCIONES_CONFIRMPEND    ,
  RELLENO_CONFIRMPEND                            ,

  DATOS_MSG_ORDER_CONFIRMPEND                    , 

// CashRate global table
DATOS_CASHRATE,
  CODIGO_CASHRATE,
    MONEDA_CASHRATE,
    TEXTO_TERM_CASHRATE,
  NOMBRE_ITEM_CASHRATE,
  TASA_DEMANDA_CASHRATE,
  TASA_OFERTA_CASHRATE,
  TASA_MEDIA_CASHRATE,
  FECHA_CASHRATE,
  HORA_CASHRATE,
  RELLENO_CASHRATE,
AVAILABLE_0121,
AVAILABLE_0122,
AVAILABLE_0123,
AVAILABLE_0124,

BANDERA_FIXPRICE                                 ,

// Fix Price Message
DATOS_FIXPRICE                                   ,
                                                  
MERCADO_FIXPRICE                                 ,
DATOS_BUSQUEDA_G7_FIXPRICE                       ,
  DIAS_FIXPRICE                                  ,
  XDIAS_FIXPRICE                                 ,
  NIVEL_FIXPRICE                                 ,
  FECHA_VENCIMIENTO_FIXPRICE                     ,
  TEXTO_FIXPRICE                                 ,
PRECIO_FIXPRICE                                  ,
BOTON_SEND_FIXPRICE                              ,
BANDERA_PRECIO_MODIFICADO_FIXPRICE               ,
BANDERA_PRECIO_FIXPRICE                          ,
BANDERA_PLAZO_FIXING_FIXPRICE                    ,
RELLENO_A_FIXPRICE                               ,
DURACION_FIXING_FIXPRICE                         ,
HORA_INICIO_FIXING_FIXPRICE                      ,
HORA_FIN_FIXING_FIXPRICE                         ,
CODIGO_FIXING_FIXPRICE                           ,
  USUARIO_FIXING_FIXPRICE                        ,
  MCOD_FIXING_FIXPRICE                           ,
CODIGO_SUCURSAL_FIXING_FIXPRICE                  ,
  CODIGO_INSTITUCION_FIXING_FIXPRICE             ,
    PAIS_DATAMANAGER_FIXPRICE                    ,
    SECUENCIAL_FIXPRICE                          ,
  CODIGO_CIUDAD_3C_FIXPRICE                      ,
  CODIGO_AGENCIA_FIXPRICE                        ,
INTENCION_FIXPRICE                               ,
MONTO_INTENCION_FIXPRICE                         ,
RELLENO_B_FIXPRICE                               ,

// Tabla Instituciones Numeradas
DATOS_INSTNUM,

CODIGO_INSTITUCION_INSTNUM,
NUMERO_INSTITUCION_INSTNUM,

// Tabla Sucursales Numeradas
CODIGO_SUCURSAL_SUCNUM,
NUMERO_SUCURSAL_SUCNUM,

// Tabla PU Inscritos al DME
MERCADO_INSC,
CODIGO_PRIMARYUSER_INSC,
CODIGO_SUCURSAL_INSC,

// Fields after cabeza of table PU Inscritos al DME
I_OP_PINSDME,

// Tabla Credit Administration
DATOS_CREDITADM,

MERCADO_CREDITADM,
CODIGO_INSTITUCION_CREDITADM,
TIPO_CUPO_CREDITADM,
BANDERA_ACEPTA_CREDITADM,
BANDERA_CLIENTE_MANEJA_CONFIGURACION_CUPOS,
PORCENTAJE_DE_ADVERTENCIA_CREDITADM,
RELLENO_CREDITADM,

// Increments global table
DATOS_INCREMENTS,

MERCADO_INCREMENTS,
TEXTO_TERM_INCREMENTS,
DATOS_1_INCREMENTS,
INCREMENTO_PRECIO_INCREMENTS,
MONTO_CCY_1_INCREMENTS,
UNIDADES_MONTO_CCY_1_INCREMENTS,
MONTO_CCY_2_INCREMENTS,
UNIDADES_MONTO_CCY_2_INCREMENTS,
MONTO_MINIMO_CCY_1_INCREMENTS,
MONTO_MINIMO_CCY_2_INCREMENTS,
MONTO_LOTE_MAXIMO_CCY_1_INCREMENTS,
MONTO_LOTE_MAXIMO_CCY_2_INCREMENTS,
RELLENO_INCREMENTS,

// Overnight Indexes global table
DATOS_OVERNIGHT,

CODIGO_OVERNIGHT,
MONEDA_OVERNIGHT,
TEXTO_TERM_OVERNIGHT,
NOMBRE_ITEM_OVERNIGHT,
PRECIO_DEMANDA_OVERNIGHT,
PRECIO_OFERTA_OVERNIGHT,
FECHA_OVERNIGHT,
HORA_OVERNIGHT,
RELLENO_OVERNIGHT,

// DME Connected global table
DATOS_DMECONNECTED,

MERCADO_DMECONNECTED,
CODIGO_PRIMARYUSER_DMECONNECTED,
BANDERA_PRINCIPAL_RESPALDO_DMECONNECTED,

// Terms Msg (Voice markets)
BANDERA_VOICETERM,

// Terms global table (Voice markets)
DATOS_VOICETERM                 ,

CODIGO_UNICO_VOICETERM          ,
CODIGO_VOICETERM                ,
CODIGO_TITULO_VOICETERM         ,
DELIMITADOR_CODIGO_VOICETERM    ,
CODIGO_GRUPO_VOICETERM          ,
CODIGO_SUPER_GRUPO_VOICETERM    ,
NOMBRE_VOICETERM                ,
MONEDA_VOICETERM                ,
MONEDA_1C_VOICETERM             ,
BANDERA_DETALLADO_VOICETERM     ,
DETALLES_ADICIONALES_VOICETERM  ,
BANDERA_VENCIMIENTO_VOICETERM   ,
FECHA_VENCIMIENTO_VOICETERM     ,
PLAZO_1_VOICETERM               ,
PLAZO_2_VOICETERM               ,
TEXTO_PLAZO_VOICETERM           ,
LIQUIDACION_VOICETERM           ,
DIAS_VALOR_VOICETERM            ,
BANDERA_PREDETERMINADO_VOICETERM,
CODIGO_EMISION_VOICETERM        ,
CODIGO_UNICO_TV_VOICETERM       ,
DELIMITADOR_CODIGO_EMSION_VOICETERM,
RELLENO_A_VOICETERM             ,
CODIGO_ALTERNO_VOICETERM        ,
ORDEN_POSTURAS_VOICETERM        ,
CONCERTACION_VOICETERM          ,
MERCADO_VOICETERM               ,
CODIGO_ALTERNO_NUMERICO_VOICETERM,
SECUENCIAL_FUTUROS_VOICETERM    ,
CAMA_DE_MONTO_VOICETERM         ,
ORIGEN_POSTURA_VOICETERM        ,
TIPO_OPERACION_VOICETERM        ,
LINEA_PICO_VOICETERM            ,
BANDERA_PINTAR_LINEA_VOICETERM      ,
CODIGO_LINEA_VOICETERM              ,
COLOR_DETALLES_INSTRUMENTO_VOICETERM,
BANDERA_TIPO_FUTURO_VOICETERM       ,
CODIGO_MERCADO_RF_VOICETERM         ,
CODIGO_BACK_OFFICE_VOICETERM    ,
DIAS_VALOR_MAXIMO_VOICETERMN    ,
NUMERO_PAGINA_ETC_VOICETERMN    ,
RELLENO_B_VOICETERM             ,

//Fields after voiceterm global table fields.
DATOS_ADICIONALES_VOICETERM     ,

BANDERA_CAMBIAR_COLOR_VOICETERM ,
COLOR_VOICETERM                 ,
NVO_CODIGO_TITULO_VOICETERM     ,
NVO_BANDERA_VENCIMIENTO_VOICETERM,
NVO_PLAZO_1_VOICETERM           ,
NVO_PLAZO_2_VOICETERM           ,
NVO_TEXTO_PLAZO_VOICETERM       ,
NVO_LIQUIDACION_VOICETERM       ,
NVO_DIAS_VALOR_VOICETERM        ,
NVO_TIPO_OPERACION_VOICETERM    ,
BANDERA_GRABAR_COMANDO_VOICETERM,
TEXTO_COMANDO_VOICETERM         ,

// CMsgETCResponse
DATA_RESPONSE                                    ,

ORDER_ID_RESPONSE                                ,
USUARIO_ORDER_ID_RESPONSE                        ,
MCOD_ORDER_ID_RESPONSE                           ,
RESULT_RESPONSE                                  ,
PRICE_RESPONSE                                   ,
AMOUNT_RESPONSE                                  ,
CUR_NUMBER_MESSAGES_RESPONSE                     ,
TOTAL_NUMBER_MESSAGES_RESPONSE                   ,
TEXT_RESPONSE                                    ,
FILL_RESPONSE                                    ,

// Global table of currencies. (CGTCurrency)
CODIGO_CURRENCY                                  ,
MONEDA_1C_CURRENCY                               ,
PAIS_DATAMANAGER_CURRENCY                        ,
NOMBRE_CURRENCY                                  ,
ULTIMO_PRECIO_CURRENCY                           ,
PICTURE_PRECIO_CURRENCY                          ,
#endif

// Global table of connected users (CGTConnUsers)
CODIGO_USUARIO_DIALOGO_CONNUSER,
SUCURSAL_CONNUSER,
NOMBRE_USUARIO_CONNUSER,
CODIGO_USUARIO_CONNUSER,
HORA_INGRESO_CONNUSER,
BANDERA_PRIMARYUSER_CONNUSER,
SUCURSAL_4C_CONNUSER,
CODIGO_PRIMARYUSER_CONNUSER,
CODIGO_DPROXY_CONNUSER,             
FECHA_INGRESO_CONNUSER,             
BANDERA_VISIBILIDAD_CONNUSER,       
CLASE_USUARIO_CONNUSER,             
CLASE_INSTITUCION_CONNUSER,         
CODIGO_COMPLETO_DATASERVER_CONNUSER,
GRUPO_MERCADOS_CONNUSER,            
PAIS_INSTITUCION_CONNUSER,          
DIRECCION_IP_LOCAL_CONNUSER,        
HOST_NAME_LOCAL_CONNUSER,           
DIRECCION_IP_EN_DS_CONNUSER,        
ESTADO_CONNUSER,                    
CODIGO_USUARIO_EN_LINEA_CONNUSER,   
DATOS_LOCALES_CONNUSER,             

#ifndef DAPI
// DME->DGI Message to notify the 
// all credit policy records 
// sending to DGI (CMsgAllCrpoliNotification)
DATA_ALLCRPOLINOTIFICATION                       ,

BANDERA_ALLCRPOLINOTIFICATION                    ,
MERCADO_ALLCRPOLINOTIFICATION                    ,
RELLENO_ALLCRPOLINOTIFICATION                    ,

// Message of command history (MsgCommandHistory)
DATOS_COMMANDHISTORY                             ,

MERCADO_COMMANDHISTORY                           ,
FECHA_COMMANDHISTORY                             ,
HORA_COMMANDHISTORY                              ,
USUARIO_COMMANDHISTORY                           ,
TEXTO_COMMANDHISTORY                             ,
RESULTADO_COMMANDHISTORY                         ,
BANDERA_OPERACION_COMMANDHISTORY                 ,
NUMERO_REGISTROS_COMMANDHISTORY                  ,
SECUENCIAL_COMMANDHISTORY                        ,
DIEZ_MILESIMA_SEGUNDO_COMMANDHISTORY             ,
RELLENO_COMMANDHISTORY                           ,

// Currency pairs global table.
DATOS_CCYPAIR                                    ,

MERCADO_CCYPAIR                                  ,
CODIGO_CCYPAIR                                   ,
CODIGO_PAR_CCYPAIR                               ,
BANDERA_NDF_FORWARD_CCYPAIR                      ,
CODIGO_MONEDA_CCYPAIR                            ,
CODIGO_MONEDA_CONTRAPARTE_CCYPAIR                ,
ESCALA_PRECIO_CCYPAIR                            ,
ESCALA_PRECIO_FINAL_CCYPAIR                      ,
PAIS_FERIADOS_1_CCYPAIR                          ,
PAIS_FERIADOS_2_CCYPAIR                          ,
REGLA_UNION_FERIADOS_CCYPAIR                     ,
FIXING_DATE_CCYPAIR                              ,
DIVISOR_POINTS_CCYPAIR                           ,
CODIGO_GUIBOS_CCYPAIR                            ,
VALUE_DATE_MONEDA_CCYPAIR                        ,
VALUE_DATE_MONEDA_CONTRAPARTE_CCYPAIR            ,
BANDERA_DIA_VALIDO_US_CCYPAIR                    ,
BANDERA_RFQ_CCYPAIR                              ,
RELLENO_CCYPAIR                                  ,

// Indicatives mark global table.
MERCADO_INDICATIVESMARK                          ,
BANDERA_PUBLICAR_INDICATIVE_ICAP_INDICATIVESMARK ,
FECHA_BASE_INDICATIVESMARK                       ,

// Connected dm servers global table.
CODIGO_PRIMARYUSER_CONNDMSERVER                  ,
CODIGO_SUCURSAL_CONNDMSERVER                     ,
CODIGO_INSTITUCION_CONNDMSERVER                  ,
CODIGO_CIUDAD_CONNDMSERVER                       ,
CODIGO_AGENCIA_CONNDMSERVER                      ,
SUCURSAL_4C_CONNDMSERVER                         ,
CODIGO_USUARIO_CONNDMSERVER                      ,
NOMBRE_USUARIO_CONNDMSERVER                      ,

// Holidays global table.
DATOS_HOLIDAY                                    ,

CODIGO_HOLIDAY                                   ,
CODIGO_PAIS_HOLIDAY                              ,
FECHA_FERIADO_HOLIDAY                            ,
NOMBRE_FERIADO_HOLIDAY                           ,
PAIS_DATAMANAGER_HOLIDAY                         ,
RELLENO_HOLIDAY                                  ,

// Message of RFQRequest (Ronda)
BANDERA_RFQREQUEST                               ,


// Global table RFQRequest (Ronda)
DATOS_RONDA_RFQREQUEST                           ,

  DATOS_POSTULANTE_RFQREQUEST                    ,
    CODIGO_PRIMARYUSER_RONDA_RFQREQUEST          ,
    CODIGO_RONDA_RFQREQUEST                      ,
      USUARIO_RONDA_RFQREQUEST                   ,
      MCOD_RONDA_RFQREQUEST                      ,
    SUCURSAL_POSTULANTE_RFQREQUEST               ,
      CODIGO_SUCURSAL_RONDA_RFQREQUEST           ,
        CODIGO_INSTITUCION_RONDA_RFQREQUEST      ,
        CIUDAD_3C_RONDA_RFQREQUEST               ,
        AGENCIA_RONDA_RFQREQUEST                 ,
      SUCURSAL_4C_RONDA_RFQREQUEST               ,
      CIUDAD_RONDA_RFQREQUEST                    ,
      BANDERA_BROKER_POSTURA_RFQREQUEST          ,
      BANDERA_CLIENTE_ETC_POSTURA_RFQREQUEST     ,
      BANDERA_NO_MOSTRAR_CONTRAPARTES_RFQREQUEST ,
      BANDERA_GUARDAR_EN_MEMORIA_RFQREQUEST      ,
    USUARIO_INGRESO_RFQREQUEST                   ,
    BANCO_TRABAJO_RFQREQUEST                     ,
    SOBRE_TASA_RFQREQUEST                        ,
    ORIGEN_RFQREQUEST                            ,
    RELLENO_POSTULANTE_RFQREQUEST                ,
  BANDERAS_POSTURA_2_RFQREQUEST                  ,
  HORA_OPERACION_POSTULANTE_RFQREQUEST           ,
  MERCADO_RFQREQUEST                             ,
  SUB_MERCADO_RFQREQUEST                         ,
  TEXTO_TERM_EXTENDIDO_RFQREQUEST                ,
  CURRENCY_PAIR_RFQREQUEST                       ,
    CURRENCY_PAIR_1_RFQREQUEST                   ,
    SEPARADOR_MONEDA_RFQREQUEST                  ,
    CURRENCY_PAIR_2_RFQREQUEST                   ,
  BANDERA_ESTANDAR_LIBRE_RFQREQUEST              ,
  TIPO_INSTRUMENTO_RFQREQUEST                    ,
  TEXTO_TERM_RFQREQUEST                          ,
  XDIAS_RFQREQUEST                               ,
  DIAS_RFQREQUEST                                ,
  FECHA_VENCIMIENTO_XDIAS_RFQREQUEST             ,
  FECHA_VENCIMIENTO_RFQREQUEST                   ,
  NIVEL_RFQREQUEST                               ,
  LIQUIDACION_RFQREQUEST                         ,
  FECHA_VALOR_RFQREQUEST                         ,
  FECHA_ENTREGA_RFQREQUEST                       ,
  PICTURE_PRECIO_RFQREQUEST                      ,
  PICTURE_PRECIO_FINAL_RFQREQUEST                ,
  ESCALA_PRECIO_RFQREQUEST                       ,
  PAIS_FERIADOS_1_RFQREQUEST                     ,
  PAIS_FERIADOS_2_RFQREQUEST                     ,
  REGLA_UNION_FERIADOS_RFQREQUEST                ,
  DIVISOR_POINTS_RFQREQUEST                      ,
  VALUE_DATE_MONEDA_RFQREQUEST                   ,
  VALUE_DATE_MONEDA_CONTRAPARTE_RFQREQUEST       ,
  BANDERA_DIA_VALIDO_US_RFQREQUEST               ,
  FECHA_RONDA_A_RFQREQUEST                       ,
    FECHA_RONDA_RFQREQUEST                       ,
  NUMERO_RONDA_RFQREQUEST                        ,
  BANDERA_RONDA_RFQREQUEST                       ,
  TIEMPO_VALIDEZ_RFQREQUEST                      ,
  PORCENTAJE_CERRADAS_RFQREQUEST                 ,
  CODIGO_SUCURSAL_CONTESTANTE_A_RFQREQUEST       ,

    CODIGO_SUCURSAL_CONTESTANTE_RFQREQUEST       ,

  SUCURSAL_4C_CONTESTANTE_A_RFQREQUEST           , 

    SUCURSAL_4C_CONTESTANTE_RFQREQUEST           ,

  BANDERA_GRUPO_RFQREQUEST                       ,
  NOMBRE_GRUPO_RFQREQUEST                        ,
  NUMERO_RFQREQUEST                              ,
  VALOR_NOMINAL_RFQREQUEST                       ,
  MONEDA_MONTO_RFQREQUEST                        ,
  O_D_RFQREQUEST                                 ,
  TIPO_OPERACION_RFQREQUEST                      ,
  RESTRICCION_RFQREQUEST                         ,
  TEXTO_RESTRICCION_RFQREQUEST                   ,
    TEXTO_RESTRICCION_1_RFQREQUEST               ,
    FACTOR_PRECIO_PARA_CUPOS_RFQREQUEST          ,
  TIEMPO_VALIDEZ_ALFANUMERICA_RFQREQUEST         ,
    TIEMPO_VALIDEZ_HORA_RFQREQUEST               ,
  BANDERA_DIFUSION_RFQREQUEST                    ,
  EMISOR_RFQREQUEST                              ,
    CODIGO_PAIS_RFQREQUEST                       ,
    CODIGO_EMISOR_RFQREQUEST                     ,
  CODIGO_TITULO_RFQREQUEST                       ,
    CODIGO_EMISION_RFQREQUEST                    ,
    CODIGO_TITULO_1_RFQREQUEST                   ,
    DELIM_CODIGO_TITULO_1_RFQREQUEST             ,
    EMISOR_1_RFQREQUEST                          ,
      CODIGO_PAIS_1_RFQREQUEST                   ,
      CODIGO_EMISOR_1_RFQREQUEST                 ,
    REFERENCIA_1_RFQREQUEST                      ,
    NUMERO_EMISION_1_RFQREQUEST                  ,
    NUMERO_TRAMO_1_RFQREQUEST                    ,
    NUMERO_COLOCACION_1_RFQREQUEST               ,
  TIPO_MONTO_RFQREQUEST                          ,
  HORA_CIERRE_RFQREQUEST                         ,
  HORA_ADJUDICACION_RFQREQUEST                   ,
  TIEMPO_ADJUDICACION_RFQREQUEST                 ,
  BANDERA_SUBASTA_RFQREQUEST                     ,
  BANDERA_MEZCLA_TITULOS_RFQREQUEST              ,
  BANDERA_MEZCLA_EMISORES_RFQREQUEST             ,
  HORA_INICIO_RFQREQUEST                         ,
  MERCADO_REAL_RFQREQUEST                        ,
  NEMOTECNICO_RFQREQUEST                         ,
  BANDERA_PLAZO_ANIOS_RFQREQUEST                 ,
  ORIGEN_MORE_RFQREQUEST                         ,
  BANDERA_ASIGNACION_RFQREQUEST                  ,
  BASE_DIAS_RFQREQUEST                           ,
  NUMERO_COMPRADO_RFQREQUEST                     ,
  PRECIO_PROMEDIO_COMPRA_RFQREQUEST              ,
  PRECIO_X_MONTO_COMPRA_RFQREQUEST               ,
  NUMERO_VENDIDO_RFQREQUEST                      ,
  PRECIO_PROMEDIO_VENTA_RFQREQUEST               ,
  PRECIO_X_MONTO_VENTA_RFQREQUEST                ,
  BANDERA_CONTESTADA_RFQREQUEST                  ,
  BANDERA_TRANSADA_RFQREQUEST                    ,
  MARCA_PARA_PORCENTAJE_RFQREQUEST               ,
  TIEMPO_DURACION_RFQREQUEST                     ,
  BANDERA_ADJUDICADA_RFQREQUEST                  ,
  C_V_RFQREQUEST                                 ,
  MONTO_TOTAL_POSTURAS_RFQREQUEST                ,
  DATOS_SUBASTA_RFQREQUEST                       ,
    BANDERA_MECANISMO_SUBASTA_RFQREQUEST         ,
    TASA_DE_CORTE_RFQREQUEST                     ,
    CODIGO_COMITENTE_RFQREQUEST                  ,
    MONTO_A_SUBASTAR_RFQREQUEST                  ,
    FORMA_PRORRATEO_RFQREQUEST                   ,
    CUSTODIA_GARANTIA_RFQREQUEST                 ,
    SUCURSAL_CUSTODIA_RFQREQUEST                 ,
    GARANTIA_RFQREQUEST                          ,
    O_D_SUBASTA_RFQREQUEST                       ,
    RELLENO_CUSTODIA_GARANTIA_RFQREQUEST         ,
  SUBTIPO_PAPEL_RFQREQUEST                       ,
  PRECIO_PROMEDIO_POSTURAS_COMPRA_RFQREQUEST     ,
  PRECIO_PROMEDIO_POSTURAS_VENTA_RFQREQUEST      ,
  BANDERA_VIA_PROCESAMIENTO_RFQREQUEST           ,
  CON_CUPOS_RFQREQUEST                           ,
  TOTAL_POSTURA_RFQREQUEST                       ,
  BANDERA_INGRESO_PRECIO_RFQREQUEST              ,
  PRECIO_RFQREQUEST                              ,
    PRECIO_C_RFQREQUEST                          ,
  MONTO_TOTAL_RFQREQUEST                         ,
  MONTO_TRANSADO_RFQREQUEST                      ,
  TICKS_OPERACION_RFQREQUEST                     ,
  TIPO_PAPEL_RFQREQUEST                          ,
  BANDERA_PRIMERA_TRANSACCION_RFQREQUEST         ,
  BANDERA_TRASFERIR_TITULOS_RFQREQUEST           ,
  BANDERA_SIN_DETALLE_TITULOS_RFQREQUEST         ,
  BANDERA_IIF_RFQREQUEST                         ,
  BANDERA_DCV_RFQREQUEST                         ,
  BANDERA_MONTO_INGRESADO_RFQREQUEST             ,
  USUARIO_SOLICITANTE_RFQREQUEST                 ,
  BANDERA_RONDA_PARTICIPANTES_RFQREQUEST         ,
  BANDERA_BOTON_TODO_RFQREQUEST                  , 
  BANDERA_MAS_RFQREQUEST                         ,   
  BANDERA_RESULTADOS_RFQREQUEST                  ,

#endif // ndef DAPI

#ifdef GDIAPP
// Summary message SUMMRF in RF market SUMMRF
// REGISTRO demanda_oferta_global_100

DATOS_SUMMRF                                   ,
MERCADO_SUMMRF                                 ,
TIPO_MERCADO_SUMMRF                            ,
IDENTIFICADOR_MERCADO_SUMMRF                   ,
NUMERO_PAGINA_SUMMRF                           ,
DATOS_INSTRUMENTO_SUMMRF                       ,
NUMERO_INSTRUMENTO_SUMMRF                       ,    
DESCRIPCION_SUMMRF                             ,
DESCRIPCION_EXTENDIDA_SUMMRF                   ,
DESCRIPCION_ALTERNA_SUMMRF                     ,
MONEDA_SUMMRF                                   ,    
FECHA_VENCIMIENTO_SUMMRF                       ,    
FECHA_VENCIMIENTO_REAL_SUMMRF                   ,    
TASA_INTERES_SUMMRF                            ,
MONTO_OMISION_SUMMRF                           ,
PRECIO_BASE_SUMMRF                             ,
FACTOR_INCREMENTO_PRECIO_SUMMRF                ,
INCREMENTO_PRECIO_SUMMRF                       ,
TEXTOS_CONDICIONES_SUMMRF                       , 
TIPO_DESPLIEGUE_SUMMRF                           , 
TEXTO_TASA_INTERES_SUMMRF                       ,    
RELLENO_INSTRUMENTO_SUMMRF                       , 
INDICADORES_TRANSACCION_SUMMRF                 ,
LADO_SUBSIGUIENTE_SUMMRF                       ,  
MONTO_SUBSIGUIENTE_SUMMRF                      ,
RELLENO_INDICADORES_TRANSACCION_SUMMRF         ,
DATOS_DEMANDA_SUMMRF                           ,
ESTADO_DEMANDA_SUMMRF                          ,
CONDICION_DEMANDA_SUMMRF                       ,
MONTO_DEMANDA_SUMMRF                           , 
CODIGO_MEJOR_DEMANDA_SUMMRF                    ,
RELLENO_DEMANDA_SUMMRF                           , 
DATOS_OFERTA_SUMMRF                            ,
ESTADO_OFERTA_SUMMRF                           ,
CONDICION_OFERTA_SUMMRF                        ,
MONTO_OFERTA_SUMMRF                            , 
CODIGO_MEJOR_OFERTA_SUMMRF                     , 
RELLENO_OFERTA_SUMMRF                           , 
DATOS_HISTORICOS_SUMMRF                        ,
PRECIO_ULTIMA_TRANSACCION_SUMMRF               ,
PRECIO_ANTERIOR_SUMMRF                         ,
PRECIO_APERTURA_SUMMRF                         ,
PRECIO_CIERRE_SUMMRF                           ,
PRECIO_ALTO_SUMMRF                             ,
PRECIO_BAJO_SUMMRF                             ,
PRECIO_DEMANDA_SUMMRF                          ,
PRECIO_OFERTA_SUMMRF                           ,
MONTO_TOTAL_SUMMRF                             ,
RELLENO_DATOS_HISTORICOS_SUMMRF                   ,
RELLENO_SUMMRF                                  , 

DATOS_SUMMFI                                   ,
CODIGO_REGISTRO_PADRE                          , 
CODIGO_TITULO_SUMMFI                           ,
EMISOR_SUMMFI                                  ,
CODIGO_PAIS_SUMMFI                             ,
CODIGO_EMISOR_SUMMFI                           ,
REFERENCIA_SUMMFI                              ,
MONEDA_SUMMFI                                  ,
FECHA_VENCIMIENTO_SUMMFI                       ,
TIPO_PAPEL_SUMMFI                              ,
MERCADO_SUMMFI                                 , 
FRANJA_SUMMFI                                  ,
VENCIMIENTO_TEXTO_SUMMFI                       ,
SECUENCIA_SUMMFI                               ,
DIBUJO_SUMMFI                                  ,
NUMERO_DEMANDAS_OFERTAS_SUMMFI                 ,
NUMERO_POSTURAS_DEMANDA_SUMMFI                 ,
NUMERO_POSTURAS_OFERTA_SUMMFI                  ,
NIVEL_SUMMFI                                   ,
COLOR_SUMMFI                                   ,
DIAS_SUMMFI                                    ,
CODIGO_ISIN_SUMMFI                             , 
TASA_INTERES_SUMMFI                            ,
NEMOTECNICO_SUMMFI                             ,  
FECHA_VALOR_SUMMFI                             ,  
FECHA_ENTREGA_SUMMFI                           ,  
BANDERA_FISCOMP_SUMMFI                         ,  
BANDERA_TIPO_POSTURA_SUMMFI                    ,  
BANDERA_ESTADO_SUMMFI                          ,  
BANDERA_CLASE_POSTURA_SUMMFI                   , 
RELLENO_SUMMFI                                 ,

DATOS_HISTORY_IC_CO                            ,                           
DATOS_HISTORY_IC                               ,  
FECHA_HISTORY_IC                               ,
HORA_HISTORY_IC                                ,
MERCADO_HISTORY_IC                             ,
EMISOR_HISTORY_IC                              ,  
CODIGO_PAIS_HISTORY_IC                         ,
CODIGO_EMISOR_HISTORY_IC                       ,
CODIGO_TITULO_HISTORY_IC                       ,  
MONEDA_HISTORY_IC                              ,  
MONEDA_1C_HISTORY_IC                           ,  
FECHA_VENCIMIENTO_HISTORY_IC                   ,  
RENTABILIDAD_HISTORY_IC                        ,  
SOBRE_TASA_HISTORY_IC                          ,  
PRECIO_HISTORY_IC                              ,  
FECHA_EMISION_HISTORY_IC                       ,  
BANDERA_TIPO_TASA_HISTORY_IC                   ,  
MONTO_HISTORY_IC                               ,  
PLAZO_HISTORY_IC                               ,  
RANGO_PLAZO_HISTORY_IC                         ,  
CATALOGO_HISTORY_IC                            ,  
DIAS_VALOR_HISTORY_IC                          ,  
CODIGO_POSTURA_HISTORY_IC                      ,  
USUARIO_POSTURA_HISTORY_IC                     ,  
MCOD_POSTURA_HISTORY_IC                        ,  
CODIGO_POSTURA1_HISTORY_IC                     ,  
USUARIO_POSTURA1_HISTORY_IC                    ,  
MCOD_POSTURA1_HISTORY_IC                       ,  
O_D_HISTORY_IC                                 ,  
CODIGO_ISIN_HISTORY_IC                         ,  
BANDERA_REGISTRADA_HISTORY_IC                  ,          
TASA_PAPEL_HISTORY_IC                          ,    
BANCO_4C_COMPRADOROR_HISTORY_IC                ,  
USUARIO_CLIENTE_COMPRADOR_HISTORY_IC           ,  
BANCO_4C_VENDEDOR_HISTORY_IC                   ,  
USUARIO_CLIENTE_VENDEDOR_HISTORY_IC            ,  
BANDERA_BROKER_POSTURA_HISTORY_IC              ,  
BANDERA_BROKER_POSTURA_1_HISTORY_IC            ,  
BANDERA_ORIGEN_HISTORY_IC                      ,  
RENDIMIENTO_HISTORY_IC                         ,  
TIPO_PAPEL_HISTORY_IC                          ,  
FECHA_ENTREGA_HISTORY_IC                       ,  
REFERENCIA_HISTORY_IC                          ,  
VENCIMIENTO_XDIAS_HISTORY_IC                   ,  
TIPO_TASA_HISTORY_IC                           ,  
OPCION_HISTORY_IC                              ,  
FECHA_OPCION_HISTORY_IC                        ,  
NEMOTECNICO_HISTORY_IC                         ,  
NEMOTECNICO_1_HISTORY_IC                       ,  
TEXTO_TERM_HISTORY_IC                          ,  
BANDERA_MULTIUSO_HISTORY_IC                    ,  
TASA_INTERES_HISTORY_IC                        ,  
BANDERA_RMD_HISTORY_IC                         ,  
TICKS_OPERACION_HISTORY_IC                     ,  
RELLENO_HISTORY_IC                             ,  
BANDERA_VISUALIZAR_HISTORY_IC                  ,  

#endif

#ifdef DMEAPP

// CGTHistoryTransDayMem (historia_moneda_trans_dia_memoria) 
DATOS_HISTORYTRANSDAYMEM                         ,

FECHA_HISTORIA_HISTORYTRANSDAYMEM                ,
ANO_HISTORYTRANSDAYMEM                           ,
MES_HISTORYTRANSDAYMEM                           ,
DIA_HISTORYTRANSDAYMEM                           ,
MERCADO_HISTORYTRANSDAYMEM                       ,
DATOS_PRECIO_MONTO_DIA_HISTORYTRANSDAYMEM        ,
PRECIO_APERTURA_HISTORYTRANSDAYMEM               ,
PRECIO_CIERRE_HISTORYTRANSDAYMEM                 ,
PRECIO_PROMEDIO_HISTORYTRANSDAYMEM               ,
PRECIO_MINIMO_HISTORYTRANSDAYMEM                 ,
PRECIO_MAXIMO_HISTORYTRANSDAYMEM                 ,
PRECIO_PROMEDIO_CALCULOS_HISTORYTRANSDAYMEM      ,
MONTO_TOTAL_HISTORYTRANSDAYMEM                   ,
MONTO_MINIMO_HISTORYTRANSDAYMEM                  ,
MONTO_MAXIMO_HISTORYTRANSDAYMEM                  ,
MONTO_PROMEDIO_HISTORYTRANSDAYMEM                ,
NUMERO_TRANSACCIONES_HISTORYTRANSDAYMEM          ,
MONTO_ULTIMO_HISTORYTRANSDAYMEM                  ,
XDIAS_HISTORYTRANSDAYMEM                         ,
DIAS_HISTORYTRANSDAYMEM                          ,
TEXTO_TERM_HISTORYTRANSDAYMEM                    ,
HORA_ULTIMA_TRANSACCION_HISTORYTRANSDAYMEM       ,
HORA_PRIMERA_TRANSACCION_HISTORYTRANSDAYMEM      ,
CONSOLIDADO_HISTORYTRANSDAYMEM                   ,
COLOR_ULTIMA_TRANS_HISTORYTRANSDAYMEM            ,
TENDENCIA_HISTORYTRANSDAYMEM                     ,
SUB_MERCADO_HISTORYTRANSDAYMEM                   ,
DIAS_AUX_HISTORYTRANSDAYMEM                      ,
BANDERA_ESTANDAR_LIBRE_HISTORYTRANSDAYMEM        ,
RELLENO_HISTORYTRANSDAYMEM                       ,


BANDERA_BRIDGE                                   ,


DATOS_BRIDGE                                     ,
                                                  
CLAVE_BRIDGE                                     ,
MERCADO_BRIDGE                                   ,
MONEDA_BRIDGE                                    ,
PAR_MONEDAS_BRIDGE                               ,
DELIMITADOR_BRIDGE                               ,
BANDERA_ENVIO_RECEPCION_BRIDGE                   ,
SECUENCIA_BRIDGE                                 ,
BANDERA_ACTIVA_BRIDGE                            ,
BANDERA_TIPO_INFORMACION_BRIDGE                  ,
PRODUCTOR_BRIDGE                                 ,
DIRECCION_IP_BRIDGE                              ,
PUERTO_BRIDGE                                    ,
ESQUEMA_BRIDGE                                   ,
ESTADO_BRIDGE                                    ,
MENSAJES_ENVIADOS_RECIBIDOS_BRIDGE               ,
BANDERA_PRECIOS_POR_ENVIAR_BRIDGE                ,
BANDERA_FORMA_ENVIO_BRIDGE                       ,
SEGUNDOS_PARA_ENVIO_BRIDGE                       ,
CADENA_SIMBOLO_BRIDGE                            , 
NUMERO_PLAZOS_ACTIVOS_BRIDGE                     ,
BANDERA_PRECIOS_SPOT_MANUAL_BRIDGE               ,
RELLENO_BRIDGE                                   ,

// Table counter bridge
DATOS_COUNTERBRIDGE                              ,
                                                  
  MERCADO_COUNTERBRIDGE                          ,
  MONEDA_COUNTERBRIDGE                           ,
  PAR_MONEDAS_COUNTERBRIDGE                      ,
    MONEDA_1_COUNTERBRIDGE                       ,
    SEPARADOR_COUNTERBRIDGE                      ,
    MONEDA_2_COUNTERBRIDGE                       ,
  DELIMITADOR_COUNTERBRIDGE                      ,
  BANDERA_ENVIO_RECEPCION_COUNTERBRIDGE          ,
  SECUENCIA_COUNTERBRIDGE                        ,
  BANDERA_TIPO_INFORMACION_COUNTERBRIDGE         ,
  MENSAJES_ENVIADOS_RECIBIDOS_COUNTERBRIDGE      ,

// Indicatives message fields after cabeza.
CLASE_MENSAJE_INDICATIVES                        ,


// Indicatives global table data
DATOS_INDICATIVE_ICAP_INDICATIVES                ,
                                                  
DATOS_INDICATIVE_ICAP_1_INDICATIVES              ,
  MERCADO_INDICATIVES                            ,
  DATOS_BUSQUEDA_G7_INDICATIVES                  ,
    DIAS_INDICATIVES                             ,
    XDIAS_INDICATIVES                            ,
    NIVEL_INDICATIVES                            ,
    FECHA_VENCIMIENTO_INDICATIVES                ,
    TEXTO_INDICATIVES                            ,
  TEXTO_DIAS_INDICATIVES                         ,
  PRECIO_DEMANDA_INDICATIVES                     ,
  PRECIO_OFERTA_INDICATIVES                      ,
  PRECIO_MEDIO_INDICATIVES                       ,
  TENDENCIA_PRECIO_MEDIO_INDICATIVES             ,
  DATOS_INDICATIVE_ICAP_2_INDICATIVES            ,
    PRECIO_INDICATIVO_DEMANDA_INDICATIVES        ,
    PRECIO_INDICATIVO_OFERTA_INDICATIVES         ,
    BANDERA_VENCIMIENTO_INDICATIVES              ,
    ACTUALIZACION_AUTOMATICA_INDICATIVES         ,
  BANDERA_PUBLICAR_EN_MERCADO_INDICATIVES        ,
  CODIGO_POSTURA_INDICATIVES                     ,
  BANDERA_NO_PUBLICAR_PRECIO_DEMANDA_INDICATIVES ,
  BANDERA_NO_PUBLICAR_PRECIO_OFERTA_INDICATIVES  ,
  FECHA_VENCIMIENTO_XDIAS_INDICATIVES            ,
  RELLENO_INDICATIVES                            ,

// Bridge Data sent 
DATOS_DATOS_BRIDGE               ,
                               
PRODUCTOR_DATOS_BRIDGE           ,
MERCADO_DATOS_BRIDGE             ,
CADENA_SIMBOLO_DATOS_BRIDGE      ,
TEXTO_TERM_DATOS_BRIDGE          ,
PERIODO_DATOS_BRIDGE             ,
CODIGO_ICAP_DATOS_BRIDGE         ,
POINTS_LENGTH_DATOS_BRIDGE       ,
POINTS_DECIMALS_DATOS_BRIDGE     ,
FIRST_PUBLICATION_DATOS_BRIDGE   ,

VARIOS_DATOS_BRIDGE              ,
CAMBIO_DATOS_BRIDGE              ,
PRICE_DATOS_BRIDGE               ,
CLIENTE_DATOS_BRIDGE             ,
MONEDA_DATOS_BRIDGE              ,
VOLUMEN_DATOS_BRIDGE             ,
BANCO_DATOS_BRIDGE               ,

VARIOS_DATOS_BRIDGE_2            ,
CAMBIO_DATOS_BRIDGE_2            ,
PRICE_DATOS_BRIDGE_2             ,
CLIENTE_DATOS_BRIDGE_2           ,
MONEDA_DATOS_BRIDGE_2            ,
VOLUMEN_DATOS_BRIDGE_2           ,
BANCO_DATOS_BRIDGE_2             ,

VARIOS_DATOS_BRIDGE_ENVIADOS     ,
CAMBIO_DATOS_BRIDGE_ENVIADOS     ,
PRICE_DATOS_BRIDGE_ENVIADOS      ,
CLIENTE_DATOS_BRIDGE_ENVIADOS    ,
MONEDA_DATOS_BRIDGE_ENVIADOS     ,
VOLUMEN_DATOS_BRIDGE_ENVIADOS    ,
BANCO_DATOS_BRIDGE_ENVIADOS      ,

VARIOS_DATOS_BRIDGE_2_ENVIADOS   ,
CAMBIO_DATOS_BRIDGE_2_ENVIADOS   ,
PRICE_DATOS_BRIDGE_2_ENVIADOS    ,
CLIENTE_DATOS_BRIDGE_2_ENVIADOS  ,
MONEDA_DATOS_BRIDGE_2_ENVIADOS   ,
VOLUMEN_DATOS_BRIDGE_2_ENVIADOS  ,
BANCO_DATOS_BRIDGE_2_ENVIADOS    ,

INFORMACION_DATOS_BRIDGE         ,

DATOS_CONFIG_PRECIO_SPOT                         ,
                                                 
PAR_MONEDAS_CONFIG_PRECIO_SPOT                   ,
MONEDA_1_CONFIG_PRECIO_SPOT                      ,
SEPARADOR_CONFIG_PRECIO_SPOT                     ,
MONEDA_2_CONFIG_PRECIO_SPOT                      ,
CURRENCY_PAIR_CODIGO_GUIBOS_CONFIG_PRECIO_SPOT   ,
BANDERA_AUTO_PRECIO_SPOT_CONFIG_PRECIO_SPOT      ,
PRECIO_SPOT_LHS_CONFIG_PRECIO_SPOT               ,
PRECIO_SPOT_RHS_CONFIG_PRECIO_SPOT               ,

#endif

#if DMEAPP || DMDIAPP

// Bridge Message
DATOS_RBRIDGE                   ,

PRODUCTOR_RBRIDGE               ,
SIMBOLO_RBRIDGE                 ,
// when connected contains port
NUM_FLDS_RBRIDGE                ,
// When connected. contains hostname
NOMBRE_CAMPO_RBRIDGE            ,

VALOR_CAMPO_RBRIDGE             ,


// Bridge Command-Result dme-dmdi communications
DATOS_CMDBRIDGE                    ,
                                   
COMANDO_CMDBRIDGE                  ,
RESULTADO_CMDBRIDGE                ,
PRODUCTOR_CMDBRIDGE                ,
HOSTNAME_CMDBRIDGE                 ,
PORT_CMDBRIDGE                     ,
TEXT_CMDBRIDGE                     ,

#endif

#ifdef DMDIAPP
DATOS_USERLOGINBRIDGE                            ,

CODIGO_SUCURSAL_USERLOGINBRIDGE                  ,
NOMBRE_USUARIO_USERLOGINBRIDGE                   ,
CLAVE_USUARIO_USERLOGINBRIDGE                    ,
EQUIPO_USUARIO_USERLOGINBRIDGE                   ,
CODIGO_USUARIO_USERLOGINBRIDGE                   ,
CAMBIAR_CLAVE_USERLOGINBRIDGE                    ,
CONECTADO_DATASERVER_USERLOGINBRIDGE             ,
BANDERA_USERLOGINBRIDGE                          ,
SISTEMA_FECHAS_USERLOGINBRIDGE                   ,
RELLENO_USERLOGINBRIDGE                          ,
CLAVE_USUARIO_16_USERLOGINBRIDGE                 ,
FECHA_CONEXION_ANTERIOR_USERLOGINBRIDGE          ,
HORA_CONEXION_ANTERIOR_USERLOGINBRIDGE           ,
#endif

// Handover Message
//DATOS_MENSAJE_HANDOVER                          ,

// Campos propios para el mensaje handover.
DATOS_ADICIONALES_AC_SP_HANDOVER                ,
                                                 
 NUMERO_TRANSADO_ORIGINAL_HANDOVER              ,
 USUARIO_CONTRAPARTE_HANDOVER                   ,
 MONEDA_TRANSADA_ORIGINAL_HANDOVER              ,
 RELLENO_1_DATOS_A_HANDOVER                     ,
 CODIGO_BANCO_CONTRAPARTE_HANDOVER              ,
 SUCURSAL_4C_BANCO_CONTRAPARTE_HANDOVER         ,
 USUARIO_BANCO_CONTRAPARTE_HANDOVER             ,
 RELLENO_2_DATOS_A_HANDOVER                     ,

 DATOS_ESPECIALES_ACUERDO_SUGERIDO_HANDOVER     ,
  CODIGO_BANCO_MIO_SUGERIDO_HANDOVER            ,
  USUARIO_BANCO_MIO_SUGERIDO_HANDOVER           ,
  CODIGO_BANCO_OTRO_SUGERIDO_HANDOVER           ,
   INSTITUCION_BANCO_OTRO_SUGERIDO_HANDOVER     ,
   CIUDAD_BANCO_OTRO_SUGERIDO_HANDOVER          ,
   AGENCIA_BANCO_OTRO_SUGERIDO_HANDOVER         ,
  USUARIO_BANCO_OTRO_SUGERIDO_HANDOVER          ,

 DATOS_ACUERDO_SUGERIDO_HANDOVER                ,
  START_DATE_SUGERIDO_HANDOVER                  ,
  XDIAS_SUGERIDO_HANDOVER                       ,
  END_DATE_SUGERIDO_HANDOVER                    ,
  DIAS_SUGERIDO_HANDOVER                        ,
  BANDERA_ESTANDAR_LIBRE_SUGERIDO_HANDOVER      ,
  TEXTO_TERM_SUGERIDO_HANDOVER                  ,
  NIVEL_SUGERIDO_HANDOVER                       ,
  POINTS_SUGERIDO_HANDOVER                      ,
  PRECIO_SPOT_SUGERIDO_HANDOVER                 ,
  NEAR_AMOUNT_SUGERIDO_HANDOVER                 ,
  FAR_AMOUNT_SUGERIDO_HANDOVER                  ,
  MONEDA_SUGERIDO_HANDOVER                      ,
  FAR_AMONUT_CALCULADO_SUGERIDO_HANDOVER        ,
  TASA_INTERES_SUGERIDO_HANDOVER                ,
  RELLENO_SUGERIDO_HANDOVER                     ,

 DATOS_ESPECIALES_ACUERDO_ACEPTADO_HANDOVER     ,
  CODIGO_BANCO_MIO_ACEPTADO_HANDOVER            ,
  USUARIO_BANCO_MIO_ACEPTADO_HANDOVER           ,
  CODIGO_BANCO_OTRO_ACEPTADO_HANDOVER           ,
   INSTITUCION_BANCO_OTRO_ACEPTADO_HANDOVER     ,
   CIUDAD_BANCO_OTRO_ACEPTADO_HANDOVER          ,
   AGENCIA_BANCO_OTRO_ACEPTADO_HANDOVER         ,
  USUARIO_BANCO_OTRO_ACEPTADO_HANDOVER          ,

 DATOS_ACUERDO_ACEPTADO_HANDOVER                ,
  START_DATE_ACEPTADO_HANDOVER                  ,
  XDIAS_ACEPTADO_HANDOVER                       ,
  END_DATE_ACEPTADO_HANDOVER                    ,
  DIAS_ACEPTADO_HANDOVER                        ,
  BANDERA_ESTANDAR_LIBRE_ACEPTADO_HANDOVER      ,
  TEXTO_TERM_ACEPTADO_HANDOVER                  ,
  NIVEL_ACEPTADO_HANDOVER                       ,
  POINTS_ACEPTADO_HANDOVER                      ,
  PRECIO_SPOT_ACEPTADO_HANDOVER                 ,
  NEAR_AMOUNT_ACEPTADO_HANDOVER                 ,
  FAR_AMOUNT_ACEPTADO_HANDOVER                  ,
  MONEDA_ACEPTADO_HANDOVER                      ,
  FAR_AMONUT_CALCULADO_ACEPTADO_HANDOVER        ,
  TASA_INTERES_ACEPTADO_HANDOVER                ,
  RELLENO_ACEPTADO_HANDOVER                     ,

 DATOS_ACUERDO_TODAS_HANDOVER                   ,
  BANDERAS_ESPECIALES_ACUERDO_HANDOVER          ,
   BANDERA_CODIGO_BANCO_MIO_HANDOVER            ,
   BANDERA_USUARIO_BANCO_MIO_HANDOVER           ,
   BANDERA_CODIGO_BANCO_OTRO_HANDOVER           ,
   BANDERA_USUARIO_BANCO_OTRO_HANDOVER          ,
  BANDERAS_ACUERDO_HANDOVER                     ,
   BANDERA_PRECIO_SPOT_HANDOVER                 ,
   BANDERAS_ACUERDO_EXPANDIDAS_HANDOVER         ,
    BANDERA_START_DATE_HANDOVER                 ,
    BANDERA_XDIAS_HANDOVER                      ,
    BANDERA_END_DATE_HANDOVER                   ,
    BANDERA_DIAS_HANDOVER                       ,
    BANDERA_POINTS_HANDOVER                     ,
   BANDERA_NEAR_AMOUNT_HANDOVER                 ,
   BANDERA_FAR_AMOUNT_HANDOVER                  ,
   BANDERA_MONEDA_HANDOVER                      ,
   BANDERA_RELLENO_HANDOVER                     ,

 DATOS_ACUERDO_TODAS_ACEPTADO_HANDOVER          ,
  BANDERAS_ESPECIALES_ACUERDO_ACEPTADO_HANDOVER ,
   BANDERA_CODIGO_BANCO_MIO_ACEPTADO_HANDOVER   ,
   BANDERA_USUARIO_BANCO_MIO_ACEPTADO_HANDOVER  ,
   BANDERA_CODIGO_BANCO_OTRO_ACEPTADO_HANDOVER  ,
   BANDERA_USUARIO_BANCO_OTRO_ACEPTADO_HANDOVER ,
  BANDERAS_ACUERDO_ACEPTADO_HANDOVER            ,
   BANDERA_PRECIO_SPOT_ACEPTADO_HANDOVER        ,
   BANDERAS_ACUERDO_EXPANDIDAS_ACEPTADO_HANDOVER,
    BANDERA_START_DATE_ACEPTADO_HANDOVER        ,
    BANDERA_XDIAS_ACEPTADO_HANDOVER             ,
    BANDERA_END_DATE_ACEPTADO_HANDOVER          ,
    BANDERA_DIAS_ACEPTADO_HANDOVER              ,
    BANDERA_POINTS_ACEPTADO_HANDOVER            ,
   BANDERA_NEAR_AMOUNT_ACEPTADO_HANDOVER        ,
   BANDERA_FAR_AMOUNT_ACEPTADO_HANDOVER         ,
   BANDERA_MONEDA_ACEPTADO_HANDOVER             ,
   BANDERA_RELLENO_ACEPTADO_HANDOVER            ,

// estos campos van fuera de datos_mensaje
BANDERA_CAMBIA_USUARIO_POSTURA_HANDOVER         ,
BANDERA_CAMBIA_USUARIO_POSTURA_1_HANDOVER       ,
DATOS_SUCURSAL_HANDOVER_HANDOVER                ,
 CODIGO_SUCURSAL_HANDOVER_HANDOVER              ,
  CODIGO_INSTITUCION_HANDOVER_HANDOVER          ,
  CIUDAD_3C_HANDOVER_HANDOVER                   ,
  AGENCIA_HANDOVER_HANDOVER                     ,
 SUCURSAL_4C_HANDOVER_HANDOVER                  ,
 CIUDAD_HANDOVER_HANDOVER                       ,
PRIMARYUSER_HANDOVER_HANDOVER                   ,
USUARIO_HANDOVER_HANDOVER                       ,

// Tabla de persistentes generales
DATOS_GENDATA                                   ,
 ID_CODE_GENDATA                                ,
 FIRST_DATA_GENDATA                             ,
 RELLENO_GENDATA                                ,

// Chat/Charla Message
DATOS_CHAT                                     ,
BASIC_DATA_CHAT                                ,
  ID_CHAT                                      ,
  TIPO_CHAT                                    ,
  ORIGEN_CHAT                                  ,
  FECHA_MENSAJE_CHAT                           ,
  HORA_MENSAJE_CHAT                            ,
  DIEZMILESIMA_MENSAJE_CHAT                    ,
EMISOR_CHAT                                    ,
TEXTO_CHAT                                     ,
NUMERO_RECEPTORES_CHAT                         ,
TIPO_RECEPTORES_CHAT                           ,
RECEPTOR_A_CHAT                                ,
  RECEPTOR_CHAT                                ,

MAX_NUMBER_FIELDS_EQUIVALENCE
};


#endif //#ifndef __FLDDESCR_H__

///////////////////////////////////////////////////////////////////////////////
